function [decdata] = assign_to_decile(s,cutpoint,order,open_ended);
% [decdata] = assign_to_decile(dat,cutpoint,order);
%
% order==1 means decile 1==highest value
% order==-1 means decile 1==lowest value
%
% open_ended == 1 means values > highest value will be assigned decile 0, and below
% lowest could get decile 11.
% open_ended == 0 means these high and low values are collapsed to decile 1 and 10
%

% need an alg for finding closest decile when deciles are not evenly spaced
% and without these cutpoints, ie. when the decile value is the center (mean)


cutpoint = sort(cutpoint);
yet_to_assign = [1:size(s,1)]';

%[s,sortid] = sort(-1.*dat);
%[b,reverse_mapping] = sort(sortid); 

% deal with values which are lower than the lowest cutpoint
i=find(s(yet_to_assign)<cutpoint(1,1));
if ~isempty(i),
  if open_ended==1,
    decdata(yet_to_assign(i),1) = zeros(size(i,1),1);
  else
    decdata(yet_to_assign(i),1) = ones(size(i,1),1);
  end;
  yet_to_assign = setdiff(yet_to_assign,yet_to_assign(i));
end;

% middle deciles
for dec=1:size(cutpoint,1)-1,
   i=find(s(yet_to_assign)>=cutpoint(dec,1) & s(yet_to_assign)<cutpoint(dec+1,1));
   if ~isempty(i),
      decdata(yet_to_assign(i),1) = ones(size(i,1),1).*dec;
      yet_to_assign = setdiff(yet_to_assign,yet_to_assign(i));
   end;
end;

% deal with open high end
i=find(s(yet_to_assign)>=cutpoint(size(cutpoint,1),1));
if ~isempty(i),
  if open_ended==1,
    decdata(yet_to_assign(i),1) = ones(size(i,1),1).*size(cutpoint,1);
  else
    decdata(yet_to_assign(i),1) = ones(size(i,1),1).*(size(cutpoint,1)-1);
  end;
end;

if order==-1,
   decdata = size(cutpoint,1)-decdata;
end;
%key1         = key1(reverse_mapping,:);