  [newval] = general_model_optimize(testset,testsetparam,degree, ...
                                c,w,norml,kernel,width,model);


  testset = [testset testsetparam];

  [c,w,yest,modelstr] = general_model_train(trainset,traindep, ...
    degree,no_centroids,iterations,lc,norml,kernel,width,model);
  yest = general_model_eval(testset,degree,c,w,norml,kernel,width,model);

  % Visualize the model landscape (assumes the model has comps
  % one other var), and maps to theowin
  % ----------------------------------
 
  gridsize=20;labdensity=100;
  lab=[];trailpoint=[];pad_percent=0.1;
  
  general_model_plot(testset,testdep,degree, ...
                     c, w, norml, kernel, width, ...
                     model, pad_percent, trailpoint, ...
                     lab, labdensity, gridsize, ...
                     modelstr);


  % Cluster input space of model
  % ----------------------------

  [clust,clusty] = memlookup_train(testset,testdep,200);
  % its very important that we get roughly equal number of points
  % being covered by each cluster. The reason is that we want to 
  % make sure we. It'll depend on the training set, whether
  % we should worry about 
  % in each 

  % Remove any clusters which aren't covering any training points
  % -------------------------------------------------------------

  member = find_closest2(testset,clust);
  % closest centroid for each training case
  fprintf('original number of clusters %d\n',size(clust,1));
  disp('removing clusters which don''t cover any training points');
  for i=1:size(clust,1),
    cover(i,1) = size(find(member==i),1);
  end;
  i = find(cover>0);
  clust  = clust(i,:);
  clusty = clusty(i,:);
  fprintf('there are now %d clusters\n',size(clust,1));
  

% Alternative Run an optimization using nearest neighbour for each customer
% -------------------------------------------------------------

  for i=1:size(testset,1),
    [yest(i,1),id(i,:)] = k_nearest_neighbour(testset(i,:),testset,testdep,2);
  end;
  % [yest,id] =k_nearest_neighbour(testset,testset,testdep,2);
  % get the two closest entries. The first closest is itself (in the other
  % list). The second closeset is its neighbour

  opttotalwin = testdep(id(:,2),1); 
  optcomps    = testset(id(:,2),1);
  % second nearest neighbour's y value

  i=find(opttotalwin<=testdep(:,1)); 
  % find all yests which are not good
  % changes, not larger than the current testdep value

  opttotalwin(i,1) = testdep(i,1); 
  optcomps         = testset(i,1);
  % assign the old testdep value for those rows where the change
  % was poor

  % We now have a yest which has values greater than or equal to 
  % the present testdep values

% ====================  



% Optimize each kernel region, and set this as the class for that cluster
% -----------------------------------------------------------------------

% assume comps is the last column. all others must remain fixed

options = foptions;
options(1,14) = 20;

member = find_closest2(testset,clust);
% closest centroid for each training case


% For each cluster, find the optimum comps
% ----------------------------------------

z = zeros(size(totalbuyin,1),1);
theowin_minus_cost        = z;
opttheowin_minus_cost     = z;
model_theowin_minus_cost  = z;
optcomps_year2            = z;
comps_year2               = z;

for i=1:size(clust,1),

  member_of_this_cluster = find(member==i);
  if isempty(member_of_this_cluster),
    fprintf('\ncluster empty\n');
    % we should put a -9 here (but to do so, we'd have to
    % look for it at the end and filter it out)
  else

  no_in_cluster(i,1) = size(member_of_this_cluster,1);

  % find all customers who are covered by this cluster

  maxcomp(i,1) = full(max(testset(member_of_this_cluster,1)));
  mincomp(i,1) = full(min(testset(member_of_this_cluster,1)));

  % Direct Optimize, check if outside min/maxcomps in training cases
  % ---------------------------------------------------------

    warning off;
    optcomp(i,1) = fmins('win_minus_comps',clust(i,1),options, [], ...
                          clust(i,2:size(clust,2)), degree,   ...
                          c,w,norml,kernel,width,model);
    warning on;

    if optcomp(i,1)>maxcomp(i,1),
      optcomp(i,1) = maxcomp(i,1);
      disp('reached max');
    end;
    if optcomp(i,1)<mincomp(i,1),
      optcomp(i,1) = mincomp(i,1);
      disp('reached min');
    end;
    if optcomp(i,1)<0,
      optcomp(i,1)=0;
    end;

  oldwin(i,1) = win_minus_comps(clust(i,1),clust(i,2:size(clust,2)), ...
                        degree, c,w,norml,kernel,width,model);
  opttotalwin(i,1) = win_minus_comps(optcomp(i,1),clust(i,2:size(clust,2)), ...
                        degree,c,w,norml,kernel,width,model);

  if 0,
  winatmin(i,1) = win_minus_comps(mincomp(i,1),clust(i,2:size(clust,2)), ...
                        degree,c,w,norml,kernel,width,model);
  winatmax(i,1) = win_minus_comps(maxcomp(i,1),clust(i,2:size(clust,2)), ...
                        degree,c,w,norml,kernel,width,model);
  fprintf('mincomp %d maxcomp %d winatmin %d winatmax %d\n', ...
          mincomp(i,1), maxcomp(i,1), winatmin(i,1), winatmax(i,1));
  end;

  fprintf('cluster %d %d customers fall into this cluster\n',...
           i,no_in_cluster(i,1));
  fprintf('original clust comp %f new comp %f old win %d new win %d\n ', ...
          full(clust(i,1)), full(optcomp(i,1)),...
          full(oldwin(i,1)),     full(opttotalwin(i,1)));

  % All of these details are based on the model ONLY. Not reality.
  % ie. the model thinks opttotalwin will be 100 higher than totalwin
  % if we keep the comps as is. But the reality of actual optimum change
  % and actual winnings change, compared to reality, are not tested here

  % Assign cluster optima to general population
  % --------------------------------------------

  opttheowin_minus_cost(member_of_this_cluster,1) = ...
    ones(no_in_cluster(i,1),1).*opttotalwin(i,1);
  theowin_minus_cost(member_of_this_cluster,1) = -1 .* ( ... 
      sum(theowin_series(member_of_this_cluster,tedep)')' ...
    - sum(comps_series(member_of_this_cluster,tedep)')' ) ;
  model_theowin_minus_cost(member_of_this_cluster,1) = ...
    ones(no_in_cluster(i,1),1).*oldwin(i,1);

  % true theowin minus cost next year
  % optimal win next year (based on the comps we chose for this year)

  optcomps_year2(member_of_this_cluster,1) = ...
    ones(no_in_cluster(i,1),1).*optcomp(i,1);
  comps_year2(member_of_this_cluster,1) = ...
    sum(comps_series(member_of_this_cluster,te)')';

  % actual comps this year
  % optimum comps for this year

end; % if cluster is not empty
end;

% Analyse comp optimization
% -------------------------

yest = ...
  win_minus_comps(testset(:,1),testset(:,2:size(testset,2)), ...
                          degree, c,w,norml,kernel,width,model);
% we can go more accurate here, apply the model to every customer.
% However, in our optimization, we have used a cluster cetner.
% Therefore, to get a true measure of accuracy of this method, against
% actual, we need to also use the cluster center for getting
% model_theowin_minus_cost (ie. the model's ordinary result on the
% cluster center)
% compared to actual theowin_minus_cost seen next year.
% If the error is too high, it means we should make more clusters,
% (which will also drop the range on the optimization).
% How about instead of forcing to min or max of cluster, allow it 
% to optimize up or down 50% of current

disp('accuracy of model run on individual customers');
correlation(yest,theowin_minus_cost),
mean(abs(yest-theowin_minus_cost)),

disp('accuracy of cluster model');
correlation(model_theowin_minus_cost,theowin_minus_cost),
mean(abs(model_theowin_minus_cost-theowin_minus_cost)),
mean(abs(theowin_minus_cost-mean(theowin_minus_cost))),

mean(theowin_minus_cost),       
mean(opttheowin_minus_cost),
mean(optcomps_year2),
mean(comps_year2),

[l,u] = errorbars(theowin_minus_cost - model_theowin_minus_cost,0.9);

mean(opttotalwin),
mean(oldwin),
mean(optcomp),
mean(clust(i,1)),

% Plot new comps and new expected dollars by decile with error bars
% ------------------------------------------------------------------

decdata = decile1([-1.*theowin_minus_cost -1.*opttheowin_minus_cost ...
                   -1.*model_theowin_minus_cost ...
                       comps_year2 optcomps_year2 ...
                      totalcomps totalwin], ...
                  [1],5,[1 1 1 1 1 1 1]);

legend('theowin-cost','opttheowin-cost','modtheowin-cost',..
       'comps','optcomps','totalcomps','totalwin');


%
% End of comps optimization
% ====================================================================


