function count = histc_extra(x,n);
% count = histc_extra(x,n);
%
%
%
% EXAMPLE
%
% key=1;nodeciles=10;
% [decdata,decstd,cutpoint] = decile1(data,key,nodeciles,ones(1,size(data,2)));
% histc_extra(data(:,key),cutpoint);
% % should return the same numbers in all deciles
%
% % find number of customers who defected
% [decdata,decstd,cutpoint] = decile1([meanbefore meanafter],[1],nodeciles,ones(1,2));
% n1=histc_extra(meanbefore,cutpoint);figure(1);clf;bar(1:nodeciles,n1,'r');hold on;
% n2=histc_extra(meanafter,cutpoint);bar(1:nodeciles,n2,'b');
%
% note that cutpoint is a nodeciles+1 vector and is descending
% histc_extra handles that
% 

n(size(n,1)) = n(size(n,1))-eps; 
% forces it to count the last values as
% >= val

for i=1:size(n,1)-1,
   count(i,1) = size(find(x<=n(i) & x>n(i+1)),1);
end;
   