function [model1,model2,accuracy,stackweights,caseweights] = bboost(x,y,seconds);
% [model1,model2,accuracy,stackweights]=bboost(x,y,alg);
%
% no_cases=100;x=rand(no_cases,4);y = gaussianf(x(:,1),0.5)+x(:,2).^2+x(:,3).*5+5.*randn(size(x,1),1);
% tr=[1:round(no_cases./2)]';te=[round(no_cases./2)+1:no_cases]';
% [model1,model2,accuracy,stackweights] = bboost(x(tr,:),y(tr,:),360);
% [yfinal,ystack,yavg,yest] = bboost_eval(x(te,:),x(tr,:),model1,model2,accuracy,stackweights);
% figure(1);figure(2);figure(3);clf;
% subplot(2,2,1);plot(y(te,:),yfinal,'.');title(['bboost R=' num2str(rank_correlation(y(te,1),yfinal))]);
% subplot(2,2,2);plot(y(te,:),ystack,'.');title(['stack  R=' num2str(rank_correlation(y(te,1),ystack))]);
% subplot(2,2,3);plot(y(te,:),yest(:,1),'.');title(['est1 R=' num2str(rank_correlation(y(te,1),yest(:,1)))]);
% subplot(2,2,4);plot(y(te,:),yest(:,size(accuracy,2)),'.');
% title(['estn R=' num2str(rank_correlation(y(te,1),yest(:,size(accuracy,2))))]);
%
% % view average of models over time (Brieman's phenomenon that testset error continues to decrease)
% for i=1:size(accuracy,2),
%   if i==1,yavg_err(1,i)=nan;yavg_corr(1,i)=nan; else
%   yavg_err(1,i)  = mean(abs(mean(yest(:,1:i)')' - y(te,:))')';
%   yavg_corr(1,i) = rank_correlation(mean(yest(:,1:i)')',y(te,:));end;
% end;
% figure(4);clf;subplot(2,1,1);plot(1:size(accuracy,2),yavg_err);ylabel('meanabs err');title('avg of estimates');
% subplot(2,1,2);plot(1:size(accuracy,2),yavg_corr);xlabel('trial');ylabel('rankcorr');xlabel('trial');
% figure(5);clf;subplot(2,1,1);plot(1:size(accuracy,2),mean(abs(yest-y(te,:)*ones(1,size(accuracy,2)))));
% title('global meanabs error of each new estimator (should become worse)');
% subplot(2,1,2);ytemp=ranks([y(te,:) y(te,:)]);plot(1:size(accuracy,2),corrmat2(ranks(yest),ytemp(:,1)));
% ylabel('rankcorr');xlabel('trial');
% 
% 

% User adjustable
% ---------------

alpha       = 1;     % rate with which caseweights change on next classification run
bootstrap   = 1;
boost       = 0;
bootstrap_size = round(0.8.*size(x,1));
fprintf('bootstrap_size %d of %d\n',bootstrap_size,size(x,1));
if bootstrap_size<2, boostrap=0; end;
accuracy    = zeros(size(x,1),10);          % Pre-allocate accuracy table
yesttable   = zeros(size(x,1),10);

% Initialize
% ----------

t0          = clock; % Begin timer
trial       = 1; 
caseweights = ones(size(x,1),1)./size(x,1); % caseweights begin as equal
tr=[1:size(x,1)]'; % default (in case bootstrap is switched off

while (etime(clock,t0)<seconds), 
   
  % Bootstrap sample
  % ----------------
  
  if bootstrap==1,
     % select another random boostrap sample of cases
     [a,i]=sort(rand(size(x,1),1));
     tr=i(1:bootstrap_size);
  end;
  
  % Induce model
  % ------------
 
  if boost==1,
     [c,w]=spline_train(x(tr,:),y(tr,:),10,0,0,1,4,0,caseweights);
  else
     % no boosting
     [c,w]=spline_train(x(tr,:),y(tr,:),10,0,0,1,4,0);
  end;
  yesttable(:,trial) = spline_eval(x,c,w,1,4,0);
  
  % Save model and Create lookup table of case accuracies
  % ------------------------------------------------------
  
  accuracy(:,trial) = abs(yesttable(:,trial)-y);
  % note that this error is unbiased, ie. the error we would receive
  % if executing this algorithm from outside, for real. However, the 
  % model itself was induced using a skewed cost weightings, but this is
  % ignored now
  model1{trial} = c;
  model2{trial} = w;
  
  % Adjust caseweights (if boosting)
  % --------------------------------
  
  if boost==1,
    maxadjust = (accuracy(:,trial)./sum(accuracy(:,trial)));
    % maxadjust now gives us a percent of where errors are in the cases
    caseweights = caseweights + alpha.*(maxadjust - caseweights);
    % caseweights = caseweights + alpha.*maxadjust;
    % pull caseweights towards maxadjust
    caseweights = caseweights ./ sum(caseweights); 
    % guarantee that caseweights will sum to one
  end;

  % Show results
  % ------------
  
  if trial==1,
    figure(1);clf;showresults(x(:,1:2),accuracy(:,trial));
    figure(2);clf;subplot(2,1,1);plot(caseweights);drawnow;
  else
    figure(1);showresults(x(:,1:2),accuracy(:,trial));
    figure(2);subplot(2,1,2);plot(caseweights);drawnow;
  end;
  drawnow;
  trial=trial+1;
  fprintf('.');
end;

accuracy = accuracy(:,1:trial-1);
yesttable = yesttable(:,1:trial-1);
% Reset accuracy and yesttable to correct size


% Create stacking weights
% -----------------------

stackweights = yesttable \ y;

% Accuracy of aggregate model
% ---------------------------

%bboost_eval(x,y,model1,model2,accuracy);

