function [yfinal,ystack,yavg,yest] = bboost_eval(x,xtrain,model1,model2,accuracy,stackweights);

% Input parameters
% ----------------

% Execute each boosted model on the new test data
% ------------------------------------------------

fprintf('Executing boosted models (%d total)\n',size(accuracy,2));
for trial=1:size(accuracy,2),
  c = model1{trial};
  w = model2{trial};
  yest(:,trial) = spline_eval(x,c,w,1,4,0);
  fprintf('%d/%d ',trial,size(accuracy,2));
end;

% Execute stacked model
% ---------------------

if ~isempty(stackweights),
  ystack = yest*stackweights;
end;

yavg = mean(yest')';

% Use nearest neighbour model selection
% --------------------------------------
[m,best_training_estimator] = min(accuracy');
% Best estimator for each training case

% Use Nearest neighbour to find what training case the test case most looks like
% ------------------------------------------------------------------------------

yfinal = zeros(size(x,1),1);
fprintf('creating final estimate for each case\n');
o=ones(size(xtrain,1),1);
for obs=1:size(x,1),
   % find nearest neighbour
   [m,id] = min(sum(abs( o*x(obs,:) - xtrain )')');
   % id in the training set is the closest to this test example
   % Now lookup the best estimator
   yfinal(obs,:) = yest(obs,best_training_estimator(id));
   if rem(obs,1000)==0,fprintf('%d/%d ',obs,size(x,1));end;
end;

%  [t,id] = k_nearest_neighbour(x,xtrain,zeros(size(xtrain,1),2),1,missing_val);
%  yfinal = yest(:,id);
%  accuracy(:,trial) = err;
% Nearest neighbour on 

return

