function [bintarg, values] = bintargs(target, bins)

% target is a single column continuous data column
% bins is how many output bins are generated
% zeros get their own bin
% bintarg is a single column vector that maps target to bin
% values is a matrix that maps:
%	column1: bin
%	column2: threshold
%	column3: mapped value

% change bins to bits
bins = bins -1;

%thresh = [1 143 283 507 987];
% determine thresholds
% fix first threshold where target = 0
thresh = [0;1];
values = [0];

nonzeros = find(target > 0);
nonzeros  = target(nonzeros );

for i = 1:bins-1
   percent = i/bins;
   thresh = [thresh; percentile(nonzeros,percent)];
end


bintarg = ones(length(target),1);

for i = 2:length(thresh)
   hit = target >= thresh(i);
   
   if i < length(thresh)
      keep = find(target >= thresh(i) & target < thresh(i+1));
   else
      keep = find(target >= thresh(i));
   end
   keep = target(keep);

   
   bintarg = bintarg + hit;
   values = [values; mean(keep)];  
   
end

values =  [[1:bins+1]' thresh values];
