function [corr,f,matches,rankcorr,p] = corr_with_dep(var,dep,missingval)
%
% [corr,f,matches,rankcorr,p] = function corr_with_dep(var,dep,missingval)
%

crit = 1; % F stat

% remove any missing vals from dep (and var)
% ------------------------------------------

if isnan(missingval),
  present = find(~isnan(dep));
else
  present = find(dep~=missingval);
end;
dep = dep(present,1);
var = var(present,:);


% Calc relationship between each column and dep
% ---------------------------------------------

for i=1:size(var,2),
  if isnan(missingval),
    r = find(~isnan(var(:,i)));
  else
    r = find(var(:,i)~=missingval);
  end;
  matches(i,1) = size(r,1);
  if matches(i,1)>1,
    yy = var(r,i) - mean(var(r,i));
    dd = dep(r,1) - mean(dep(r,1));
    corr(i,1) = (yy'*dd) / (norm(yy)*norm(dd));
    f(i,1) = f_statf(yy,dd,1,crit,yy,dd);
    % note that we could use this to calc R and meanabs as well
    % we also want to calc p
    rankcorr(i,1) = rank_correlation(yy,dd,4); % Jon Garibaldi ranks method
    %if exists(ftest) & size(dd,1)>1, p(i,1) = ftest(yy,dd); end;
    % requires F_test_goutte to be on path
    % problem: ftest from here gives different values of f
    disp([ num2str(i) ' ' num2str(corr(i,1))]);
  else
     rankcorr(i,1) = nan;
     corr(i,1) = nan;
     f(i,1) = nan;
     p(i,1) = nan;
  end;
end;
