function [zscore,datamean,datastd] = ...
          data2zscore_missing(data,missing_val);
%
% function [zscore,datamean,datastd] = ...
%           data2zscore_missing(data,missing_val);
%
% given a set of data, this normalizes the data to 0 mean, unit
% variance columns. datamean and datastd should be retained, so that
% any results can be retransformed back from zscores into the original
% metric space representation.
%
% SEE ALSO zscore2data

zscore = ones(size(data)).*nan;
for i=1:size(data,2),
  if isnan(missing_val),
    present = find(~isnan(data(:,i)));
  else
    present = find(data(:,i)~=missing_val);
  end;
  if ~isempty(present),
    datamean(1,i) = mean(data(present,i));
    datastd(1,i)  = std(data(present,i));

    if size(present,1)>1 & datastd(1,i)~=0,
      zscore(present,i) = ( data(present,i) - ones(size(present,1),1) * ...
                            datamean(1,i) ) ./ ...
                            (ones(size(present,1),1) * datastd(1,i));
      missing = find(data(:,i)==missing_val);
      zscore(missing,i) = data(missing,i);
    else
      zscore(:,i) = zeros(size(data,1),1); %(:,i);
    end;  
  end;
end;

% datastd and datamean 
% preserved so that zscores can be transformed back into original data
