function forecast = decodebin(binforecast,values)

% decode binned targets
% binforecast is the forecasted bin
% values (output from bintargs) =
%			bin			threshold		mapped value
%          1.00             0             0
%          2.00          1.00         91.84
%          3.00        143.00        205.56
%          4.00        283.00        384.54
%          5.00        508.00        708.21
%          6.00        990.00       2324.60


bins = values(:,1);
map = values(:,3);

forecast = zeros(length(binforecast),1);
for b = 1:length(bins)
   i = bins(b);
   keep = binforecast == i;
   keep = keep * map(i);
   forecast = forecast + keep;
end
