function display_intensitymat(corr,levels,latent_class);
% display_intensitymat(corr,levels,latent_class);
%

if nargin<2, 
   levels=50;
end;
if isempty(levels),
   levels=50;
end;
if nargin<3, 
   latent_class = num2str([1:size(corr,1)]');
end;

% you could simply do a surf(corr), but the problem is negative
% values. These will be lost due to the colourmap corresponding to 
% positive ids only (I believe)

clf;
slip=1;
offset  = -1.*min(corr(:));
cmin = min(corr(:)); % (min(corr(:))+offset).*multiplier;
cmax = max(corr(:))./slip; %(max(corr(:))+offset).*multiplier;
% add back the ones on the diagonal
range = cmax-cmin;
% spread range through 1000 intensity levels
multiplier = levels ./ range;

image(round((corr+offset).*multiplier)+1);
colormap(pink(levels+1));
set(gca,'ytick',[1:size(latent_class,1)]');
set(gca,'xtick',[1:size(latent_class,1)]');
set(gca,'yticklabel',latent_class);
set(gca,'xticklabel',latent_class(:,min([2 size(latent_class,2)])));
set(gca,'fontsize',8);
cbar=colorbar;
ytick = get(cbar,'ytick');
set(cbar,'yticklabel',num2str((ytick'-1)./multiplier-offset));

