function d = distance(x,y);
%
% d = distance(x,y);
%
% x and y must be column vectors. 

if size(x,2)==1 & size(x,1)>1,
  % Stops matlab from collapsing in the sum 
  % operation (sum automatically sums vertically or horizontally 
  % if the vector is vertical or horizontal. In this case, we 
  % want matlab to keep the integrity of a single column 
  % vertical vector, and sum it to produce the row sums
  x = [x zeros(size(x,1),1)];
  y = [y zeros(size(y,1),1)];
end;

%t=clock;
d = (sum( ((x-y).^2)' )').^0.5;
%etime(clock,t),
%d,

return

% Other ways of calculating distance
% -----------------------------------

%t=clock;
d = (x-y);
d = diag(d*d') .^0.5;
%etime(clock,t),
%d,

%t=clock;
d = 0;
for i=1:size(x,2),
  d = d + (x(:,i)-y(:,i)).^2;
end;
d = d.^0.5;
%etime(clock,t),
%d,
