function dist = distmat(x,y);
% 
% dist = distmat(x,y,Mean);
%
% Formula
% 
% (x*x' - 2.* y'*x + y*y').^0.5;
%
% Derivation
%
% MeanDist(x,y) = sqrt( 1/N * (Sumi (xi-yi)^2) )
%               = sqrt( 1/N * Sumi (xi^2 - 2xiyi + yi^2))
%               = sqrt( 1/N * Sumi (xi^2) - 2 * Sumi xiyi + Sumi yi^2) 
%               = sqrt( 1/N * X X' - 2 .* X Y' + Y Y' )
% 


if nargin<3, Mean=0; end;

dist = size(y,1) * (x*x') - 2.* x*y' + size(x,1) * (y*y');

% xdown, 
% x* y' = xdown, y across

if (Mean==1), dist = dist./N; end;

dist = dist.^0.5;

