function var_contrib = dtree_calc_significance(nodeID,dtree);
%
% var_contrib = dtree_calc_significance(nodeID,dtree);
%
% EXAMPLE
% x=rand(100,2);
% [dtree,valtree,cattree] = dtree_train(x,x(:,1).^2,-9,2,20);
% var_contrib = dtree_calc_significance(1,dtree)./(dtree(1,5).*dtree(1,6))
%
%
% 

  parent_entropy = dtree(nodeID,5);
  lchild = nodeID.*2;
  rchild = nodeID.*2+1;
  
  if lchild>size(dtree,1) | rchild>size(dtree,1),
     var_contrib = zeros(1,dtree(1,2));
     return
  end;
  if dtree(lchild,1)==0 | dtree(rchild,1)==0,
     % the children underneath that parent are not filled in. Thus, the children
     % were the terminals
     var_contrib = zeros(1,dtree(1,2));
     % note that dtree(1,2) is size(x,2)
     return
  end;
  
  % Calculate entropy drop caused by performing the split underneath this parent (recorded against each child)
  % ----------------------------------------------------------------------------------------------------------
  
  lchild_entropy_drop = (parent_entropy - dtree(lchild,5)) .* dtree(lchild,6);
  rchild_entropy_drop = (parent_entropy - dtree(rchild,5)) .* dtree(rchild,6);
  % drop discounted by the percent which it occurred on
  
%  if lchild_entropy_drop<0 | rchild_entropy_drop<0, keyboard;end;
  % this drop was attributable to the variable that was split on for each of these children
  
  var_contribl = dtree_calc_significance(lchild,dtree); % will return a full var_contrib matrix size(1,size(x,2))
  var_contribr = dtree_calc_significance(rchild,dtree);
  
  var_contrib = var_contribl + var_contribr;
  var_contrib(1,dtree(lchild,2)) = var_contrib(1,dtree(lchild,2)) + ...
     lchild_entropy_drop + rchild_entropy_drop;
  
  % dimension we used to split on to result in the entropy seen at this level
  return
  