function [var_contrib,total_contrib] = dtree_calc_significance_wrapper(dtree,nodestr);
%
% var_contrib = dtree_calc_signif_wrapper(dtree);
%
% % EXAMPLE 1
% x=rand(100,2);dtree = dtree_train(x,x(:,1).^2,-9,2,20);
% var_contrib = dtree_calc_significance_wrapper(dtree),
% 
% % EXAMPLE 2: Comparison with stepwize !
% % function to fit (hidden relationship)
%   x = rand(100,4); y=x(:,1).^3 + x(:,2).^2 - x(:,3);
% % dtree (overfitting down to 1 case)
%   dtree = dtree_train(x,y,-9,2,1);
% % stepwize
%   pause off;[v,deg,varlevel] = stepwize(x,y,2,0.001,1);pause on;varlevel2=varlevel;[a,i] = sort(varlevel);
% for ii=1:size(i,2),cumvar(i(ii)) = varlevel2(i(ii));varlevel2=varlevel2-cumvar(i(ii));end;
% % we should put this in stepwize
% % display in order of dimension
%
% var_contrib = dtree_calc_significance_wrapper(dtree),
% fprintf('DTree variable contributions\n');fprintf('%d\t%5.2f%%\n',[[1:size(x,2)]' 100.*var_contrib']');
% fprintf('Stepwize variable contributions\n');
% [a,i] = sort(v);for ii=1:size(i,2),fprintf('%d^%d\t%5.2f%%\n',v(i(ii)),deg(i(ii)),100.*cumvar(i(ii)));end;

var_contrib = dtree_calc_significance(1,dtree)./dtree(1,6); %./dtree(1,6); % ./dtree(1,5)
% original variance * number of cases

%keyboard
original_entropy = dtree(1,5);

% 1   2   3            4      5                    6         7
%   dims splitmetric  avgval  variance or entropy nocases  variance or prob

% Write results to screen
% =======================

% Create header
% -------------

fprintf('\nDTree variable contributions (split metric == ');
if dtree(1,3)==2, fprintf('variance)\n');else fprintf('entropy)\n');end;
fprintf('Dim\tContrib\t');if dtree(1,3)==2, fprintf('VarianceDrop\n');else fprintf('EntropyDrop\n');end;

% Write out variance and percentage
% ----------------------------------

if nargin>1,
   % sort in order of contribution
   [a,i] = sort(-1.*var_contrib);
   for ii=1:size(var_contrib,2),
      fprintf('%s\t%3.0f%%\t%f\n',nodestr(i(ii),:), ...
         (100.*var_contrib(i(ii))./original_entropy), (var_contrib(i(ii)))');
   end;
else
   fprintf('%d\t%3.0f%%\t%f\n',[[1:size(var_contrib,2)]' ...
      (100.*var_contrib./original_entropy)' (var_contrib)' ]');
end;

% Write out total
% ---------------

  fprintf('total\t%3.0f%%\t%f (max %f)\n',100.*sum(var_contrib./dtree(1,5)),sum(var_contrib),dtree(1,5));
  fprintf('\n');

return

