function [y,prob]=dtree_traverse(x,nodeID,dtree,missing_val);

% note that this is an iterative (non-recursive) procedure
% also performs it vectorized, so should be fairly fast lookup

% current position is the left of a left-right branch. Implicitly the parent is above this

  nodeID = ones(size(x,1),1).*2;
  newcase=[1:size(x,1)]';
  % these training cases have yet to be assigned
  % newcase gives the x case row which we are going to modify
  while ~isempty(newcase),
% keyboard
    % check that we are not at the end of the tree
    outside_tree = find(nodeID(newcase)>size(dtree,1) | nodeID(newcase)>size(dtree,1));
    inside_tree  = find(nodeID(newcase)<=size(dtree,1) & nodeID(newcase)<=size(dtree,1));
    zero_node    = find(dtree(nodeID(newcase(inside_tree)),1)==0 | dtree(nodeID(newcase(inside_tree)),1)==0);
    
    % for all of those nodes which are now zero or outside, they are a terminal.
    % report the final value
    
    terminal = unique([inside_tree(zero_node);outside_tree]);
    nonterminal = setdiff([1:size(newcase,1)]',terminal);
    % these are relative to newcase
    
    if ~isempty(nonterminal),
    % move to the next node in the tree (for the non-terminal nodes)
      % find out which of these are left branches
      down=zeros(size(nonterminal,1),1);
      for d=1:size(nonterminal,1),
        down(d,1) = x(newcase(nonterminal(d)),dtree(nodeID(newcase(nonterminal(d))),2)) ...
           < dtree(nodeID(newcase(nonterminal(d))),3);
      end;
      i=find(down==1);
%     i  =  find(x(newcase(nonterminal(d)),dtree(nodeID(newcase(nonterminal(d))),2)) ...
 %                                   < dtree(nodeID(newcase(nonterminal(d))),3));
                                
      i2 =  setdiff([1:size(nonterminal,1)]',i);
      % find which of these nonterminals are right branches
      
      if ~isempty(i),  nodeID(newcase(nonterminal(i)))  = nodeID(newcase(nonterminal(i))).*2; end;
      % skip to next left node
      if ~isempty(i2), nodeID(newcase(nonterminal(i2))) = (nodeID(newcase(nonterminal(i2)))+1).*2; end;
      % skip to next right node
   end;
 
   if ~isempty(terminal),
       y(newcase(terminal),1)    = dtree(floor(nodeID(newcase(terminal))./2),4);
       prob(newcase(terminal),1) = dtree(floor(nodeID(newcase(terminal))./2),5);
       % nodeID(newcase(terminal)) = zeros(size(terminal,1),1); % the node now pointing at is zero
       newcase = setdiff(newcase,newcase(terminal)); % a candidate x which we need to find values for
    end;
    

    % ready for next loop
 end; % while
 
 % report these y values
 
 
     
if 0,    
     keyboard
    dim = dtree(nodeID(newcase),2);
    val = dtree(nodeID(newcase),3); % this is the dim<val split, to go to next left branch

    ltree = nodeID(newcase).*2;  % again, vectors
    rtree = nodeID(newcase).*2+1;
    outside_tree = find(ltree>size(dtree,1) | rtree>size(dtree,1));
    inside_tree  = find(ltree<=size(dtree,1) & rtree<=size(dtree,1));
    zero_node    = find(dtree(ltree(inside_tree),1)==0 | dtree(rtree(inside_tree),1)==0);
    % gives the ids into ltree(inside_tree(i)) which are terminals
    
    % terminals are now ltree(inside_tree(zero_node)) union ltree(outside_tree)
    
    % ltree are node values at position newcase in nodeID list
    
    terminal = unique([newcase(inside_tree(zero_node));newcase(outside_tree)]);
    nonterminal = setdiff(newcase,terminal);
    
    % for terminals, lookup their final value
    if ~isempty(terminal),
       y(terminal,1)    = dtree(nodeID(terminal),4);
       prob(terminal,1) = dtree(nodeID(terminal),5);
    end;
    
    % for nonterminals, advance them in the tree (traverse down the next branch)

%  if x(1,dim)==missing_val,
 %   % need a split_metric here
  %  if under_ltree=1,
   %   y1 = dtree_traverse(ltree,dtree,x,missing_val);
    %end;
    %if under_rtree=1, 
     % y2 = dtree_traverse(rtree,dtree,x,missing_val);
    %end;
end;