function str = dtree_write_xml(nodeID,dtree);
%
% str = dtree_write_xml(nodeID,dtree);
% 
% XSCRIPT FORMAT
% IF [Variable] THEN 
% ELSE 
% ENDIF
% 

global nodestr
global txt;

  indents = floor(log2(nodeID)).*2; % because it is a binary tree

  % left or right node?
  lbranch = 0;
  if nodeID/2 - floor(nodeID/2) > 0,  
    comparison = '>=';
    lbranch=0;
  else 
    comparison = '< ';
    lbranch=1; 
  end; 

  dim          = full(dtree(nodeID,2));
  val          = full(dtree(nodeID,3));
  pred         = full(dtree(nodeID,4));
  variance     = full(dtree(nodeID,5));
  nocases      = full(dtree(nodeID,6));
  extra        = full(dtree(nodeID,7));
  
  indentstr = char([ones(1,indents).*32]);
  
  if nodeID>1, 
    % ignore the top-level node node
    if txt==1,
      fprintf('%sif %s %s %f then %f n %d %s %f %f\t\n', ... 
        indentstr,deblank(nodestr(dim,:)),comparison,val,pred,nocases,'var',variance,extra);
    else

      if txt==0, % BNAPI syntax
        if lbranch,
           fprintf('%s<Vertex split="%s" splitScore="%f" id="%d"><Branch><Values>(-Infinity, %f)</Values>\n', ...
            indentstr,deblank(nodestr(dim,:)),variance,nodeID,val);
            % opened branch
        else
          fprintf('%s<Branch><Values>[%f, Infinity)</Values>\n',indentstr,val);
          % opened branch
        end;
      else
        % XSCRIPT syntax
        % txt==2
        if lbranch, 
          fprintf('%sIF ([%s] %s %f) THEN ', ... 
          indentstr,deblank(nodestr(dim,:)),comparison,val); % pred and \n will be decided later
        else
          fprintf('%sELSE ', ...  
          indentstr); % pred and \n will be decided later          
        end;
      end; 
    end;

%				<DecisionTree><Vertex split="RedirPower" splitScore="5483.25" id="0">
%						<Branch>
%							<Values>(-Infinity, 0.0219533)</Values>
%							<Vertex split="extrac" splitScore="2777.78" id="1">
%								<Branch>

  end;

  lchild = nodeID.*2;
  rchild = nodeID.*2+1;
  
  traverseleft  = 1;
  if lchild>size(dtree,1),
     % do not proceed to this child
     traverseleft = 0;
  else
    if dtree(lchild,1)==0, 
      traverseleft = 0;
    end;
  end;
 
  traverseright = 1;
  if rchild>size(dtree,1),
     % do not proceed to this child
     traverseright = 0;
  else
    if dtree(rchild,1)==0, 
      traverseright = 0;
    end;
  end;

  if traverseleft==0,
    if txt==0,
      fprintf('%s<Leaf><Multinomial><Probs>%f %f</Probs><Counts>%d %d</Counts><PriorCounts>1 1</PriorCounts></Multinomial></Leaf>\n', ...
        indentstr,1-pred,pred,round((1-pred).*nocases),round(pred.*nocases));
%																	<Leaf>
%																		<Multinomial>
%																			<Probs>0.991295 0.00870515</Probs>
%																			<Counts>269654 2367</Counts>
%																			<PriorCounts>1 1</PriorCounts>
%																		</Multinomial>
%																	</Leaf>
    else 
      if txt==2, % XSCRIPT syntax
        % no left traversal. This means we must terminate and drop out the value for txt3
        fprintf('$Score=ToR8(%f);$Rule=ToI4(%d);\n',pred,nodeID);
        % next could be an else
        % We already wrote out the left value
      end;
      % Don't do anything if it is regular text
    end;
  end;

  if traverseright==0,
    % We already dropped out the numbers on the left traversal (on the other branch)
    % so no need to drop out numbers again
    if txt==2,
      % no right traversal. This means we must terminate and drop out the value for txt3
%      fprintf('%f \n',pred);
      % should be an endif here
    end;
      
%    fprintf('%s<Leaf><Multinomial><Probs>%f %f</Probs><Counts>%d %d</Counts><PriorCounts>1 1</PriorCounts></Multinomial></Leaf>\n', ...
%      indentstr,pred,1-pred,pred.*nocases,(1-pred).*nocases);

  end;
      
  
  if traverseleft,  
    if txt==2,fprintf('\n');end;
    dtree_write_xml(lchild,dtree); 
  end;

  if traverseright, 
%    if txt==2,fprintf('\n');end;
    dtree_write_xml(rchild,dtree);
  end;
  
  if nodeID>1,
    if txt==0, fprintf('%s</Branch>\n',indentstr);end;
    if lbranch==0 & txt==0, fprintf('%s</Vertex>\n',indentstr);end;
    if lbranch==0 & txt==2, fprintf('%sEND IF\n',indentstr);end;
  end;