function dtree_write_xml_wrapper(dtree,nodestr1,txt1);
% 
% dtree_write_xml_wrapper(dtree,nodestr1,txt1);
% 
% txt1==1 means produce a text tree
%     ==0 means produce an xml tree
%     ==2 means produce an xscript tree
%
% (added xscript tree January 2008)
%  

global nodestr;
global txt;

if nargin<2, 
  nodestr1 = num2str(  [1:max(full(dtree(:,2)))]'  );
end;
if isempty(nodestr1), 
  nodestr1 = num2str(  [1:max(full(dtree(:,2)))]'  );
end;  
if nargin<3, 
  txt1=1;
end;

nodestr = nodestr1;
txt = txt1;


if txt==0,

  fprintf('\n\n');
  fprintf('<?xml version="1.0" standalone="yes"?><AnalysisNotebook>\n');

  fprintf('<Variables>\n');

  % Create the type variable of continuous
  fprintf('<TypeVariables><Variable name="Type0 continuous" type="continuous"><Range low="-Infinity" high="Infinity"/></Variable></TypeVariables>\n');

  % Run down all variables and make them continuous
  for i=1:size(nodestr,1),
    fprintf('		<Variable name="%s" typeVariable="Type0 continuous"></Variable>\n',deblank(nodestr(i,:)));
  end;

  % Include the target
  fprintf('    <Variable name="Conversion" type="categorical"><State index="0" name="0"/><State index="1" name="1"/></Variable>\n');
  fprintf('</Variables>\n');



  % Model properties

  fprintf('<Model name=""><ModelProperties><PropertyTypes><PropertyType name="Command" description="Command line used to learn the model" type="string"/>\n');
  fprintf('<PropertyType name="Working directory" description="Working directory when the learning algorithm was run" type="string"/><PropertyType name="Model score" description="Sum of local model scores" type="real"/><PropertyType name="Relative tree score" description="Sum of the split scores" type="real"/>\n');
  fprintf('</PropertyTypes><NodeProperties variable="Conversion">\n');
  fprintf('<Property name="Relative tree score"><PropValue>%f</PropValue></Property></NodeProperties><GeneralProperties><Property name="Command">\n',dtree(1,5));
	fprintf('<PropValue><![CDATA[c:Dnet.exe -data dt09w1.xdat -plan dt2.xplan -model dt09w1.xmod ]]></PropValue>\n');
	fprintf('</Property><Property name="Working directory"><PropValue><![CDATA[D:\\AdcenterDevPS\\target\\retail\\i386]]></PropValue></Property>\n');
	fprintf('<Property name="Model score"><PropValue>%f</PropValue></Property></GeneralProperties></ModelProperties>\n',dtree(1,5));

  % LocalModels
  
  fprintf('<LocalModels>\n');
  fprintf('<LocalModel variable="Conversion">\n');
	fprintf('<Inputs>\n');
  for i=1:size(nodestr,1),  
	  fprintf('<Input variable="%s"/>\n',deblank(nodestr(i,:)));
  end;
  fprintf('</Inputs>\n');
  
  % Decision tree

  fprintf('<DecisionTree>\n');
	  		
end;

if txt==2, 

  fprintf('\n');
  fprintf('////////////////////////////////////////////\n');
  fprintf('// MINERVA Model\n');
  fprintf('// XScript dtree code generator  \n');
  fprintf('//\n');
  fprintf('// Model identification\n');
  fprintf('// Creation date:        %s\n',datestr(now));
  fprintf('// Manual rules:         None - All rules are from auto-generated code\n');
  fprintf('// Author:               \n');
  fprintf('// Version number:       \n');
  fprintf('// Description:          \n');
  fprintf('//\n');
  fprintf('// Parameters\n');
  fprintf('// Variables:            %d\n',full(dtree(1,2)));
  fprintf('// Rules:                %d\n',size(dtree,1));
  fprintf('// Top-level Impurity:   %f\n',full(dtree(1,5)));
  fprintf('// Training cases:       %d\n',full(dtree(1,6)));
  fprintf('// Split metric:         %d\n',full(dtree(1,3)));
  fprintf('//\n');
  fprintf('// Variables\n');
  for i=1:size(nodestr1,1),
    fprintf('// %s\n',nodestr1(i,:));
  end;
  %fprintf('//\n');
  
%  if full(dtree(1,3))==1, 
%  fprintf('// Split metric:    entroyp\n',full(dtree(1,3)));
%  end;
%  if full(dtree(1,3))==2,
%  fprintf('// Split metric:    variance\n',full(dtree(1,3)));
%  end;
  %fprintf('// AvgVal:             %f\n',full(dtree(1,4)));
  %fprintf('// Variance/prob:      %f\n',full(dtree(1,7)));
  %fprintf('// Copyright Microsoft Corporation\n');
  fprintf('////////////////////////////////////////////\n');
  fprintf('//\n');
  fprintf('//\n');
  fprintf('\n');

% 1   2   3            4      5                    6         7
%   dims splitmetric  avgval  variance or entropy nocases  variance or prob
end;

dtree_write_xml(1,dtree);


if txt==0,
  fprintf('</DecisionTree></LocalModel></LocalModels></Model></AnalysisNotebook>\n');
end;

if txt==2, 
  fprintf('\n');
  fprintf('//\n');
  fprintf('//\n');
  fprintf('////////////////////////////////////////////\n');
  fprintf('// End automatically generated code\n');
  fprintf('////////////////////////////////////////////\n');
  fprintf('\n');
end;