function dtree_write_xml_wrapper2(dtree,nodestr1,txt1,savedfileName,nodestr2)
% 
% dtree_write_xml_wrapper(dtree,nodestr1,txt1);
% 
% txt1==1 means produce a text tree
%     ==0 means produce an xml tree
%     ==2 means produce an xscript tree
%     ==3 means c# version
%
% (added xscript tree January 2008)
% (added c# tree November 2008)
%  

global nodestr;
global txt;
global fid;

if nargin<2
  nodestr1 = num2str(  [1:max(full(dtree(:,2)))]'  );
end
if nargin<3 
  txt1=1;
end
%%%%% add two more extra parameters
if nargin<4, 
  savedfileName = 'tree.xmod';
end
if nargin<5
  nodestr2 = nodestr1;
end

if isempty(nodestr1),
  nodestr1 = num2str(  [1:max(full(dtree(:,2)))]'  );
end  

if isempty(nodestr2),
  nodestr2 = nodestr1;
end

nodestr = nodestr1;
txt = txt1;

% open file to write
fid = fopen(savedfileName, 'wt');

if txt==0,

  %fprintf(fid, '\n\n');
  fprintf(fid, '<?xml version="1.0" standalone="yes"?><AnalysisNotebook>\n');

  fprintf(fid, '<Variables>\n');

  % Create the type variable of continuous
  fprintf(fid, '<TypeVariables><Variable name="Type0 continuous" type="continuous"><Range low="-Infinity" high="Infinity"/></Variable></TypeVariables>\n');

  % Include the target
  fprintf(fid, '    <Variable name="Conversion" type="categorical"><State index="0" name="0"/><State index="1" name="1"/></Variable>\n');
  
  % Run down all variables from nodestr2 (for XMOD purpose) and make them continuous
  for i=1:size(nodestr2,1),
    fprintf(fid, '		<Variable name="%s" typeVariable="Type0 continuous"></Variable>\n',deblank(nodestr2(i,:)));
  end;
  
  fprintf(fid, '</Variables>\n');




  % Model properties

  fprintf(fid, '<Model name=""><ModelProperties><PropertyTypes><PropertyType name="Command" description="Command line used to learn the model" type="string"/>\n');
  fprintf(fid, '<PropertyType name="Working directory" description="Working directory when the learning algorithm was run" type="string"/><PropertyType name="Model score" description="Sum of local model scores" type="real"/><PropertyType name="Relative tree score" description="Sum of the split scores" type="real"/>\n');
  fprintf(fid, '</PropertyTypes><NodeProperties variable="Conversion">\n');
  fprintf(fid, '<Property name="Relative tree score"><PropValue>%0.16f</PropValue></Property></NodeProperties><GeneralProperties><Property name="Command">\n',dtree(1,5));
	fprintf(fid, '<PropValue><![CDATA[c:Dnet.exe -data dt09w1.xdat -plan dt2.xplan -model dt09w1.xmod ]]></PropValue>\n');
	fprintf(fid, '</Property><Property name="Working directory"><PropValue><![CDATA[D:\\AdcenterDevPS\\target\\retail\\i386]]></PropValue></Property>\n');
	fprintf(fid, '<Property name="Model score"><PropValue>%0.16f</PropValue></Property></GeneralProperties></ModelProperties>\n',dtree(1,5));

  % LocalModels
  
  fprintf(fid, '<LocalModels>\n');
  fprintf(fid, '<LocalModel variable="Conversion">\n');
	fprintf(fid, '<Inputs>\n');
  for i=1:size(nodestr2,1),  
	  fprintf(fid, '<Input variable="%s"/>\n',deblank(nodestr2(i,:)));
  end;
  fprintf(fid, '</Inputs>\n');
  
  % Decision tree

  fprintf(fid, '<DecisionTree>\n');
	  		
end;

if txt==3, 

  fprintf(fid, '\n');
  fprintf(fid, '////////////////////////////////////////////\n');
  fprintf(fid, '// MINERVA Model\n');
  fprintf(fid, '// C# dtree code generator  \n');
  fprintf(fid, '//\n');
  fprintf(fid, '// Model identification\n');
  fprintf(fid, '// Creation date:        %s\n',datestr(now));
  fprintf(fid, '// Manual rules:         None - All rules are from auto-generated code\n');
  fprintf(fid, '// Author:               \n');
  fprintf(fid, '// Version number:       \n');
  fprintf(fid, '// Description:          \n');
  fprintf(fid, '//\n');
  fprintf(fid, '// Parameters\n');
  fprintf(fid, '// Variables:            %d\n',full(dtree(1,2)));
  fprintf(fid, '// Rules:                %d\n',size(dtree,1));
  fprintf(fid, '// Top-level Impurity:   %0.16f\n',full(dtree(1,5)));
  fprintf(fid, '// Training cases:       %d\n',full(dtree(1,6)));
  fprintf(fid, '// Split metric:         %d\n',full(dtree(1,3)));
  fprintf(fid, '//\n');
  fprintf(fid, '// Variables\n');
  for i=1:size(nodestr1,1),
    fprintf(fid, '// %s\n',nodestr1(i,:));
  end;
  %fprintf(fid, '//\n');
  
%  if full(dtree(1,3))==1, 
%  fprintf(fid, '// Split metric:    entroyp\n',full(dtree(1,3)));
%  end;
%  if full(dtree(1,3))==2,
%  fprintf(fid, '// Split metric:    variance\n',full(dtree(1,3)));
%  end;
  %fprintf(fid, '// AvgVal:             %0.16f\n',full(dtree(1,4)));
  %fprintf(fid, '// Variance/prob:      %0.16f\n',full(dtree(1,7)));
  %fprintf(fid, '// Copyright Microsoft Corporation\n');
  fprintf(fid, '////////////////////////////////////////////\n');
  fprintf(fid, '//\n');
  fprintf(fid, '//\n');
  fprintf(fid, '\n');

% 1   2   3            4      5                    6         7
%   dims splitmetric  avgval  variance or entropy nocases  variance or prob
end;

if txt==4, 

  fprintf(fid, '\n');
  fprintf(fid, '--------------------------------------------\n');
  fprintf(fid, '-- MINERVA Model\n');
  fprintf(fid, '-- SQL dtree code generator  \n');
  fprintf(fid, '--\n');
  fprintf(fid, '-- Model identification\n');
  fprintf(fid, '-- Creation date:        %s\n',datestr(now));
  fprintf(fid, '-- Manual rules:         None - All rules are from auto-generated code\n');
  fprintf(fid, '-- Author:               \n');
  fprintf(fid, '-- Version number:       \n');
  fprintf(fid, '-- Description:          \n');
  fprintf(fid, '--\n');
  fprintf(fid, '-- Parameters\n');
  fprintf(fid, '-- Variables:            %d\n',full(dtree(1,2)));
  fprintf(fid, '-- Rules:                %d\n',size(dtree,1));
  fprintf(fid, '-- Top-level Impurity:   %0.16f\n',full(dtree(1,5)));
  fprintf(fid, '-- Training cases:       %d\n',full(dtree(1,6)));
  fprintf(fid, '-- Split metric:         %d\n',full(dtree(1,3)));
  fprintf(fid, '--\n');
  fprintf(fid, '-- Variables\n');
  for i=1:size(nodestr1,1),
    fprintf(fid, '-- %s\n',nodestr1(i,:));
  end;
  %fprintf(fid, '--\n');
  
%  if full(dtree(1,3))==1, 
%  fprintf(fid, '-- Split metric:    entroyp\n',full(dtree(1,3)));
%  end;
%  if full(dtree(1,3))==2,
%  fprintf(fid, '-- Split metric:    variance\n',full(dtree(1,3)));
%  end;
  %fprintf(fid, '-- AvgVal:             %0.16f\n',full(dtree(1,4)));
  %fprintf(fid, '-- Variance/prob:      %0.16f\n',full(dtree(1,7)));
  %fprintf(fid, '-- Copyright Microsoft Corporation\n');
  fprintf(fid, '--------------------------------------------\n');
  fprintf(fid, '--\n');
  fprintf(fid, '--\n');
  fprintf(fid, '\n');

% 1   2   3            4      5                    6         7
%   dims splitmetric  avgval  variance or entropy nocases  variance or prob
end;


if txt==2, 

  fprintf(fid, '\n');
  fprintf(fid, '////////////////////////////////////////////\n');
  fprintf(fid, '// MINERVA Model\n');
  fprintf(fid, '// XScript dtree code generator  \n');
  fprintf(fid, '//\n');
  fprintf(fid, '// Model identification\n');
  fprintf(fid, '// Creation date:        %s\n',datestr(now));
  fprintf(fid, '// Manual rules:         None - All rules are from auto-generated code\n');
  fprintf(fid, '// Author:               \n');
  fprintf(fid, '// Version number:       \n');
  fprintf(fid, '// Description:          \n');
  fprintf(fid, '//\n');
  fprintf(fid, '// Parameters\n');
  fprintf(fid, '// Variables:            %d\n',full(dtree(1,2)));
  fprintf(fid, '// Rules:                %d\n',size(dtree,1));
  fprintf(fid, '// Top-level Impurity:   %0.16f\n',full(dtree(1,5)));
  fprintf(fid, '// Training cases:       %d\n',full(dtree(1,6)));
  fprintf(fid, '// Split metric:         %d\n',full(dtree(1,3)));
  fprintf(fid, '//\n');
  fprintf(fid, '// Variables\n');
  for i=1:size(nodestr1,1),
    fprintf(fid, '// %s\n',nodestr1(i,:));
  end;
  %fprintf(fid, '//\n');
  
%  if full(dtree(1,3))==1, 
%  fprintf(fid, '// Split metric:    entroyp\n',full(dtree(1,3)));
%  end;
%  if full(dtree(1,3))==2,
%  fprintf(fid, '// Split metric:    variance\n',full(dtree(1,3)));
%  end;
  %fprintf(fid, '// AvgVal:             %0.16f\n',full(dtree(1,4)));
  %fprintf(fid, '// Variance/prob:      %0.16f\n',full(dtree(1,7)));
  %fprintf(fid, '// Copyright Microsoft Corporation\n');
  fprintf(fid, '////////////////////////////////////////////\n');
  fprintf(fid, '//\n');
  fprintf(fid, '//\n');
  fprintf(fid, '\n');

% 1   2   3            4      5                    6         7
%   dims splitmetric  avgval  variance or entropy nocases  variance or prob
end;


dtree_write_xml2(1,dtree);


if txt==0,
  fprintf(fid, '</DecisionTree></LocalModel></LocalModels></Model></AnalysisNotebook>\n');
end;

if txt==2 || txt==3, 
  fprintf(fid, '\n');
  fprintf(fid, '//\n');
  fprintf(fid, '//\n');
  fprintf(fid, '////////////////////////////////////////////\n');
  fprintf(fid, '// End automatically generated code\n');
  fprintf(fid, '////////////////////////////////////////////\n');
  fprintf(fid, '\n');
end;

if txt==4, 
  fprintf(fid, '\n');
  fprintf(fid, '--\n');
  fprintf(fid, '--\n');
  fprintf(fid, '--------------------------------------------\n');
  fprintf(fid, '-- End automatically generated code\n');
  fprintf(fid, '--------------------------------------------\n');
  fprintf(fid, '\n');
end;

fclose(fid);