function dout = dummyvarf(dat,nodestr);
% 
% [dout,strout] = dummyvarf(dat,nodestr);
%
% Convert categorical variable into a series of indicator 1,0 variables, where 
% 1 means == category, and 0 means not 
% 
% 

norows=size(dat,1);
nodims=size(dat,2);


dout = [];
strout = [];
maxstr = size(nodestr,2)+100;

for dim=1:nodims,
  u = unique(dat(:,dim)); % find all unique values
  novals = size(u,1);
  code = zeros(norows,novals); % initialize the dummy code
  % This will have novals across, one for each category, and norows down
  remaining = [1:norows]';
  for val=1:novals,
    if isempty(remaining), fprintf('internal error 1 detected');end;
    i=find(dat(remaining,dim)==u(val));
    code(remaining(i),val) = ones(size(i));
    remove_ids(remaining,i);
  end;
  if ~isempty(remaining), fprintf('internal error 2 detected');end;

  dout    = [dout code];
  newvars = [ones(size(u,1),1)*nodestr(dim,:) num2str(u)];
  strout = [strout;newvars(:,1:maxstr)];  
  fprintf('.');
end;

% Resize the strout
% -----------------

s=sum(double(newvars)-32);
maxlen=max(find(s~=0));  
strout = strout(:,1:maxlen);
  