function [err,yest] = exp_offset(offset,a,x,y,w);
% [err,yest] = exp_error(offset,a,x,y,w);
%
% Estimate the offset for an exponential fit, whilst keeping the slope parameter 
% unchanged. 
%
% EXAMPLE
% 
% a = fminsearch('exp_error',[0.5;0.4],[],x(:,7),y);
% yest = exp(a(2).*x).*a(1);
% 
% SEE ALSO
%
% exp_error, pow_error, gutenberg_error, adaline_error, polyfitf, 
% 

%if length(a)>2,
%  yest = exp(a(2).*x).*a(1) + a(3);
%else
  yest = exp(a.*x).*offset;
%end;

if nargin<5,
  err = norm(yest-y);
else
  err = sum(  (w .* (yest-y)).^2);
end;

  