function [truepos, falsepos, trueneg, falseneg, tot] = ...
          false_positives(forecast,actual,missing_val);
%
% [tp, fp, tn, fn, tot] = ...
%  false_positives(forecast,actual,missing_val);
%
% given forecast, returns the error matrix
% requires exactly binary choice 1 or 0
%
% display as
% [tp(i) tn(i) tp(i)+tn(i);fp(i) fn(i) fp(i)+fn(i)]
%
% does this by matching exactly, forecast=actual, forecast~=actual
% Therefore, this isn't suitable for real number comparisons
% (recode them categorically before reaching this routine)
%

for i=1:size(forecast,2),

  pres = find(forecast(:,i)~=missing_val & actual(:,i)~=missing_val);
  tot(i,1) = size(pres,1);

  truepos(i,1)=size(find(forecast(pres,i)==actual(pres,i) & ...
                         forecast(pres,i)==1),1);

  trueneg(i,1)=size(find(forecast(pres,i)==actual(pres,i) & ...
                         forecast(pres,i)==0),1);

  falsepos(i,1)=size(find(forecast(pres,i)~=actual(pres,i) & ...
                          forecast(pres,i)==1),1);

  falseneg(i,1)=size(find(forecast(pres,i)~=actual(pres,i) & ...
                          forecast(pres,i)==0),1);

end;
