function [mini,mindist] = find_closest(x,c);
%
% function mini = find_closest(x,c);
%
% given a set of centroids, c (each row is a centroid)
% and a set of inputs, x, returns a vector mini, which is a long
% vector which is the closest centroid id to each row of x.
%
% This is slower than find_closest, *however*, this can handle 
% column vectors where-as find_closest2 cannot.
% column vectors are handled by the distance.m function, 
% which itself handles column vectors

xones   = ones(size(x,1),1);
mindist = distance(xones*c(1,:),x);
mini    = ones(size(x,1),1);

for cid=2:size(c,1),
  %disp(num2str(cid));
  d = distance(xones*c(cid,:),x);
  i=find(mindist-d>0);
  mindist(i,1) = d(i,1);
  mini(i,1) = ones(size(i,1),1) * cid;
end;

