function [p,rank] = find_rank(meanx,control,missing_val); 
% [p,rank] = find_rank(x,control,missing_val); 
%
% Returns the rank of x (a one down, any across vector) in control, which is a set of numbers
% p is the percentile
% 
% r = rand(100,1);find_rank(percentile(r,0.95),r) 
% % Should return 0.95
% % percentile(r,0.95) is the number at the 95th percentile.
% % find_rank() will return the percentile of that number  

rank       = zeros(1,size(control,2));
p          = zeros(1,size(control,2));

for dim=1:size(control,2),

  % First eliminate any missing values
  vect = control(:,dim); 
  if isnan(missing_val), 
    i = find(~isnan(vect));
  else
    i = find(vect~=missing_val);
  end;
  vect = vect(i);

  % Next find the percentile rank  
  [a,i] = sort(vect);
  i1 = max(find(meanx(1,dim) > vect(i) + 0.005));if isempty(i1),i1=1; end; % Lower than all of them
  i2 = min(find(meanx(1,dim) < vect(i) - 0.005));if isempty(i2),i2=length(vect);end; % Higher than all of them
  i = mean([i1 i2]);
  if ~isempty(i), rank(1,dim) = i; else rank(1,dim) = length(vect); end;
  p(1,dim) = rank(dim) ./ length(vect);
  % We now know where the average of the current period falls in the control distribution
end;
