function [rows_with_pattern,  vars_present, ...
          candidates_for_dim, num_candidates ] = ...
   find_same_mv_pattern(  ...
   testinp, ...
   traininp, ...
   missing_val,       ...
   min_training_pool, ...
   droptabu);
                          
%function [rows_with_pattern, vars_present,       ...
%         candidates_for_dim, num_candidates ] =  ...
%         find_same_mv_pattern(testinp, traininp, ...
%                             missing_val,        ...
%                             min_training_pool);
%                          
%

%droptabu,
if nargin<5, droptabu=-1;end;
%droptabu,
row=1;
while row<=size(testinp,1),

  nonmissing_dims = find(testinp(row,:)~=missing_val);
  % find nonmissing_dims in testinp
  % testinp is the input we ultimately want the value for. 
  % Find out which dims are present.

  % Now find rows in the training pool with the same pattern of 
  % missing values. (we'll use these to induce a correct mapping)
  
  candidate_rows = [1:size(traininp,1)]';
  % initialize candidates in the training set
  
  %candidate_rows = [1:row-1 row+1:size(traininp,1)]';
  % this one skips the current test example (assuming train and test 
  % are identical

  i=0;
  redo=0; 
  % redo occurs if we can't find vars in the training pool
  % with the same pattern of missing_vars

  for dim=nonmissing_dims,
  % loop over each nonmissing column. Check the candidate set to
  % make sure its present
 
      cindex = find(traininp(candidate_rows,dim) ~= missing_val);
      candidate_rows = candidate_rows(cindex);

      % in the current candidates, keep all without a missing val
      % in the nonmissing_dims(dim) position
      % If we end up with no vars, we have to relax the inp and retry.

      % check the number of candidates (in case we're at 0)
      i=i+1;
      %candidates_for_dim(:,i) = candidate_rows;
      num_candidates(row,i) = size(cindex,1);
 
      if num_candidates(row,i)<min_training_pool,
      % oh no, NO cases in the training set match the test pattern
      % of missing values! We have to relax the exact match
      % constraint. We'll do this by finding the variable which caused the
      % most dramatic decrease in exemplars. Then remove that var
      % from the test variable. And try again.

        % find most dramatic decrease
        decrease = [-inf ...
        (num_candidates(row,1:i-1)-num_candidates(row,2:i)) ./ ...
        num_candidates(row,1:i-1)];

        [m,dropdim] = max(decrease);%dropdim=dropdim+1;
        if nonmissing_dims(dropdim)==droptabu,
           decrease(dropdim) = -inf;
           [m,dropdim] = max(decrease);%dropdim=dropdim+1;
        end;             
             
        % found the max decrease var, now drop it by mangling it
        % from the original input vector!
        testinp(row,nonmissing_dims(dropdim)) = missing_val;

        disp(['dropped input ' num2str(nonmissing_dims(dropdim))]);
        redo = 1;
        break; % wish this could be used continue;
        % breaks out of the for loop, the redo flag forces skip of
        % calculation
      end;
  end;         

  if redo==0,
     rows_with_pattern(:,row) = candidate_rows;
     vars_present(row,1) = size(candidate_rows,1);
     row=row+1;
  end % ~redo

end;

return
