function f = gaussianf(x,width)
%
% f = gaussianf(x,width)
%
% EXAMPLE
% no_centroids = 5;c=rand(no_centroids,2);points=[];for cid=1:no_centroids,t=[1:1000]';
% for dim=1:2,x(t,dim)=gaussianF(ones(size(t,1),1)*c(cid,dim),rand(1,1).*100);end;
% points=[points;x];end;
%
% width=0.2;no_centroids=5;t=[1:1000]';no_labels=100;colorid=['b';'r';'c';'k';'m';'g'];
% while 1,c=rand(no_centroids,2);points=[];id=[];figure(1);clf;hold on;figure(2);clf;hold on;
% for cid=1:no_centroids,
% x(t,1:2)=ones(size(t,1),1)*c(cid,:)+(randn(size(t,1),2)).*(ones(size(t,1),1)*[rand+0.1 rand+0.1]).*width;
% points=[points;x];id=[id;ones(size(t,1),1)*cid];figure(1);
% plot(x(t,1),x(t,2),[colorid(rem(cid,7)+1) '.'],'markersize',1);
% [a,ii]=sort(rand(size(t,1),1));r=ii(1:no_labels);figure(2);
% plot(x(t(r),1),x(t(r),2),[colorid(rem(cid,7)+1) '.'],'markersize',1);
% text(x(t(r),1),x(t(r),2),num2str(ones(size(r,1),1)*cid),'fontsize',8,'color',colorid(rem(cid,7)+1));
% end;drawnow;pause;end;
%
% fid=fopen('cluster.txt','w');for i=1:size(points,1),
% fprintf(fid,'%d\t%f\t%f\t%f\t%f\n',i,points(i,1),points(i,2),id(i,1),id(i,1));end;
% fclose(fid);
%
f = ( 1./ (width .* sqrt(2.*pi)) ) .* exp((-x.^2)./(2.*width.^2));
