function Mov = gaussiandata;
% 
% figure(1);clf;axis square;axis off;image(Mov(:,1).cdata);
% 

surface_flat = 0;
trail        = 0;
no_centroids = 5;
minwidth     = 0.02;
width        = 0.1;
resolution   = 100; % number of squares in a dimension
maxx         = 1; % max
amount_of_data = 3000;
iterations = 1;
lc = 0.2;
stopping = 0.001;

% Should make a menu with controls

% At each mesh point, call gaussianF

[x1,x2] = meshgrid(0:maxx./resolution:maxx,0:maxx./resolution:maxx);

x = [x1(:) x2(:)];

cont='n';
while cont(1,1)~='y',
f = zeros(size(x,1),1);
w = minwidth + rand(no_centroids,1).*width;
c = rand(no_centroids,2);
for i=1:no_centroids,
  %newf = zeros(size(x1));
  dist = ( sum(   ((x-ones(size(x,1),1)*c(i,:)).^2)')').^0.5;
  newf = ( 1./ (w(i,:) .* sqrt(2.*pi)) ) .* exp( - ((dist.^2)./(2.*w(i,:).^2)) );
  f = f+newf;
end;

rows = size(x1,1);
f2 = zeros(rows,rows);
for i=1:rows,
  f2(1:rows,i) = f( (i-1).*rows+1: i.*rows,1);
end;

figure(1);clf;surf(f2);shading interp;view(0,90);colormap(hot);v=axis;axis([1 resolution 1 resolution]);
axis square;axis off;
%axis off;
fprintf('Type y to finish ');cont = input('','s');
if isempty(cont), cont='n';end;
end;


% Set positions of centroids

%c1 = rand(number_of_clusters,2).*0000001; %xdata(1:number_of_clusters,:); % initialize to some datapoints
maxf               = max(f);
number_of_clusters = 0;
cont               = 'n';
figure(1);hold on;
while cont~='y',
  [newx,newy,button] = ginput(1);
  if button==1,
    fprintf('%f\t%f\n',newx,newy);
    newx = newx./resolution;
    newy = newy./resolution;
    number_of_clusters=number_of_clusters+1;
    plot3(newx.*resolution,newy.*resolution,maxf+1,'.','markersize',1);
    text(newx.*resolution,newy.*resolution,maxf+1,num2str(number_of_clusters),'color','w');
    c1(number_of_clusters,1:2) = [newx newy];
  else
    cont='y';
    if number_of_clusters==0, 
      disp('Must specify at least one cluster - point to a position on the figure and press left button\n');
      cont='n';
    end;
  end;
end;
% After we are happy we should generate data according to the function we've developed

% Note, we now have, x1,x2,f
% Now turn this into a probability density

[a,i]=sort(rand(size(f,1),1));
x = x(i,:);
f = f(i,:);
f = f./sum(f);
fcum = cumsum(f);

% Now sample x1,x2 according to the frequencies in f


xdata = zeros(amount_of_data,2);

for i=1:amount_of_data,
  r = rand;
  ii=find(r<fcum); % first entry where fcum is r or greater, ii(1) is the entry to read off
  xdata(i,:) = x(ii(1),:);
end;
ydata = zeros(amount_of_data,1);

figure(2);clf;plot(xdata(:,1),xdata(:,2),'.','markersize',3);
%keyboard
%pause;
% Give this to kmeans

figure(1);hold on;
lastc1 = c1;
j=1;

button=1;
while button==1,
cont = 'n';
while cont~='y';
  if (trail==1),
    plot3([lastc1(:,1) c1(:,1)].*(resolution),[lastc1(:,2) c1(:,2)].*(resolution),[maxf+1 maxf+1],'wx-','linewidth',3,'markersize',4);
  else 
    if surface_flat,
      figure(1);clf;[cc,hh]=contourf(f2);colorbar;shading flat;%clabel(cc,hh),colorbar;%view(0.90);
    else
      figure(1);clf;surf(f2);shading interp;view(0,90);
    end;
    colormap(hot);v=axis;axis([1 resolution 1 resolution]);
    axis square;axis off;hold on;
    plot3(c1(:,1).*(resolution),c1(:,2).*(resolution),ones(number_of_clusters,1).*(maxf+1),'.','markersize',1);
    for cid=1:number_of_clusters,
      text( c1(cid,1).*(resolution),c1(cid,2).*(resolution),maxf+1,num2str(cid),'color','w');
    end;
  end;
  
  lastc1 = c1;
  [c1,cx,cy] = kmeans_mean(xdata,number_of_clusters,iterations,ydata,c1,0,lc);
  %[c1,cx,cy] = kmeans_batch2(xdata,number_of_clusters,lc,iterations,ydata,c1);
  figure(1);drawnow;
  Mov(:,j) = getframe;
  % in manual makeframe(j,[512,320],65536); % 584 384
  % makeframe(j,[584,384],65536); % 584 384
  j=j+1;

  if mean(mean(abs(c1-lastc1)')')<stopping,
    cont='y';
  end;
  %fprintf('Press y to stop ');cont = input('','s');
  %if isempty(cont), cont='n';end;
end;

[newx,newy,button] = ginput(1);
newx = newx./resolution;newy=newy./resolution;
if (button==1), c1 = [c1;newx(1) newy(1)];lastc1 = [lastc1;newx(1) newy(1)];number_of_clusters=number_of_clusters+1;end;
end;

figure(2);hold on;plot(c1(:,1),c1(:,2),'o');
figure(3);clf;axis off;movie(Mov);
%makemovie([1:j-1],'d:\testmovie',30,1,'all');