function graph_btree_wrapper(idlist,down,across,gap);
%
% graph_btree_wrapper(idlist,down,across,gap);
%
% Graphs a binary tree, where that tree is specified by a list
% of Ids. Those ids are special. For any id, id.*2 and id.*2+1
% are the left and right children of id. This method is convenient,
% since it (a) mitiates the need to use pointers, (b) using a 
% sparse array, there is no storage cost for storing ids between
% those specified. However, there is a cost to pay for this convenient
% node id system. Since id doubles each level, id quickly becomes very
% large. Therefore, trees of only about 32 in depth can be supported,
% until id becomes too large. I'll live with this limitation, given
% that matlab doesn't support pointers (which are the only other way
% to construct trees).
% 
% INPUTS
% idlist, list of ids Do ids have to be horizontal or vertical?
% (down,across) 
% gap
% 
% EXAMPLE
% graph_btree_wrapper([1:10 15:20 30:40],1,20,.1);
% 
% SEE ALSO
% graph_btree_wrapper(idlist,down,across,gap);

%
% TODO: work out the maths to automatically adjust gap
% and across so that at bottom level we have unit with gaps
%

% remove zeros from idlist
i=find(idlist>0);
idlist=idlist(i);

% [lexpansions,rexpansions] = btree_width(idlist);
% determine the widest extreme of the tree.

% max left or right width is equal to the max depth (level) of the 
% tree. Therefore, 

% width = ceil(log2(max(idlist)));
% unit = width.*100;
% across = 1;
% gap    = (unit - across) ./ (2^(width)),

% we'll drop our width by a unit each time. For a large tree, this
% may not be good enough
% down   = 1;         % move down one unit each time
% across = 1;

figure(1);clf;
graph_btree(min(idlist),idlist,0,0,down,across,gap);
% posy = 0, posx = 0;

