function returnstruct = headerload(filename,format,delim);
% 
% s = headerload(filename,format,delim);
% 
% Reads a text file with the first row comprising the header names for each column
% The routine returns a structure, s, with fieldnames corresponding to the 
% header names. 
% 
% EXAMPLE
%
% % Create a test file
% fid=fopen('tmp.txt','w');
% fprintf(fid,'ID\tFirstName\tRevenue\tLastName\n');
% fprintf(fid,'1\tstring\t2\tstring2\n');
% fprintf(fid,'10\tstrstr\t20\tstrstr2\n');
% fclose(fid)
% 
% % Load that test file
% p = headerload('tmp.txt','%d%s%d%s','\t');
% % Will load a file with two integers separated by a tab
% p,
% % Show the contents of the structure
% 

  % Read the header
  % ---------------

  fid = fopen(filename);
  line = fgetl(fid);
  fields = regexp(line,['(?<fieldname>\w*)' delim '|(?<fieldname>\w*$)'],'names');
  % Break on delimiter to pick up the field names  
  fclose(fid);
  
    
  % Break the first line on the delimiter
  %linestr = sscanf(line,'%s\t');
  %names = [];
  %while 1, 
  %  c = fscanf(fid,'%c',1);
  %  names = [names c];
  %  if c=='\n', break; end;
  %  fprintf(c);pause;
  %end;
  
    % Read /only/ the first line
%  lines = textscan(fid, '%s','delimiter','\n');
  %fclose(fid);  
  %names = names{1}; % Only care about the first line 
  
  
  % Read the data
  % -------------
  
  fid   = fopen(filename);
  dat   = textscan(fid,format,'delimiter',delim,'headerLines',1,'treatAsEmpty',{'NA','na','#DIV/0!'});
  % Read the data
  fclose(fid);

  %[names,types,x,y,answer] = textread('mydata.dat','%s%s%f%d%s'); 
  %dat = textscan(fid,'%d%d%s%d%d%s%d%d%f%d%s%s%s%d%d','delimiter','\t','treatAsEmpty',{'NA','na','});

  clear returnstruct;  
  returnstruct=[];
%  returnstruct.nuh = [];
  for f = 1:length(fields),
    data = dat(f);
    data = data{1};
    returnstruct = setfield(returnstruct,fields(f).fieldname,data);
  end;
  
  
  
  