function c = initialize_centroids(x,c,method,iterations,changepercent);
% c = initialize_centroids(x,c,method,iterations,changepercent);
%

if nargin<4,
   iterations=10;
end;
if nargin<5,
   changepercent=-inf;
end;

c = memlookup_train(x,zeros(size(x,1),1),size(c,1));
% initialize c to random cases in the data

iteration=1;
prev_std = inf;
figure(1);clf;hold on;

for iteration=1:iterations,
   
  [yest,id] = k_nearest_neighbour(x,c,zeros(size(c,1),1),1);
  % assign each x to a cluster
  
  % count the size of each cluster
  for i=1:size(c,1),
    member = find(id==i);
    no_members(i,1) = size(member,1);
    if method==1,
       cluststd(i,1) = mean(std(x(member,:)));
    else
       cluststd(i,1) = size(member,1);
    end;
  end;
  
  if method==1,
     current_std = mean(cluststd);
  else
     current_std = std(cluststd); % standard deviation in the number of customers
     % assigned to each clust
  end;
  if iteration>1, figure(1);plot([iteration-1 iteration]',[prev_std current_std]','-');drawnow;end;
  
  % calc std drop from last iteration
  if abs(current_std - prev_std) < changepercent,
     break;
  end;
  prev_std = current_std;  
  
  % Prepare to reassign
  if member==1,
    [a,ii] = sort(cluststd); % smallest std is first
  else
    [a,ii] = sort(-1.*cluststd);
  end;
  % find cluster with smallest std (best coverage), delete it, 
  % add another cluster to the cluster with the largest std (poorest coverage)

  c(ii(size(ii,1)),:) = c(ii(1),:)+(rand(1,size(c,2))-0.5).*(cluststd(ii(1)).*0.000001);
  % one millionth of the cluster std which we are entering
  
  
  % recalc membership
end;
  
   
   