function [c,mini] = kmeans(x,number_of_clusters,lc,number_of_loops);
%
% function [c,member] = ...
%                       kmeans(x,number_of_clusters,lc,iterations);
%
% c is a set of cluster prototypes
% member is a row of clusterIDs for each input x (the cluster
% which this x belongs to)
%


  % initialize clusters to the k random vectors in the input set
  % ------------------------------------------------------------

  i = ceil(rand(number_of_clusters,1).*(size(x,1)-1));
  c = x(i,:);
  mini = ones(size(x,1),1) .* -1;
  % mini stands for minimum cluster id
  % there's also mind minimum distance
  
  for count=1:number_of_loops,
     
     disp(['iteration ' num2str(count)]);
     
  for i=1:size(x,1),
  
    % find closest centroid for this datapoint
    % ----------------------------------------

    mindist      = norm(c(1,:)-x(i,:));
    mini(i,1)    = 1;
    for cid=2:number_of_clusters,
      d = norm(c(cid,:)-x(i,:));
      if d<mindist,
        mindist = d;
        mini(i,1) = cid;
      end;
    end;
  
    % adjust that centroid
    % --------------------

    c(mini(i,1),:) = c(mini(i,1),:) + lc .* (x(i,:)-c(mini(i,1),:));

  end; % loop over all datapoints  
  end; % number_of_loops

return % return those centroids

