function [c,cx,cy,mini,no_members,cstr,cy_std_overall] = ...
         kmeans_mean_with_geo(x,number_of_clusters,number_of_loops,y,str,uscoastline,c); %,c,stopifadjustmentlessthan,lc);
%
% function [c,cx,cy,mini,no_members,cstr,cy_std_overall] = ...
%          kmeans_mean_with_geo(x,number_of_clusters,number_of_loops,y,str,uscoastline,c); %,c,stopifadjustmentlessthan,lc);
%
%
% Geographic kmeans
% 
% Performs the kmeans algorithm where centroids are calculated as the mean of the
% datapoints (xs) which are members of them. This algorithm could be better than
% kmeans_batch2 because the centroids move quicker to actual cluster centers. 
% kmeans_batch2 may also have trouble with the batch update (multiple movements
% cancel out, resulting in no movement). I should check kmeans against it to see if
% kmeans works any better.
%
% This algorithm needs to be improved by performing better centroid initialization
%
     %
     % x==lat,lon, y==vector we want to minimize the discrepancy of the
     % vector
     

  % initialize clusters to the k random vectors in the input set
  % ------------------------------------------------------------

%  if nargin>=5,
    % c were supplied, so don't overwrite
%  else
    % select random vectors from x to be cs
    % i = ceil(rand(number_of_clusters,1).*(size(x,1)-1));
    % c = x(i,:);
%    [c,cy] = memlookup_train(x,y,number_of_clusters);
%  end;

%  if nargin>=6,
%  else
    stopifadjustmentlessthan = -inf;
%  end;

%  if nargin>=7,
%  else
    lc = nan;
%  end;

  mini          = [];
  cy            = [];
  cx            = []; % these are only returned if y is supplied
  movement      = zeros(number_of_loops,1);
  disttravelled = zeros(number_of_clusters,1);
  no_members    = [];

  statestr = char(ones(size(x,1),2).*32);
  for i=1:size(x,1),
    st = deblank(str(i,:));
    statestr(i,1:2) = st(1,length(st)-1:length(st));
  end;

  % kmeans algorithm
  % ----------------

  
  %keyboard;
  
  % Randomize
  if nargin>=7, 
      % supplied externally
      number_of_clusters = size(c,1);
      % Just to make sure
      fprintf('optimizing passed in centroids\n');
  else
     [c,cy] = memlookup_train(x,y,number_of_clusters);
  end;

  cmin = c;
%  cy_mean_min = inf;
%  cy_std_min = inf;
  cy_std_overall_min = inf;
  cy_std_overall_track = [];
  cstrmin = str(1:size(c,1),:); % Not right
  
  for count=1:number_of_loops,
    %disp(num2str(count));

    cold = c;
    % adjust closest centroids
    ids_to_replace =[];

    if count==1,
      % don't re-cluster - use 
      % the first iteration to calcualte the c values
      % the c being passed in
    else
      [c,cy,member] = memlookup_train(x,y,number_of_clusters);
    end;

    % find the closest x point to each c (should have done this in
    % memlookup)
    % find the closest input to each centroid, and use that input's
    % y value for the cy for the centroid
    mininput = find_closest2(c,x);
    cx = x(mininput,:);
    cy = y(mininput,:);
    cstr = str(mininput,:);

%    figure(6);clf;bar(sort(mean(cy,2))); % actual values, mean of them 

    % find vector of closest centroids to each x
    % mini = find_closest2(x,c);
    [a,mini] = min(dist2(x,c)'); mini=mini';
    
    % Calculate purity of each cy
    for cent=1:size(c,1),
      member = find(mini==cent); % find members of the centroid
      no_members(cent,1) = size(member,1);      
      if no_members(cent,1)==0, ids_to_replace = [ids_to_replace;cent];end;
      cy_mean(cent,:) = mean(y(member,:));
      cy_std(cent,:) = mean(std(y(member,:))); % standard dev in each dimension then average
    end;

    % Calc overall purity
    cy_std_overall = sum(cy_std .* no_members./size(x,1));
    
    % Is the new purity better than old?
    if (cy_std_overall < cy_std_overall_min && length(ids_to_replace)==0) || count==1,
        cmin = c;
        cstrmin = cstr;
        cy_mean_min = cy_mean;
        cy_std_min = cy_std;  % the vector
        cy_std_overall_min = cy_std_overall;
        no_members_min = no_members;
    end;
    cy_std_overall_track(count) = cy_std_overall_min;
    
    if ~isempty(ids_to_replace),
       % find the centroids which account for the largest number of points
       [a,ii] = sort(-1.*no_members);
       c(ids_to_replace,:) = c(ii(1:size(ids_to_replace,1)),:)+0.000001.*(rand(size(ids_to_replace,1),size(c,2))-0.5);
       fprintf('reinserted %d centroids\n',size(ids_to_replace,1));
    end;


  end;

  % Finished
  % -----------------------------------------------------------------
  
  
  % Set back to the min
  % --------------------
  
  [a,i] = sortrows(-1.*cy_mean_min,1);
  % Sorted order helps to keep some semblence of clusters that can be 
  % recognized over subsequent runs
  
  c = cmin(i,:);
  cy_std = cy_std_min(i,:);
  cy_mean = cy_mean_min(i,:);
  cy_std_overall = cy_std_overall_min;
  cstr = cstrmin(i,:);
%  no_members = no_members_min;


  % select cys for each discovered cluster
  % --------------------------------------

    % find the closest input to each centroid, and use that input's
    % y value for the cy for the centroid
    mininput = find_closest2(c,x);
    cx = x(mininput,:);
    cy = y(mininput,:);

    
    % Show figures
    % ------------
  
  close all;
  figure(1);clf;plot(c(:,1),c(:,2),'x','markersize',20);hold on;plot(x(:,1),x(:,2),'r.');
  hold on;voronoi(c(:,1),c(:,2))
  
  [xi,yi] = meshgrid(min(x(:,1)):0.5:max(x(:,1)),min(x(:,2)):0.5:max(x(:,2)));zi=griddata(x(:,1),x(:,2),y,xi,yi,'cubic');figure(2);clf;mesh(xi,yi,zi);
  figure(2);hold on;stem3(c(:,1),c(:,2),ones(size(c,1),1)*max(y(:,1)),'x','markersize',20);%hold on;plot(x(:,1),x(:,2),'r.');
  
  figure(3);clf;showresults(x,y,3)
  
  figure(4);clf;plot(cy_std_overall_track)

  % c is now cmin  

  %  close all
  figure(5);clf;hold on;
  figure(6);clf;hold on;
  figure(7);clf;hold on;
  symstr = ['x';'o';'s';'d';'+';'p';'h';'*';'v';'^';'<';'>'];
  colstr = ['b';'g';'r';'c';'m';'k';'b';'g';'r';'c';'m';'k'];
  if size(c,1)>length(symstr), 
     symstr(length(symstr)+1:size(c,1),1) = ones(size(c,1)-length(symstr),1)*'x';
     colstr(length(colstr)+1:size(c,1),1) = ones(size(c,1)-length(colstr),1)*'b';
  end;
 
  s=0;
  
  [a,mini] = min(dist2(x,c)'); mini=mini';
    
    % Calculate purity of each cy
    for cent=1:size(c,1),
      member = find(mini==cent); % find members of the centroid
      no_members(cent,1) = size(member,1);      
      if no_members(cent,1)==0, ids_to_replace = [ids_to_replace;cent];end;
      cy_mean(cent,:) = mean(y(member,:));
      cy_std(cent,:) = mean(std(y(member,:))); % standard dev in each dimension then average
      
      figure(5);text(c(cent,1),s+c(cent,2),num2str(cent),'fontsize',20,'color',colstr(cent));
      plot(x(member,1),s+x(member,2),[colstr(cent) symstr(cent)]);
      
%      figure(6);plot(c(cent,1),s+c(cent,2),symstr(cent),'markersize',20);
      figure(6);text(c(cent,1),s+c(cent,2),num2str(cent),'fontsize',20,'color',colstr(cent));
%      plot(x(member,1),s+x(member,2),['r' symstr(cent)]);

% plot 
for i=1:1:length(member), %size(x,1),
    st = deblank(str(member(i),:));
    st = st(1,length(st)-1:length(st));
    text(x(member(i),1),s+x(member(i),2),st,'color',colstr(cent));
end;

      figure(7);
      text(c(cent,1),s+c(cent,2),num2str(cent),'fontsize',20);%,'color',colstr(cent));%,'fontcolor',colstr(cent)); %symstr(cent),'markersize',20);
      done = sparse(max(statestr(:,1)),max(statestr(:,2)));
      for i=1:length(member),
        if done(statestr(member(i),1),statestr(member(i),2))==1, 
           text(x(member(i),1),s+x(member(i),2),num2str(cent),'color',colstr(cent));%,'fontcolor',colstr(cent));%['r' symstr(cent)]);
           % put the number in here
        else
            % put the state name in 
          text(x(member(i),1),s+x(member(i),2),statestr(member(i),:),'color',colstr(cent));
          done(statestr(member(i),1),statestr(member(i),2))=1;
        end;
        %plot(x(member(i),1),s+x(member(i),2),'.');%['r' symstr(cent)]);
      end;
clear done;
%for i=1:size(c,1),
%    st = deblank(cstr(i,:));
%    st = st(1,length(st)-1:length(st));
%    text(cx(i,1),s+cx(i,2),st,'color',colstr(member(i)));
%end;

      
end;
figure(5);
%hold on;voronoi(c(:,1),s+c(:,2));
%for i=1:20:size(x,1),text(x(i,1),s+x(i,2),str(i,:));end;
plot(uscoastline(:,1),uscoastline(:,2),'-');

figure(6);hold on;voronoi(c(:,1),s+c(:,2));
plot(uscoastline(:,1),uscoastline(:,2),'-');

figure(7);hold on;voronoi(c(:,1),s+c(:,2));
% for i=1:5:size(x,1),
%     st = deblank(str(i,:));
%     st = st(1,length(st)-1:length(st));
%     text(x(i,1),s+x(i,2),st);
% end;
plot(uscoastline(:,1),uscoastline(:,2),'-');

[a,i] = sort(mean(cy_mean,2));
figure(8);clf;bar(a); % actual values, mean of them 
set(gca,'xticklabel',num2str(i));
title('Cluster mean yval');

figure(9);clf;subplot(2,1,1);bar(mean(cy_mean,2));ylabel('y mean');
title('Cluster yval mean and purity');
hold on;subplot(2,1,2);bar(mean(cy_std,2),'r');ylabel('y std');

figure(10);clf;errorbar([1:size(c,1)]',mean(cy_mean,2),mean(cy_std,2),'s');ylabel('y mean');
%title('Cluster yval mean and purity');
%hold on;subplot(2,1,2);bar(mean(cy_std,2),'r');ylabel('y std');



%keyboard;

% Typical impurity
% Actual impurity

figure(11);clf;bar([1 2],[cy_std_overall_track(1) cy_std_overall_min]);legend('starting cystd','ending cystd');


%figure(10);clf;bar(sort(mean(cy,2))); % actual values, mean of them 
%set(gca,'xticklabel',cstr);



fprintf('Cluster Statistics:\n\n');
fprintf('Cluster\tGeoX1\tGeoX2\tNumber of members\tpercent membership\tYStdevOfMembers\tYMeanOfMembers\tNearestGeoX1\tNearestGeoX2\tCentroidDMAStr\tNearestGeoY\n');
for i=1:number_of_clusters,
  no_members(i,1) = size(find(mini==i),1);
  fprintf('%d\t%6.3f\t%6.3f\t%d\t%6.3f\t%f\t%f\t%f\t%f\t%s\t%6.3f\n',i,c(i,1),c(i,2),no_members(i,1),100.*no_members(i,1)./size(x,1),cy_std(i,1),cy_mean(i,1),cx(i,1),cx(i,2),cstr(i,:),cy(i,:));
end;
fprintf('Starting impurity (mean stdev) %f\n',cy_std_overall_track(1));
fprintf('Overall impurity (mean stdev) %f\n',cy_std_overall_min);
fprintf('Percent reduction in impurity %f\n',100.*(cy_std_overall_min./cy_std_overall_track(1)-1));


%     fprintf('look for clusters which had low movement, and have few members, these were probably ');
%     fprintf('stranded\n');
%     figure(1);clf;plot(movement);xlabel('iteration');ylabel('max avg dimensional adjustment');

        
%  figure(5);clf;plot(c(:,1),c(:,2),'x','markersize',20);hold on;plot(x(:,1),x(:,2),'r.');
%  hold on;voronoi(c(:,1),c(:,2))

  
    % Used to be this
    %for cent=1:size(c,1),

      % Used to be this
      %member = find(mini==cent); % find members of the centroid
      %c(cent,:) = mean(x(member,:)); % find the new lat-lon
      %if ~isnan(lc),
      %  c(cent,:) = cold(cent,:) + lc .* (c(cent,:) - cold(cent,:));
      %end;
      
      % Pick a new location
      
      % Calculate new purity
      
      %no_members(cent,1) = size(member,1);
      %if no_members(cent,1)==0, ids_to_replace = [ids_to_replace;cent];end;
    %end;
      
    
    %disttravelled = disttravelled + distance(c,cold);
    %movement(count,1) = mean(mean(abs(c-cold)));
    %fprintf('%d(%f) ',count,movement(count));
    %if movement(count)<stopifadjustmentlessthan, count=number_of_loops+1;end;
%  end; % iterations



%   if nargout>=6,
%     fprintf('Cluster Statistics:\n\n');
%     fprintf('Cluster\tNumber of members\tpercent membership\tDistance travelled\n');
%     for i=1:number_of_clusters,
%       no_members(i,1) = size(find(mini==i),1);
%       fprintf('%d\t%d\t%6.3f\t%f\n',i,no_members(i,1),100.*no_members(i,1)./size(x,1),disttravelled(i,1));
%     end;
%     fprintf('look for clusters which had low movement, and have few members, these were probably ');
%     fprintf('stranded\n');
%     figure(1);clf;plot(movement);xlabel('iteration');ylabel('max avg dimensional adjustment');
%   end;


return
