function [err,yest] = exp_offset(offset,a,x,y,w);
% [err,yest] = linear_error(offset,a,x,y,w);
%
% Estimate the offset for a linear fit, whilst keeping the slope parameter 
% unchanged. 
%
% SEE ALSO
%
% exp_offset, exp_error, pow_error, gutenberg_error, adaline_error, polyfitf, 
% 

%if length(a)>2,
%  yest = exp(a(2).*x).*a(1) + a(3);
%else
  yest = clicks_function([offset a.*offset],x,1,x,0,inf);
%end;

if nargin<5,
  err = norm(yest-y);
else
  err = sum(  (w .* (yest-y)).^2);
end;

  