function [err,y] = lshape_eval(w,x,ytarget,caseweights);
% [err,y] = lshape_eval(w,x,ytarget,caseweights);
%
% for the time being this is a 1 dimensional function

if nargin<2, 
  fprintf('need x\n');
  return;
end;

w = w';
% w is a vertical vector

if nargin<3, 
  ytarget=[];
  caseweights=[];
end;
if nargin<4,
  caseweights=ones(size(x,1),1);
end;
if isempty(caseweights),
  caseweights=ones(size(x,1),1);
end;
if size(ytarget,2)>1 & size(ytarget,1)>1,
  fprintf('there are %d dimensions in the y variable\n',size(ytarget,2));
  fprintf('multidimensional target variables should be treated \n');
  fprintf('as a series of one dimensional targets, using the same\n');
  fprintf('x variable set for each. The gradients, etc, are all \n');
  fprintf('separate also\n');
  return
end;
if (size(w,2)==size(x,2) & size(w,1)==size(ytarget,2)),
  %disp 'here';
  %w=w';
end; 
if (size(ytarget,2)>1 & size(ytarget,1)==1) | ...
   ...  (size(w,2)>1 & size(w,1)==1) | ...
   (size(caseweights,2)>1 & size(caseweights,1)==1),
  fprintf('ytarget is size %d %d\n',size(ytarget,1),size(ytarget,2));
  fprintf('w is size %d %d\n',size(w,1),size(w,2));
  fprintf('caseweights are size %d %d\n',size(caseweights,1),size(caseweights,2));
  fprintf('x is %d %d\n',size(x,1),size(x,2));
  fprintf('ytarget should be a vertical vector\n');
  fprintf('w should be a vertical vector\n');
  fprintf('x should have observations down, dimensions across\n');
  fprintf('caseweights should be a vertical vector for each x observation\n');
  return
end;

  % Use w(length(w)) to decide at which point the data is flat
  % w(length(w)) is the x-intercept beyond which the function remains constant at that y level
 
  i = find(x<w(3)); % ids which are covered by the sloping part
  j = find(x>=w(3)); % ids which are covered by the flat part 

  % evaluate the sloping part at w(length(w))
  yflat = w(3) .* w(2) + w(1);
  % w(3) is the position of x

  y = ones(size(x,1),1).*nan;        % initialize, if it returns a nan you'll know that something failed
  
  y(i) = x(i) .* w(2) + w(1);       % evaluate first piece of model  
  y(j) = yflat .* ones(length(j),1); % This is the second piece, starting from an x-intercept of w(length(w))

  if ~isempty(ytarget),  
    actual_minus_target = ((y - ytarget) .* caseweights)*ones(1,size(x,2));

    % y is the model estimate (actual), ytarget is the desired
    % actual-desired is the direction that the result has to move in
    % (eg. pos or negative)

    err = sum(actual_minus_target(:,1).^2);   
  else
    err = [];
  end;
  
  
  
  
    