function [meanx,count] = mean_weighted(x,caseweights,missing_val);
% [meanx,count] = mean_weighted(x,caseweights,missing_val);
%
% Mean is always over the vertical column
% 

caseweights = caseweights ./ sum(caseweights);

if isnan(missing_val),
   i=find(isnan(x(:)));
else
   i=find(x==missing_val);
end;

if nargout>1,
  present = ones(size(x));
  present(i) = zeros(size(i)); % zero out missing values
  if size(x,1)==1, 
    count = present;
  else 
    count = sum(present); % sum up the results into column. This is the number present in each dimension
  end;
  clear present;
end;

x(i) = zeros(size(i,1),1);

if size(x,1)==1,
  meanx = x;
else
  meanx=sum(x.*caseweights,1);
end;


