function [c,cy,member] = memlookup_train(x,y,number_of_clusters);
%
% function [c,cy,member] = memlookup_train(x,y,number_in_codebook);
%
% EXAMPLE
%
% x = rand(1000,3); y=rand(1000,1);
% [c,cy] = memlookup_train(x,y,2000);
% yest = knn(x,c,cy,1); % pure k-nearest neighbour memory lookup
% yest = knn(x,c,cy,2); % linear combination of codebook vectors
%

% this isn't very efficient, but doesn't result in any duplicates

r=rand(size(x,1),1);
[a,i] = sort(r);
c = x(i(1:number_of_clusters,1),:);
cy = y(i(1:number_of_clusters,1),:);

if 0,
% assign memory vectors to random elements of the training set, x
i = ceil(rand(number_of_clusters,1).*size(x,1) );
c = x(i,:);
cy = y(i,:);

[c,i] = unique(c,'rows');
cy = cy(i,:);
% may be a matlab5 command, if we take out, we just get some
% duplicates, which may not really matter
end;

if nargout==3,
  member = find_closest2(x,c);
else
  member=[];
end;

