function err = mlp_error(ww,x,y,no_hidden_units);
%
% function err = mlp_error(ww,x,y,no_hidden_units,no_output_units);
% 
% example
% err = mlp_error([whid wout],x,y,size(whid,2),size(wout,2));
%

  whid = ww(1:size(x,2),:);
  wout = ww(size(x,2)+1:size(x,2)+size(y,2),:)';
  yest = (sigmoid(x * whid)) * wout;

  err = sum(distance(y,yest));
  % sum squared error
  % this might be the same as norm(y-yest)

  disp(['error ' num2str(err)]);
