function [meanabs,meanerr,totabs,toterr]=percent_error(a,b);
% [meanabs,meanerr,totabs,toterr]=percent_error(a,b);
%
% This function gives percent error for two series a and b
%
% a has timeseries going across. There could be several timeseries
% meanabs is a vertical vector with average absolute error for each timeseries
% totalabs is a single number which is the average meanabs
%

a=a';
b=b';

for ii=1:size(a,2),
  i=find(a(:,ii)~=0);
  if ~isempty(i),
    meanerr(1,ii) = mean((a(i,ii)-b(i,ii))./a(i,ii)); 
    meanabs(1,ii) = mean(abs(a(i,ii)-b(i,ii)) ./ abs(a(i,ii)));
    % find the cases where a is 0 and we forecasted 0, or forecasted 1
  else
    meanerr(1,ii) = 0;
    meanabs(1,ii) = 0; 
  end;  
end;
i=find(~isnan(meanabs));
totabs = mean(meanabs(i));
i=find(~isnan(meanerr));
toterr = mean(meanerr(i));
return;