function out = percentile(in,percent)
% 
% out = percentile(in,percent)
% 
% in is a row or column vector
% percent is the percentile between 0 and 1 or 1 and 100
%

% check percent range and set to 0/1
i = find(percent > 1);if ~isempty(percent),percent(i) = percent(i)./100;end;

rows = size(in,1);

if isempty(in),
  out=[];
  return;
end;

out = nan.*ones(length(percent),size(in,2));
for pid=1:length(percent),

  if percent(pid) == .5
    % use median if that's what's asked for. It is more accurate.
     out(pid,:) = median(in,1); % Note we've now changed everything to be directional
  else
     n = rows;
     x = sort(in,1);
     row = round(percent(pid).*n);
     if row>rows, row=rows; end;
     if row>=1 & row<=rows,	
       out(pid,:) = x(row,:);
     else
       out(pid,:) = x(1,:);
     end;
  end; % next pid
end;