function plot_with_error_region(times2,medint,upperint,lowerint,figno,color);
% 
% plot_with_error_region(xval,yval,yupper,ylower,figno);
% 
% Plots a y versus x curve, but fills in the uncertainty region in yellow.
% The uncertainty region is given by an upper y bound and a lower y bound estimate
% for each of the xval,yval pairs.
% 

if nargin<6,
  color='y';
end;

  figure(figno);hold on;
  for i=1:length(times2),

    % Figure out what the left hand side of this error sub-region will be
    % This will be the leftmost point from which this error region will 
    % be in effect. We assume this will be half way from the present 
    % binx value, to the binx value at the left
    % cent, the left hand size of the x range
    if i>1,  
      cent = (times2(i-1)+times2(i))./2;
    else
      cent = times2(i);
    end;
  
    if i<length(times2), 
      cent2 = (times2(i+1)+times2(i))./2;
    else
      cent2 = times2(i);
    end;
  
    hh = fill([cent cent cent2 cent2], ...
              [upperint(i) lowerint(i) lowerint(i) upperint(i)],color);
    set(hh,'EdgeColor',color);
  end;
  hh2=plot(times2,medint,'r-');
  %legend([hh hh2],{'uncertainty region','median'});

return;
