function z1 = polyf(c,degree,x)
% z=polyf(c,degree,x)
%
% evaluate polynomial c at point x
% c is the coefficient,
% x is a set of points, x1 x2 x3..

% x is a vector of points (x1,x2,x3) for evaluation to give y
% c is the coefficients of the polynomial constructed by polyc.m
% this polynomial is a smooth fit to 

% description: 
% c matrix 
% c = x11 x21 x12 x22
% needs to be split up into a separate matrix for each x set. 
% (eg. xset = x11 x21
%             x12 x22
%             ... ...

pause off
echo off

for col=1:size(c,2),

dims=size(x,2);
xset=zeros((degree+1),dims); % +1 long to get a zero for the c entry
pause
for i=1:dims; % first dim positions.
  p=0;
  for i2=i:dims:degree*dims;  % step visit other deg positions
    p=p+1;
    xset(p,i)=c(i2,col);
pause
  end;
end;

% the polyval for each xset is calculated one at a time and summed.

z=0;
for i=1:dims;
  z=z+polyval(xset(:,i),x(1,i)); % note: xset initialised with a zero for c 
end;
pause
z=z+c(length(c)); % (add the constant)

z1(1,col) = z;
end;
pause on

% CHECK THE C IS the right way. ie. x^5 x^4 etc
% test on simple problem
