function z = show_splines(spline_method,norml);
%
% function z = show_splines(spline_method,norml);
%
% this function is used internally by spline_train and
% spline_eval. A list of spline kernels is given below:
%
%   0: GAUSSIAN:
%      return (exp( -1* ((r*r)/(width)) ));
%   1: MULTI_QUADRATIC:
%      return ( sqrt(width + r*r) );
%   2: LINEAR:
%      return (1+r);
%   3: CUBIC:
%      return (1+r*r*r);
%   4: THIN_PLATE:
%      return (r*r*log(r));
%
  
if spline_method==0,
  disp('gaussian');
end;
if spline_method==1,
  disp('multiquadratic');
end;
if spline_method==2,
  disp('linear');
end;
if spline_method==3,
  disp('cubic');
end;
if spline_method==4,
  disp('thin_plate');
  if norml==1,
    disp('warning: normalization may not work for thin plate splines');
  end;
end;

z=[];return
