function activ = spline_train(x,c, ...
                              norml,spline_method,width);
%
% function activ = spline_train(x,c, ...
%                               norml,kernel,width);
%
% given x, and centroids c, calculates x in c coordinates, that is,
% creates a new vector which is distance between x and each centroid.
% 

  number_of_centroids = size(c,1);

%  disp('converting x to centroid coordinates');
  activ = zeros(size(x,1),number_of_centroids);

  for cid=1:number_of_centroids,
%    disp(num2str(cid));
    activ(:,cid) = distance(x,ones(size(x,1),1) * c(cid,:));

      if spline_method==0, % gaussian
         activ(:,cid) = exp( -1 .* activ(:,cid).^2 ./ width);
      end;
      if spline_method==1, % multi_quadratic
         spline_method==2;
      end;
      if spline_method==2, % linear
         activ(:,cid) = 1+activ(:,cid);
      end;
      if spline_method==3, % cubic
         activ(:,cid) = 1+activ(:,cid).^3;
      end;
      if spline_method==4, % thin_plate
         activ(:,cid) = activ(:,cid).^2.*log(activ(:,cid)+1);
      end;
   end;

   if norml==1,
%       disp('normalizing activations'); 
       total_activ = sum(activ')';
       activ = activ ./ (total_activ * ones(1,number_of_centroids));
   end;

   
return

