function statsummary(dif,varstr,color,showgraphs);

color='b';
if nargin<2,
  varstr = '';
end;
if nargin<3,
  color='b';
end;
if nargin<4,
  showgraphs=1;
end;


 warning off;
 fprintf('Summary statistics for %s\n',varstr);
 fprintf('Mean            %f\n',mean(dif));
 %fprintf('Geometric Mean  %f\n',geomean(dif));
 %fprintf('Harmonic Mean   %f\n',harmmean(dif));
 %fprintf('Trimmed Mean    %f\n',trimmean(dif));
 fprintf('Median          %f\n',median(dif));
 fprintf('%% Positive      %f%%\n',100.*length(find(dif>0))./length(dif));
 %fprintf('%% < 0           %f\n',100.*length(find(dif<0))./length(dif));
 fprintf('Min             %f\n',min(dif));
 
 fprintf('Percentile %sst %f \n',num2str(01,'%2d'),percentile(dif,0.01));
 fprintf('Percentile %sth %f \n',num2str(05,'%2d'),percentile(dif,0.05));
 for i=0.10:0.10:0.90,
   fprintf('Percentile %sth %f \n',num2str(100.*i),percentile(dif,i));
 end;
 fprintf('Percentile %sth %f \n',num2str(95),percentile(dif,0.95));
 fprintf('Percentile %sth %f \n',num2str(99),percentile(dif,0.99));
 
 fprintf('Max             %f\n',max(dif));

 fprintf('Std             %f\n',std(dif));
 fprintf('MAD             %f\n',mad(dif));
 fprintf('Skew            %f\n',skewness(dif));
 fprintf('Kurtosis        %f\n',kurtosis(dif));
 fprintf('Range           %f\n',range(dif));

if showgraphs,
try,

 figure;clf;[hh,xx] = hist(dif,10);hh=hh./sum(hh);bar(xx,hh,color);ylabel('Pr');xlabel(varstr);
 title(['Distribution for ' varstr]);
  
 figure;clf;[hh,xx] = hist(real(log(dif)),10);hh=hh./sum(hh);bar(xx,hh,color);ylabel('Pr');xlabel(['log ' varstr]);
 title(['Log Distribution for ' varstr]);
 tic = get(gca,'xtick');
 set(gca,'xticklabel',real(exp(tic)));

 figure;clf;hh = hist(dif(find(dif~=0)),[-0.000001,0.000001]);
 hh = 100.*hh./length(dif);
 bar(1,hh(1),color);hold on;
 bar(2,hh(2),'r');
 legend('<0','>0',0);
 ylabel('Pr');
 set(gca,'xtick',[1 2]);
 set(gca,'xticklabel',{['<0 (' num2str(round(hh(1))) '%)'],['>0 (' num2str(round(hh(2))) '%)']});
 v=axis;
 axis([0 3 v(3) v(4)]);
 title(['% of ' varstr ' above versus below 0']);
 %zlabel('Pr');
 %set(gca,'ytick',[1 2]);
 %set(gca,'yticklabel',['<0';'>0']);
 
 figure;clf;dec = decile1(dif,1,10,{'mean'});dec=flipud(dec)';
 bar([1:10],dec,color);
 xlabel('Decile of distribution');ylabel(varstr);title(['Deciles for ' varstr]);

catch 
  fprintf('Unable to plot histogram');
end;
end;

 warning on;
return;