function [m,count] = std_missing(data,missing_val);
% 
% [m.count] = std_missing(data,missing_val);
%
% SEE ALSO
% 
% [xmean,xcount]           = mean_missing(x,missingVal)
% [xsum, xcount]           = sum_missing(x,missingVal)
% [xmean,xstd,xvar,xcount] = mean_nomemory(x,chunksize,missingVal);
%


m = zeros(1,size(data,2));
count = zeros(1,size(data,2));

if size(data,1)==1,
  % no horizontal collapsing please
  return;
end;

for i=1:size(data,2),
  if isnan(missing_val), 
    jj = find(~isnan(data(:,i)));
  else
    jj=find(data(:,i)~=missing_val);
  end;
  if ~isempty(jj),
    m(1,i) = std(data(jj,i));
  end;
  count(1,i) = length(jj);
end;
