function [dat,count]=sum_missing(x,missing_val);
% dat=sum_missing(x,missing_val);
%
% x has rows down, columns across. Summing collapses down the rows, resulting 
% in a single row, horizontal vector of same columns as in x
%  

if isnan(missing_val),
   i=find(isnan(x(:)));
else
   i=find(x==missing_val);
end;

if nargout>1,
  present = ones(size(x));
  present(i) = zeros(size(i)); % zero out missing values
  if size(x,1)==1, 
    count = present;
  else 
    count = sum(present); % sum up the results into column. This is the number present in each dimension
  end;
  clear present;
end;

x(i) = zeros(size(i,1),1);

if size(x,1)==1,
  dat = x;
else
  dat=sum(x);
end;

