
function [significance,ratio]=ttestc(mat,alpha);
% [significance,t]=ttestc(mat,alpha);
% mat is [number_of_x meanx stddevx]
%        [number_of_y meany stddevy]


%count mean median stddev stderr

number_of_x = mat(1,1);number_of_y=mat(2,1);
meanx = mat(1,2);meany = mat(2,2);
varx = mat(1,3)^2;vary = mat(2,3)^2;

%[m1 n1] = size(x);
%[m2 n2] = size(y);
%if (m1 ~= 1 & n1 ~= 1) | (m2 ~= 1 & n2 ~= 1)
%    error('Requires vector first and second inputs.');
%end
 
dfx = number_of_x-1; %length(x) - 1;
dfy = number_of_y-1; %length(y) - 1;
dfe  = dfx + dfy;
msx = dfx * varx;
msy = dfy * vary;

difference = meanx - meany;
pooleds    = sqrt((msx + msy) * (1/(dfx + 1) + 1/(dfy + 1)) / dfe);

ratio   = difference / pooleds;

criticalvalue = tinv(1 - alpha / 2,dfe);
spread = criticalvalue * pooleds;

ci = [(difference - spread) (difference + spread)]; 

% Find the significance probability for the  tail = 1 test.
significance  = 1 - tcdf(ratio,dfe);
% Adjust the significance probability for other null hypotheses.
%if tail == -1
%    significance = 1 - significance;
%elseif tail == 0
    significance = 2 * min(significance,1 - significance);
%end

