function [varlist_out, degree_out, st] = ...
         vanderid_to_varid(varlist,id,iddeg);
%
% [variableID, degree, var_degree_string] = ...
%         vanderid_to_varid(vanderID,id,iddeg);
%
% Given a vander column number (or several), get the variable id and
% degree of those positions. 
%
% id and iddeg are generated by create_vander. These are the same 
% size as vander across, and store at each column the actual 
% variable number and the degree of that variable. To find out what
% the original variable and degree was, we can type:
%
% varID  = id(1,vanderID);
% varDEG = iddeg(1,vanderID);
%
% vanderid_to_varid does the conversion without requiring the user
% to think about the underlying storage. It also creates a string
% representation of the varIDs and their varDegrees which can be
% printed to the screen.
%

  varlist_out = id(1,varlist);   
  degree_out  = iddeg(1,varlist);

  st = [];
  for i=1:size(varlist,2),
    st = [st num2str(varlist_out(1,i)) '^' ...
             num2str(degree_out(1,i)) '  '];
  end;

return

