function dat2 = zerospread(dat);
% dat2 = zerospread(dat);
%
% Method of eliminating zeros. This is common with datasets that switch between some 
% real value > 0, eg. 12000, and 0s, where those 0s are non-responses. This will 
% result in a large number of 0s, and a lack of information on the 
% percentiles associated with the spread of the response. "Zero-spreading" will 
% remove the zeros, and down-weight the positive cases by the removed zero information. 
% The result is that: 
%
% mean( zerospread(dat)) =   mean( dat)


%if size(dat,2)>size(dat
%if nargin<2, doop=1;end;
%if doop==0, dat2=dat;return;end;

i = find(dat~=0);if isempty(i), dat2=dat;return;end;
dat2 = dat(i) .* length(i)./size(dat,1);

return;

