function basic3Dplot(x1,x2,y,show_trajectory,trail);
% 
% basic3Dplot(x1,x2,y,show_trajectory,trail);
%
% create a 3D plot of x1,x2,y, inlcudes dropping
% a needle down to the min y intercept
%
% show_trajectory==1 connects the rows (points) 
% according to their order, so if they form a timeseries
% this shows the progression through time
% 
% if trail~=[] then use trail to define the points

width = 3;

if nargin==3, 
   show_trajectory=1;
end;
if nargin<5,
  trail=[];
end;

clf; hold on;
plot3(x1,x2,y,'o','linewidth',width);

pad = 0.2.*abs(max(y)-min(y));
v = axis;
v(5) = min(y)-pad;
v(6) = max(y)+pad;
axis(v);
grid on;

for i=1:size(x1,1),
   line([x1(i) x1(i)],[x2(i) x2(i)],[v(5) y(i)], ...
        'linewidth',width);
end;


if show_trajectory,

if isempty(trail),
  for i=2:size(x1,1),
     line([x1(i-1) x1(i)],[x2(i-1) x2(i)],[y(i-1) y(i)], ...
          'linewidth',width);
  end;
else
  for t=1:size(trail,2),
    plot3(x1(trail(:,t),1),x2(trail(:,t),1),y(trail(:,t),1),'-','linewidth',width); 
  end;
end;

end;
