function [simplex,err] = build_simplex(d);
%
% function build_simplex(d,r);
%
% d == dimensions of simplex
% will be exactly 1 distance from each other)
%
% builds d dimensional simplex. Does this recursively
% by starting with 2 points, then adding a third such
% that the distance is maintained, and so on.
%

simplex = [0];
% initial simplex is the coordinate (0)
err(1,1) = 0;

if d<2,return;end;

options = foptions;
options(2) = eps;
options(3) = eps;
options(14) = 10000;

for i=2:d,
   % add a dimension to the existing simplexes (this is the 0
   % dimension of course)
   
   simplex = [simplex zeros(size(simplex,1),1)];
   
   % find a new point (row) which satisfies the simplex relation
   newX = simplex(i-1,:);
   newX = fmins('eval_simplex_coords',newX,options,[],simplex);
   simplex(i,:) = newX;
   % estimate error
   err(i,1) = mean(dist2(simplex(1:i-1,:),newX));
   fprintf('dimension %d meandist %d\n',i,err(i,1));
end;

return