function deltax = calc_stress_gradient(distp_original, distp, dist, x);
% 
% deltax = calc_stress_gradient(distpold, distpnew, dist, x);
%
% Calculates the gradient of the stress error function with respect
% to each x. Returns this as a vector of deltax's.
%
% EXAMPLE
% 
% dist = rand(15,15);
% dist = standardize_distmat(dist);
% d    = mat2triulist(dist);
%
% x         = torgerson(dist,2);
% distp_new = dist2(x,x);
% distp_new = standardize_distmat(distp_new);s = stress(dist,distp_new),
%
% while 1,
%  distp_old  = distp_new;
%  distp_new = monotonic_average(dist,distp_old,d);
%  [x,distp_new] = gradient_optimize_stress(distp_old, distp_new, dist, x, alpha);
%  distp_new = standardize_distmat(distp_new);
%  s = stress(dist,distp_new),
% end;
%
% s = stress(dist,distp_new)
%
% SEE ALSO
%
% deltax = calc_stress_gradient(distp_old, distp_new, dist, x);


if 0,

  % Davis algorithm
  % ---------------

  %distp_original(i) = distp(i);
  % find all distances which might cause divisions by zero
  % sets bottom distp_original to the same as the top, distp
  % so that when divide they equal 1

  i=find(distp_original==0);
  distp_original(i) = distp(i);
  dterm = (1-distp./distp_original);

  for i=1:size(x,1),
    for k=1:size(x,2),
      deltax(i,k) = -1./size(x,1) .* dterm(i,:) * (x(i,k)-x(:,k));
    end;
  end;
end; % if 0


% Young algorithm
% ---------------

young_const = -2; % (sum(sum(dist.^2)')); % assumes matrices are standardized

i = find(distp_original==0);
distp_original(i) = ones(size(i,1),1)*inf;
for h=1:size(x,1),
  for e=1:size(x,2),
    deltax(h,e) = young_const .*  ...
                     ((distp(:,h)-dist(:,h))./distp_original(:,h))' * ...
                     (x(:,e)-x(h,e));
  end;
end;

% Adaptive stepsize
% -----------------

if 0,
if iteration>2,
  if err(size(err,1),1)<err(size(err,1)-1,1),
    % speed up
    alpha = alpha + 0.1 .* alpha;
  else
    % brake
    alpha = alpha ./ 10;
  end;
end;
end;

% Conjugate directional adjustment
% ---------------------------------


% Adjust x
% --------

%x = x + alpha .* deltax;
%distp = dist2(x,x);


%deltax = -1.*deltax;
% points upward
