% Multi-dimensional Scaling toolbox
% written by Brendan Kitts 1994-2002. Free for scientific use and for the betterment of mankind
% Please send modifications or enhancements to bkitts@excite.com
%
% MULTI-DIMENSIONAL SCALING
%
% direct_optimize_kruskal       - multi-dimensional reduction of a coordinate matrix so as to minimize kruskal's stress
% torgerson                     - multi-dimensional reduction using a torgerson projection, a relative of a PCA of the distance matrix
% kohonen_anneal                - multi-dimensional reduction using kohonen network
% monomds                       - multi-dimensional reduction using Kruskal's non-metric monotonic algorithm. Inefficient implementation - don't use
% gradient_optimize_stress      - multi-dimensional reduction by minimizing Kruskal's stress using gradient descent
% gradient_optimize_wrapper     - multi-dimensional reduction by minimizing Kruskal's stress using gradient descent
% random_optimize_kruskal       - multi-dimensional reduction by randomly minimizing Kruskal's stress
% stress                        - the discrepancy between two distance matrices
% 
% KOHONEN NETWORKS AND TOPOGRAPHIC MAPS
% 
% kohonen_anneal                - anneals a kohonen network
% kohonen                       - low dimensional projection of data using kohonen network
% kmeans                        - kmeans algorithm
% vam                           - train a vector associative map
% vam_online                    - train a vector associative map (slower)
% memlookup_train               - method of storing vectors in a codebook for later retrieval
% grnn                          - special kind of kohonen neural net or vam
% 
% VISUALIZATION
%
% myplot_kohonen                - used for plotting a kohonen network wire-frame
% build_simplex                 - creates a simplex with side of 1. Simplexes result in pretty MDS projections
% basic3Dplot                   - used for plotting three-dimensional data
% plot_fully_connected          - used for plotting the 2D projection of a simplex.
%
% OTHER TOOLBOXES
% 
% _estimators                   - Estimators
% _priceopt                     - Optimization functions
% _mds                          - Multi-dimensional scaling
% _timeseries                   - Timeseries functions
% _boyd                         - Deciling
% _waldo                        - Image processing
% 
% written by Brendan Kitts 1994-2002. Free for scientific use and for the betterment of mankind
% Please send modifications and enhancements to bkitts@excite.com

README.m                        general_model_eval.m            polyf.m                         
amproj.m                        general_model_plot.m            polyff.m                        
amproj2.m                       general_model_train.m           polyfitf.m                      
basic3Dplot.m                   gradient_optimize_stress.m      polyfitm.m                      
build_simplex.m                 gradient_optimize_wrapper.m     random_optimize_kruskal.m       
calc_stress_gradient.m          graph_quality_wrapper.m         replace_nulls_with_mean.m       
contents.m                      grnn.m                          show_splines.m                  
create_vander.m                 id2grid.m                       sk_timeseries_anal.m            
create_vanderf.m                kmeans.m                        skproj.m                        
crossval.m                      kohonen.m                       spline_activ.m                  
direct_optimize_kruskal.m       kohonen_anneal.m                spline_eval.m                   
direct_optimize_kruskal2.m      kohonen_initialize_centroids.m  spline_train.m                  
direct_optimize_kruskal_FUCK.m  labour_statistics.m             standardize_distmat.m           
display_map_label.m             loaddemodata.m                  stress.m                        
dist2.m                         mapdata.m                       stress_wrapper.m                
distance_activ_function.m       mapdata2.m                      stressd.m                       
distance_missing.m              mat2triulist.m                  testit.m                        
eval_simplex_coords.m           memlookup_train.m               torgerson.m                     
fileedit_append.m               monomds.m                       triulist2mat.m                  
find_closest.m                  monotonic_average.m             vam.m                           
find_closest2.m                 myplot_kohonen.m                vam_online.m                    
find_closest_missing.m          neighbour.m                     zscore2data.m                   
find_reverse_index.m            plot_fully_connected.m          
