function [xp,xpstress] = direct_optimize_kruskal2(x,dist,targetdims,xp,iterations);
% [xp,xpstress] = direct_optimize_kruskal2(x,dist,targetdims,xp,iterations);
% 
% x and dist(x,x) must be supplied, as well as xp, the original points to start from
%
% EXAMPLE
%
% % initialize
% xp = rand(size(x,1),2);dist = dist2(x,x);
% 
% % call
% [xp,xpstress] = direct_optimize_kruskal2(x,dist,2,xp,50);

  % Minimizer parameters
  % --------------------

  options=foptions;
  options(1,14) = iterations;
  options(1,3)  = eps; % 1e-4
  options(1,4)  = eps; % 1e-4

  % Call minimizer
  % --------------
  
  xp = xp(:);  % have to split it out for minimizer
  xp = fmins('stress_wrapper',xp,options,[],dist,targetdims);
  
  % determine finishing stress and re-assemble xp vector
  [xpstress,xp] = stress_wrapper(xp,dist,targetdims);
  
  
