function display_map_label( x, minx, delta, lab,                      ...
                            degree,c,w,norml,kernel,width,model,      ...
                            over_landscape_eps, textwidth, linewidth, ...
                            textcolor, textheight, fontsize);
%
% display_map_label( x, minx, delta, lab,                              ...
%                            degree,c,w,norml,kernel,width,model,      ...
%                            over_landscape_eps, textwidth, linewidth, ...
%                            textcolor, textheight, fontsize);
%
% called exclusively by mapdata
% adds a text label to a specific x1,x2 location, and uses model to
% estimate the z position
%
  
  % determine x1,x2 display position for each label point
  gridxy = (x-ones(size(x,1),1)*minx) ./ ...
           (ones(size(x,1),1)*delta);
  
  % zz uses the actual x position (the position that the 
  % spline model was trained on) to infer the zz value at that point
  zz = general_model_eval(x, degree, ...
                          c, w, norml, kernel, width, ...
                          model);
  
  for i=1:size(x,1),
     
    % plot a line from surface to the label
    if 1,
    line([gridxy(i,1) gridxy(i,1)], ...
         [gridxy(i,2) gridxy(i,2)], ...
         [zz(i,1)+over_landscape_eps  zz(i,1)+textheight], ...
         'color',textcolor,'linewidth',linewidth./2);
    end;

    % plot the o marker
    if 0,
    plot3(gridxy(i,1),gridxy(i,2), ...
           zz(i,1)+over_landscape_eps, ...  % y(i-1,:)+over_landscape_eps, 
           [textcolor 'o'],'markersize',textwidth);
    end;

    % plot the label
    text(gridxy(i,1),gridxy(i,2), ...
         zz(i,1)+textheight, ... % y(i-1,:)+textheight
         char(lab(i,:)),'color',textcolor, ...
         'fontsize',fontsize);
  end;


return
