function [dist,number_present,meandiff] = ... 
          distance_missing(x,y,missing_val);
%
% [dist,number_present,meandist] = distance_missing(x,y,missing_val);
%
% finds the distance between vector x and y, where some elements in both
% x and y may be mising. 


% find -9s and replace with nans
% ------------------------------

i = find(x==missing_val);
j = find(y==missing_val);

x(i) = ones(size(i)).*nan;
y(j) = ones(size(j)).*nan;

diff = abs(x-y)+eps; % no zeros exist in the data

% calc means without the nans
% ---------------------------

% zero out nans
diff(i)=zeros(size(i));diff(j)=zeros(size(j));

% get count of present in each dim
number_present = sum(sign(abs(diff)));
meandiff = sum(diff) ./ number_present;

% special case for no present values at all
allnull = find(isnan(meandiff));
% nan is caused if our mean was 0 / 0. This means that there 
% were no present values in the entire dimension
if size(allnull,2)>0,
  disp(['Found dimensions which are all null' num2str(allnull)]);
  disp('These dimensions should be omitted. ');
  meandiff(allnull) = ones(size(allnull)).*inf;
end;

% for nan in each dim, we now put in the mean difference for this
% dimension
% ---------------------------------------------------------------

for i=1:size(diff,2),
  absent=find(diff(:,i)==0);
  if ~isempty(absent),
    diff(absent,i) = ones(size(absent,1),1) * meandiff(1,i);
  end;
end;

% now we've put in mean differences where there is no match, now
% calc the distance between each set of vectors

dist = mean(diff')';



