function [mini,dist] = find_closest2(x,c);
%
% function [mini,dist] = find_closest2(x,c);
%
% given a set of centroids, c (each row is a centroid)
% and a set of inputs, x, returns a vector mini, which is a long
% vector which is the closest centroid id to each row of x.
%
% dist is the distance matrix, centroids 1;2;3 are down, each datapoint
% is across. [c1x1 c1x2 c1x3 c1x4 ...


  %xones   = ones(size(x,1),1);
  %mindist = distance(xones*c(1,:),x);
  %mini    = ones(size(x,1),1);


    corr = c * x';

    % c*x' =
    %
    % c1x1 c1x2 c1x3 c1x4
    % c2
    %
    % c1^2 c1^2 ... xdatapoints across
    % c2^2 c2^2 ...
    % 
    %
    % x1^2 
    % x1^2
    % x1^2
    % centroids down
    %
    

    % distance, or sqrt(c*c) (for each c vector) =
    % normc = distance(c,zeros(size(c))); % this is a 1d vect of distances
    % we are calculating c^2
    % sum(  (c.*c)'  )'.^0.5
    %

    normc = sum(  (c.*c)'  )' * ones(1,size(x,1));
    % we now duplicate this xdatapoints times  

    normx = sum(  (x.*x)'  )' * ones(1,size(c,1));

    % should be able to now:

    dist = (normc + normx' + -2.*corr) .^ 0.5;
    % distance matrix
    % the term in brackets is the  
    % (x1-y1)+(x2-y2)
    % = x^2-2xy+y^2
    % the sqrt is then the normal ((x1-y1)+...) .^0.5

    % find closest centroid
    [m,mini] = min(dist);
    mini=mini';

return
