function [mini,dist,dimmean] = find_closest_missing(x,c,missing_val);
%
% function [mini,dist,dimmean] = find_closest_missing(x,c,missing_val);
%
% given a set of centroids, c (each row is a centroid)
% and a set of inputs, x, returns a vector mini, which is a long
% vector which is the closest centroid id to each row of x.
%
% dist is the distance matrix, centroids 1;2;3 are down, each datapoint
% is across. [c1x1 c1x2 c1x3 c1x4 ...

if 0,
for cid=1:size(c,2),
  dist(cid,:) = distance_missing( ones(size(x,1),1) * c(cid,:) , ...
                                  x, missing_val)';
  % there should be a more efficient way of doing this, running the
  % distance calc integral in a loop
end;
end;

% the problem with this calc is as follows.
% distance_missing puts in the mean for differences which involve 
% a missing value. This mean is calculated from the mean diff
% between this one centroid, and the rest of the datapoints.
% The mean is used so that the operation with the missing value does
% not increase or decrease the closeness of the match. 
% We do the same for all the other centroids, and then we choose the
% min dist to get the closest centroid to each point. However, we can't
% do this comparison, (to find the closest centroid), because the means
% we just placed into the datapoints will be different for each centroid.
% Therefore, the dists from 

% second alg

% build cmatch array (c1 (size x1..n down) ,c2 (size x1..n down), etc).
% and calc distance to xmatch array (x1..n, x1..n)
% then we get a long list of distances, and we re divide them into
% 

cent   = zeros(size(x,1).*size(c,1),size(x,2));
xmatch = zeros(size(x,1).*size(c,1),size(x,2));

for cid=1:size(c,1),
  cent((cid-1).*size(x,1)+1:cid.*size(x,1),1:size(x,2)) = ...
       ones(size(x,1),1) * c(cid,:);
  xmatch((cid-1).*size(x,1)+1:cid.*size(x,1),1:size(x,2)) = x;
end;


% calc dist from each c to each x
% -------------------------------

[distlist,dimnum,dimmean] = distance_missing(cent, xmatch, missing_val);

% now have to rebreak up into rows for each cid
% ---------------------------------------------

for cid=1:size(c,1),
  dist(cid,:) = ...
  distlist((cid-1).*size(x,1)+1:cid.*size(x,1),1)';
end;

return

% that should be it



if 0,


  %xones   = ones(size(x,1),1);
  %mindist = distance(xones*c(1,:),x);
  %mini    = ones(size(x,1),1);


    corr = c * x';

    % c*x' =
    %
    % c1x1 c1x2 c1x3 c1x4
    % c2
    %
    % c1^2 c1^2 ... xdatapoints across
    % c2^2 c2^2 ...
    % 
    %
    % x1^2 
    % x1^2
    % x1^2
    % centroids down
    %
    

    % distance, or sqrt(c*c) (for each c vector) =
    % normc = distance(c,zeros(size(c))); % this is a 1d vect of distances
    % we are calculating c^2
    % sum(  (c.*c)'  )'.^0.5
    %

    normc = sum(  (c.*c)'  )' * ones(1,size(x,1));
    % we now duplicate this xdatapoints times  

    normx = sum(  (x.*x)'  )' * ones(1,size(c,1));
    % normx=normx';

    % should be able to now:

    dist = normc + normx' + -2.*corr;
    % distance matrix

    % find closest centroid
    [m,mini] = min(dist);
    mini=mini';

return
end;
