function [c,w,yest,methodstring] = general_model_train(x,y,degree, ...
                           number_of_centroids, iterations, lc, norml, kernel, width, ...
                           model);
% [c,w,yest,methodstring] = general_model_train(x,y,degree, ...
%    number_of_centroids, iterations, lc, norml, kernel, width, ...
%    model);
%
% model == 1, polyfitf
% model == 2, spline_train
%
% methodstring == string description of the method chosen
% after calling general_model_train, you can print this
% to check you've selected the correct model
%

if model==1,
  c = polyfitf(x,y,degree);
  w=[];yest=[];
  methodstring = ['polynomial degree ' num2str(degree)];  
end;

if model==2,
  [c,w,yest] = spline_train(x,y,number_of_centroids, ...
                                     iterations, lc, ...
                                     norml, kernel, width);
     if kernel==2, 
        methodstring = ['linear'];
     end;
     if kernel==3,
        methodstring = ['cubic'];
     end;
     if kernel==4,
        methodstring = ['thin plate'];
     end;
     methodstring = [methodstring ' spline'];

end;

if model==3,
  c = x;
  w = y;
  methodstring = ['inverse distance interpolation'];  
end;

