function plot_fully_connected(x);
%
% plot_fully_connected(x);
%
% given a 3-dimensional matrix x = [row row row], plots
% these points and connects each point with an arc.
% This can be useful for plotting a simplex, which is a
% geometric shape where every vertex is fully interconnected
% with every other vertex
%
% EXAMPLE
% 
% % direct_optimize_kruskal for an example provides an example
% % of scaling a high-dimensional simplex to 2D, and then viewing
% % it using plot_fully_connected(xp);
% 
% SEE ALSO
% direct_optimize_kruskal
%  


% plot points
% -----------

clf;
plot3(x(:,1),x(:,2),x(:,3),'o');
hold on;


% for each point, draw line to all other points
% ---------------------------------------------

for i=1:size(x,1),
  line([ones(size(x,1),1)*x(i,1) x(:,1)]', ...
       [ones(size(x,1),1)*x(i,2) x(:,2)]', ...
       [ones(size(x,1),1)*x(i,3) x(:,3)]', ...
       'color','r');
end;

