
function [xp,xpstress] = ...
   random_optimize_kruskal(x,targetdims,iterations,xaredist,xp);
%
% function [xp,xpstress] = ...
%   random_optimize_kruskal(x,targetdims,iterations,xaredist,xp);
% 
% randomly tries different x coordinates and evaluates their stress
% keeps x coordinates with the lowest stress. This is a systematic
% search. I've just noticed that this is a really tought way of
% optimizing.
%


  % Original distance
  % -----------------

  if xaredist==0,
    [mini,dist] = find_closest2(x,x);
  else
    dist = x;
  end;

  
  % max distance from 0 to range
  maxdist = max(dist(:)); 
  maxrange = ((maxdist.^2) ./ targetdims).^0.5;


  % Initialize xp
  % -------------
  
  if nargin<5,
    xp = rand(size(x,1),targetdims).*maxrange;
  end;
  % otherwise we take in the xp



  % Call minimizer
  % --------------
  
  xplong     = xp(:);  % have to split it out for minimizer
  beststress = stress_wrapper(xplong,dist,targetdims);

for i=1:iterations,

  newxplong = rand(size(x,1)*targetdims,1).*maxrange;

  % determine finishing stress and re-assemble xp vector
  [newstress,newxp] = stress_wrapper(newxplong,dist,targetdims);
  
  if newstress<beststress,
    beststress=newstress;
    xplong = newxplong;
    xp = newxp;
    fprintf('newstress %f iteration %d / %d\n',newstress,i,iterations);
  end;

end;
xpstress = beststress;
 
