function testit;

% modify projection code to project class membership down to 2 dimensions
% should be no problem. Just write the general projection and display
% code, and add the third dimension as the class (or height) or vector
%

  % Overall parameters
  % ------------------

  datapoints = 3;
  grid_side = 10; number_of_clusters = grid_side.^2;
  steps              = 50;
  iterations         = 10;
  lc                 = 0.005;
  
  currentdims = 3;targetdims=2;

  x = rand(datapoints,currentdims); 


  dist = dist2(x,x); % the ideal distance relationship
%  warning off;


  % Torgerson and Kruskal direct minimization
  % -----------------------------------------

    [xp,xptorg,xpstress,torgstress] = ...
      direct_optimize_kruskal(x,targetdims,1); 


  % Kohonen map
  % ----------- 
  % note that kohonen only works with 2D target projections 
  % (we could create a general neighbourhood function which has
  % line neighbourhood and maybe multidimensional neighbourhood 
  % (as in gaussians), however lets skip this)

  y = rand(size(x)); % y not be used
  
  [c,cy,member] = kohonen_anneal(x,grid_side,lc,steps,iterations,y);
  
  % now we just need to select the particular centroids in that grid which
  % the training points mapped to
  % clusters always have their 2D positions (!)
  
  for i=1:datapoints,
     % determine (x,y) grid position of this stimulus input
     % ie. the centroid which picked up that datapoint, get its grid position
     
     mini = member(i,1); % datapoint i's closest centroid
     posy = floor((mini-1)/grid_side)+1; 
     posx = rem((mini-1),grid_side)+1;
     % hardcoded square grid from kohonen & also myplot_kohonen
     % we should turn this into a function [x,y] = neighbourhood(id)

     xpkohonen(i,1:2) = [posx,posy];
   end;    
   
   %keyboard
   % now determine the stress for these projected points, versus
   % the original
  
  kdist = dist2(xpkohonen,xpkohonen);
  kstress = stress(dist,kdist);
  fprintf('\nkohonen stress %f\n',kstress);

figure(1);clf;plot(xp(:,1),xp(:,2),'.','markersize',0.5);text(xp(:,1),xp(:,2),num2str([1:datapoints]'));axis('off');
figure(2);clf;plot(xptorg(:,1),xptorg(:,2),'.','markersize',0.5);text(xptorg(:,1),xptorg(:,2),num2str([1:datapoints]'));axis('off');
figure(3);clf;plot(xpkohonen(:,1),xpkohonen(:,2),'.','markersize',0.5);text(xpkohonen(:,1),xpkohonen(:,2),num2str([1:datapoints]'));axis('off');
myplot_kohonen(x,y,'ro',c,cy,'bo',4,5,'b-');

warning on;
return


% ---------------------
% notes

  if 0,
  if size(h,1)>datapoints, 
    % if the number of points in the kohonen map is greater
    % than the number of points being mapped, then select 
    % only the centroids which have the highest hit rates
    % (we might use extra centroids so that we preserve the
    % structure of the map as best as possible - using too
    % few centroids can result in boundary effects)
    % Select highest hit clusters
    % go through and select the clusters which have the top number
    % of membership hits

    hits = zeros(number_of_clusters,1);
    for i=1:number_of_clusters,
      hits(i,1) = size(find(member==i),1);
    end;
 
    % now select the clusters with the top number of hits
    % to define the space

    h = flipud(sortrows([hits [1:number_of_clusters]']));
    % h consists of hits, clusterID

    % now select the top datapoints clusterIDs
    cid = h(1:datapoints,2);
  else
    cid = [1:datapoints]';
  end;
end;

