function convert_relational_to_basket_series;

% Generate sequential number for transactionid of each element of the data
% -------------------------------------------------------------------------

transaction_identifier = b(:,2:4);
% this is the transaction key datetouse,timetouse,lane.
% we will recode this into a unique number.

[transactionid,transactionvals,transactioncount]=recode(transaction_identifier);
% transactioncount is how many items were scanned on each transaction
% eg. mean(transactioncount) = average number of distinct items scanned per transaction

% convert to a single number, then recode?
% should check how long this takes (compared to above)
%key = num2str(zeros(size(transaction_identifier,1),1));
%for i=1:size(transaction_identifier,2),
%   key = strcat(key,'0',num2str(transaction_identifier(:,i)));
%   fprintf('appended %d columns of %d\n',i,size(transaction_identifier,2));
%end;
% convert key2 back to a number. We now have an across code for each transaction
%key2 = str2num(key);
% recode key3 so that we have a sequential number for each transaction
%[transactionid,transactionvals,mapping] = recode(key2);

% we now have a sequential number for transaction down.

% Generate sequential number for each item(category)
% --------------------------------------------------

cat = string_load('brodbeck_basket_category_cat.txt');
% watch the last entry. The last entry in cat might be blank. Its an extra
% harmless code, since there will be no categories which use the blank. But
% we will have to cut off the end.
cat = cat(1:size(cat,1)-1,:);

[itemid,itemvals,itemcount] = recode(cat); 
% itemcount says how many times each item was chosen by a customer
% eg. how popular each item is

% we now have a unique number for the transaction down, we need to find
% recode the customer id 

price = spconvert([transactionid,itemid,b(:,5)]);
qty   = spconvert([transactionid,itemid,b(:,6)]);
% items across the top,  time going down

[custid,custvals,custcount] = recode(b(:,1));
% custcount is how many distinct items each customer purchased


% Find out which customers came more than once
% ---------------------------------------------

multiplevisits=zeros(size(custvals,1),1);
for i=1:size(custvals,1),
   visit = find(custid==i);
   if transactionid(min(visit),1)==transactionid(max(visit),1),
      fprintf('o');
      % this customer only visited once
   else
      multiplevisits(i,1)=1;
      fprintf('.');
   end;
   if rem(i,100)==0, fprintf('%d/%d ',i,size(custvals,1));end;
end;
fprintf('\n');
multiplevisits = find(multiplevisits==1);

% foreach customer
%   no_transactions(customer) transactions
%   

% to calc p(switch)
% no_times it1==1 and it2==0 and next time it1==0 and it2==1
% equals switch from it1_to_it2
% foreach cust
%   godown no_transactions(cust)
%   shift each
%   ii=find(it1==1 & it2==0 & it1shift==0 & it2shift==1)
% 
%   

% Probability of switch
% ======================

% Probability of switch Method 1:
% -------------------------------
% Collapse all cust transactions to a single matrix, and go down the matrix
% Error will creep in because the boundary of one customer to the next, it will
% think a switch did or didn't occur
% 

custtranstemp = [custid transactionid];
[a,cust_trans_order] = sortrows(custtranstemp(multiplevisits,:));
% transactionid has numbers 1,2,3,... which are in transaction time order because 
% we ran it through our recode function, and that put the transaction time into order
% first, and then assigned sequential ids.
% If we just sort by custid,transactionid, then we will group custs together, and
% get their transactions in time order

% Collapse all customer transactions to a single 
% today is qty(multiplevisits(cust_trans_order),:);
% tomorrow is [zeros;today(2:size(today,2))]; qty(multiplevisits(cust_trans_order),:)

today=qty(multiplevisits(cust_trans_order),:);
tomorrow=[today(2:size(today,1),:);zeros(1,size(today,2))];
today=sign(abs(today));
tomorrow=sign(abs(tomorrow));

% Submethod in method 1: use for loops to count the probs
probswitch=zeros(size(qty,2),size(qty,2));
noswitches=zeros(size(qty,2),size(qty,2));
for i1=1:size(qty,2),
   for i2=1:size(qty,2),
      if i1~=i2,
         sales=find(today(:,i1)==1);
         if ~isempty(sales),
           switchi=find(today(sales,i1)==1 & today(sales,i2)==0 & tomorrow(sales,i1)==0 & tomorrow(sales,i2)==1);
           if ~isempty(switchi),
              noswitches(i1,i2)=size(switchi,1);
              probswitch(i1,i2)=size(switchi,1)./size(sales,1);
              %fprintf('.');
           end;
         end;
      end;  
   end;
   fprintf('%d/%d ',i1,size(qty,2));
end;
fprintf('\n');

% baseline rate of substitution
baseline_switch = sum(probswitch') ./ (sum(sign(abs(probswitch')))+eps);
liftswitch = probswitch ./ (ones(size(qty,2),1)*(baseline_switch+eps));
% total probs ./ no. present, so the rate of substitution if the product
% is listed

corrlist=find_sig_corrmat_els(liftswitch,20,noswitches,5);
corrlist=find_sig_corrmat_els(probswitch,20,noswitches,5);



% there should be a better way of doing this with matrices



% a==1,b==0  &  a==0,b==1

ii=find(

% for each col

% what about
% append all custs into one large transaction
% custqty = [qty(cust,:) zeros]; % groups all transactions so that they
% % are for a particular customer. 
% % transactions MUST BE ORDERED BY TIME. Otherwise, this switch algorithm
% can't possibly work (it looks at the next date to see if a switch occurred)
% Then when we use p(switch), we're always
% % looking at switch within same customer.
%
% 
  
  % qty(cust,transactionid,itemid);
  % ii=find(
%
 