function [x,err] = bisection1_optimize(fun, lower, upper, varargin);
% 
% [x,err] = bisection1_optimize(fun, lower, upper, varargin);
%
% Bisection on a function of one-dimension. See bisection_optimize for more details.
% 
% EXAMPLE
%
% bisection1_optimize('fun',-10,10),
% 
% SEE ALSO
%
% bisection_optimize, gradient_optimize, newton_optimize


if size(lower>1) | size(upper>1), 
  fprintf('variables must be one-dimensional\n');
  return;
end;

[x,err] = bisection_optimize(fun, lower,upper,1,inf,inf,varargin{:});
