function brodbeck_latentspender;


% Which categories do the best customers like (profile of good customer, also equity)
% -----------------------------------------------------------------------------------

h = find(totalrev<500 & totalrev>0);size(h),
avg_vec = mean(vecn(h,:));
%char(cat), % lists the categories
avg_vec', % lists the mean zscore for these customers


% Split b into vector
% --------------------

revy1 = sum(b(:,2:33)')';
revy2 = sum(b(:,34:66)')';
totalrev = revy1+revy2;

fprintf('building category pref vec\n');
vec = b(:,67:size(b,2)) ./ ((revy1+revy2) * ones(1,415)); % + rev2
% vec = b(:,67:66+415./5) ./ ((revy1+revy2) * ones(1,415./5)); % + rev2
fprintf('removing nans\n');
ii=find(isnan(vec));
vec(ii)=zeros(size(ii,1),1);
% note, we have a problem there is some leakage here. Category preference includes
% the y2 preference. This should not happen (only base off y1 preference). It could
% cause a confound if some categories are more expensive than others. thus, general
% merchandise purchase in y2 might contaminate the sample, and reveal that this customer
% had high purchases
[vecn,vecmean,vecstd] = data2zscore(full(vec)); % each dim equal "weight"
% vec is a proportion of each category, ie. what the customer favours out of the categories
%vec = b(:,67:size(b,2));

% Split into high and low
% -----------------------
% find custs in low population who have same demo profile as high

thresh = 9000;k=1;
h = find(revy1>=thresh);size(h),
l = find(revy1<thresh);size(l),

% Example
[yest,id] = k_nearest_neighbour(vecn(h,:),vecn(l,:),vecn(l,1),k);
list=remove_duplicates(id(:));
mean(revy2(list)), % avg revenue for the low neighbours (next year)
mean(revy2(l)),    % avg revenue for the population
mean(revy2(h)),
 
  %%%% mean of custs selected using k nearest neighbour for values 1..k
  k=1000; % number of nearest neighbours to retrieve as a match
  rev=[];
  [yest,id,dist] = ...
  k_nearest_neighbour(vecn(h,:),vecn(l,:),vecn(l,1),k);
  for i=1:k,
   a=id(:,1:i);list=remove_duplicates(a(:));
   rev(i,1) = mean(revy2(list));
  end;
  figure(1);clf;hold on;
  xax = (100.*[1:k]./size(vec,1));
  plot(xax,rev,'-');
  plot(xax,ones(k,1)*mean(revy2),'r--');
  plot(xax,ones(k,1)*mean(revy2(l)),'r:');
  xlabel('% of population');
  legend('selected group spending','pop mean','lowgroup mean');
  
  %%%% show the neighbours of the points
  neighblist = [208 158]; 
  [yest,id] = ...
  k_nearest_neighbour(vecn(h,neighblist),vecn(l,neighblist),vecn(l,12),4);
  figure(1);clf;
  plot(vecn(h,neighblist(:,1)),vecn(h,neighblist(:,2)),'rx');hold on;
  plot(vecn(l,neighblist(:,1)),vecn(l,neighblist(:,2)),'bo');
  plot(vecn(list,neighblist(:,1)),vecn(list,neighblist(:,2)),'ro');
 
  %%%% show effectiveness of just sorting by present year revenue
  %%%% (exclude high)
  %prop_of_set = 0.01;
  %els = (prop_of_set.* (size(vec,1)-1)) +1;
  els = 100;
  [a,i] = sort(revy1); 
  % [a,i] = sort(revy2); % theo limit to possible upsell
  i=flipud(i); % put highest revenues first
  
  rev2=[];
  for cc=1:els, 
     rev2(cc,1) = mean( revy2(i(1:cc,1)) ); 
  end;
  xax = (100.*[1:els]./size(vec,1));
  figure(2);clf;
  plot(xax,rev2,'-'); hold on;
  plot(xax,ones(els,1)*mean(revy2),'r--');
  plot(xax,ones(els,1)*mean(revy2(l)),'r:');
  legend('y1toprevgroup','pop mean','lowgroup mean');
  xlabel('% of population');
  title('theoretical best targeting of customers');

  %%%% ("theoretical") limit to total upsell possible in the year in
  %%%% question
  
  
  % Fake data maker
  % ---------------
  % 8387
  
  sex = char([ones(4200,1).*70;ones(4187,1).*77]);
  occupat_str = ['technical   ';...
             'housemaker  ';...
             'student     ';...
             'management  '];
  occupat = floor(rand(size(b,1),1).*size(occupat_str,1))+1;
  occupat2 = ones(size(b,1),size(occupat_str,2)).*32;
  for i=1:size(occupat_str,1),
     ii=find(occupat==i);
     occupat2(ii,1:size(occupat_str,2))=ones(size(ii,1),1)*occupat_str(i,:);
  end;
  
  % figure(1);[a,x]=hist(35+randn(10000,1).*8);plot(x,a)
  figure(1);[a,x]=hist(20+poissrnd(7,10000,1).*3);plot(x,a)
  
  age = 20+poissrnd(7,size(b,1),1).*3;
  
  [a,favourite] = max(b(:,67:size(b,2))');
  favourite=favourite';
  
  visits = sum(sign(b(:,2:66))')';
  freq_per_week   = visits./66;
  retention = freq_per_week;
  
  
  %  fid=fopen('h:\consulting\common\projects\stop&shop\cust_cat_vects2.txt','w');d=full(d);for i=1:size(b,1),fprintf(fid,'%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\n',d(i,1),d(i,2),d(i,3),d(i,4),d(i,5),d(i,6),d(i,7),d(i,8),d(i,9),d(i,10));if rem(i,100)==0,fprintf('%d/%d ',i,size(b,1));end;end;fclose(fid);

  % Extract relational form for attribute list
  % -------------------------------------------
  [i,j,vecn_list]=find(vecn(:,:));
  % b(i,1) is the customer id for each customer id down position
  
  size(i),
  
  custcode = b(i,1);
  a = rand(size(i,1),1);
  [a,entries] = sort(a);
  % entries is now a set of random ids in 1..size(i,1)
  fid=fopen('Profile_customer_attribute.txt','w');
  for ii=1:size(i,1), %60000,
     fprintf(fid,'%f\t%s\t%f\n',full(custcode(entries(ii),1))',char(full(cat(j(entries(ii),1),:))'), ...
        full(vecn_list(entries(ii),1))');
  end;
  fclose(fid);
  
  [data2,valtree] = discretize_continuous_vars(full([revy1 revy2 totalrev freq_per_week retention visits]),10,0,-9);
  age2 = discretize_continuous_vars(full(age),10,0,-9);
  data2(:,1:3) = discretize_continuous_vars(full([revy1 revy2 totalrev]),500,0,-9);
  
  %full(revy1(ii,1))', full(revy2(ii,1))', full(totalrev(ii,1))', full(freq_per_week(ii,1))', ...
% full(retention(ii,1))', full(visits(ii,1))', ...
  fid=fopen('Profile_customer.txt','w');
  for ii=1:size(b,1), %size(b,1),
  fprintf(fid,'%f\t%f\t%f\t%f\t%f\t%f\t%f\t%s\t%s\t%f\t%d\n', ...
     full(b(ii,1))', data2(ii,1)',data2(ii,2)',data2(ii,3)',data2(ii,4)',data2(ii,5)',data2(ii,6)', ...
     full(char(sex(ii,:)))',full(char(occupat2(ii,:)))',age2(ii,1)',...
     full(favourite(ii,1))');
  end;
  fclose(fid);
  
  fid=fopen('Profile_attribute.txt','w');
  for ii=1:size(vecn,2),
     fprintf(fid,'%d\t%s\n',ii,char(cat(ii,:))');
  end;
  fclose(fid);
  
  
  % vec is the list of categories (spending on each)
  % vecn is the zscore list of categories
  
  % revy1, revy2, totalrev, freq_per_week, retention, visits
  
  % ===========================================
  % NOTES
  % 
  
   i=strmatch('PAPER - BATHROOM TISSUE',char(cat))

i =

   105

 i=strmatch('PAPER - FACIAL TISSUE',char(cat))

i =

   104

 i=strmatch('PAPER - TOWELS',char(cat))

i =

   106

 i=strmatch('BUTTER',char(cat))

i =

   309

 i=strmatch('BANANAS',char(cat))

i =

   354
  
  