function [updown, avg_movement] = combine_estimates(orig,est);
% [updown, avg_movement] = combine_estimates(orig,est);
%
% after this, we have the average movement vector. Now sort it in order to get
% the largest to smallest changes. OR
% avg_movement ./ pricevect to give the highest movement as a percentage of
% starting price (highest percent price change)

% find movement up down

origmat = ones(size(est,1),1)*orig;
movement = est - origmat;

updown = sum(sign(movement)); % so if we have 1,1,1,-1 then we'll move up
% this is like voting. A positive is a vote for up, a negative is a vote for down,
% a 0 is abstain, which means that it doesn't contribute to the up/down vote

avg_movement = mean(movement); % column average

