method    = 5;
centroids = 20;

% Price competitors
% -----------------

corr = corrmat2(pricegroup',itemgroup');
corr2 = corr';
[node,edge,similarity,head] = agglomerative_cluster(corr2,method,centroids);

% Similar items
% -------------

corr = corrmat2(itemgroup',itemgroup');
corr2 = corr-diag(diag(corr));
[node,edge,similarity,head] = agglomerative_cluster(corr2,method,centroids);

% Substitute items (note basket form needed to get substitutes)
% ----------------

corr = corrmat2(itemgroup',itemgroup');
corr2 = corr-diag(diag(corr));
[node,edge,similarity,head] = agglomerative_cluster(-corr2,method,centroids);

% Display items
% --------------

for i=1:size(edge,1),if edge(i,2)<size(group,1),fprintf('%s\n',char(group(edge(i,2),:)));else fprintf('--\n');end;end;
% also try just selecting largest correlations, one after another
% also, try graph drawing

% Draw tree
% ---------

graph_unordered_btree_wrapper(head(1),node,[edge similarity],group,1,1,0.1,4);
for i=1:max(size(head)),graph_unordered_btree_wrapper(head(i),node,[edge similarity],group,1,1,0.01,20);v=axis;axis(v.*1.5);pause;end

%dist=dist2(itemgroup,itemgroup); % correlation seems to make more sense
dist = 1-corr;
x=torgerson(dist,2);
r=1:30;figure(1);clf;hold on;plot(x(r,1),x(r,2),'.');text(x(r,1),x(r,2),char(group(r,:)),'fontsize',8);voronoi(x(r,1),x(r,2));zoom on;



corr = corrmat2(itemgroup',itemgroup');
% items correlated with each other (in terms of daily series)
% if we change itemgroup to a basket form series, then we should
% get the basket-level substitutes

corr = corrmat2(pricegroup',itemgroup');
% corr is a matrix of price competitors. inc price inc. demand
% problem: the matrix is asymmetric. Therefore, when we agglomerate,
% weird things will happen. Agglomeration functions by agglomerating
% horizontal rows. Therefore, we need to transpose the series before
% running agglomerative.

corr2=corr-diag(diag(corr));
% not needed if we use 

[node,edge,similarity,head] = agglomerative_cluster(corr2,5,20);
% [node,edge,similarity,head] = agglomerative_cluster(-corr2,5,20);
% competitors

for i=1:size(edge,1),if edge(i,2)<size(group,1),fprintf('%s\n',char(group(edge(i,2),:)));else fprintf('--\n');end;end;