function [totalqty,totalrev,totalprof] = contribution(price,wmat,cons,cost,itemdescript);
% [totalqty,totalrev,totalprof] = contribution(price,wmat,cons,cost);
%
% price is a single row vector of item prices (no multiple days)

% totalqty = qtyi + 

no_days = 1;
noitems = size(wmat,1);

qty  = [price ones(no_days,1)] * [wmat;cons];
i = find(qty<0);qty(i)=zeros(size(i,1),1);
rev  = price.*qty;
marg = price-cost; 
prof = marg.*qty;
  
%totalrev  = rev - sum( (ones(noitems,1)*price) .* wmat' .* ((price')*ones(1,noitems)));
totalrev  = rev - sum(price'*price .* wmat');
totalqty  = qty - sum(ones(noitems,1)*price .* wmat');
totalprof = rev - sum(ones(noitems,1)*price .* wmat' .* ((marg')*ones(1,noitems)));


% Explanation: 
% contribution of a product is equal to its qty (direct sales or profit from it)
% plus the cross-sales it attracts at the store
% positive w means price inc. means this product increases other sales
% 
% Removing an item is like increasing its price. Positive ws mean that the other
% product gets greater sales. Negative ws mean that the other product's sales
% are way depressed because of the "price hike" or removal.
%
% Positive ws decrease the product's contribution in existing - they mean that
% if we got rid of the product, the other product's sales would increase.
% Negative ws increase the product's contribution in existing - they mean that
% this product helps the other products, and hiking its price decreases the other
% sales.
%
% Therefore, totalrev = rev - summed cross effect from this product onto others
% - negative effect means the product 
% 