function display_correlations(corr,num,s,sthresh, ...
                              itemdescript1,itemdescript2,str);
%
% display_correlations(corr,num,s,sthresh, ... 
%                      itemdescript1,itemdescript2,str);
%
% Given a correlation matrix (or similar, eg. cross-elasticity matrix
% or affinity matrix), corr, prints out the strongest num positive and
% negative correlations in list format.
%
% SEE ALSO
% display_item (which displays highest and lowest n vals of an item)
%
% CALLED BY
% analyse_itemgroup
% 

if isempty(s) | isempty(sthresh),
   corrlist=find_sig_corrmat_els(corr,num);
else
  corrlist = find_sig_corrmat_els(corr,num,s,0);
end;

% Display the items
fprintf('Rank\tDown\tAcross\t%s\n',str);
for i=1:num,
  fprintf('%d\t%d\t%d\t%s\t%s\t%6.3f\n',i,...
          corrlist(i,1),corrlist(i,2), ...
          char(itemdescript1(corrlist(i,1),:)), ...
          char(itemdescript2(corrlist(i,2),:)), ...
          corrlist(i,3));
end;

