function display_items(itemdescript,itemcategory,totalqty,meanmargin,str,datastr,no_ranks);
%
% display_items(itemdescript,totalqty,meanmargin,str,no_to_display);
%
% Display the best and worst no_to_display items
%
% EXAMPLE
% display_items(itemdescript,totalqty,mean(price-cost),'sellers',5);
% % displays the top and bottom 5 selling items
%
% CALLED BY
% analyse_wmat
%

% Top selling items
[sortedqty,qtyi] = sort(-1.*totalqty);
fprintf('Top %s\n',str);
if isempty(itemcategory),
  fprintf('Rank\tDescription\t%s\tMargin\n',datastr);
  for i=1:no_ranks,
     fprintf('%d\t%s\t%10.2f\t%10.3f\n',i,char(itemdescript(qtyi(i),:)),-1.*sortedqty(i),meanmargin(qtyi(i)));
  end;
else
  fprintf('Rank\tCategory\tDescription\t%s\tMargin\n',datastr);
  for i=1:no_ranks,
     fprintf('%d\t%s\t%s\t%10.2f\t%10.3f\n',i,char(itemcategory(qtyi(i),:)),char(itemdescript(qtyi(i),:)),-1.*sortedqty(i),meanmargin(qtyi(i)));
  end;
end;

% Bottom selling items
[sortedqty,qtyi] = sort(totalqty);
fprintf('Poorest %s\n',str);
if isempty(itemcategory),
fprintf('Rank\tDescription\t%s\tMargin\n',datastr);
  for i=1:no_ranks,
     fprintf('%d\t%s\t%10.2f\t%10.3f\n',i,char(itemdescript(qtyi(i),:)),sortedqty(i),meanmargin(qtyi(i)));
  end;
else
  fprintf('Rank\tCategory\tDescription\t%s\tMargin\n',datastr);
  for i=1:no_ranks,
     fprintf('%d\t%s\t%s\t%10.2f\t%10.3f\n',i,char(itemcategory(qtyi(i),:)),char(itemdescript(qtyi(i),:)),sortedqty(i),meanmargin(qtyi(i)));
  end;
end;
