function [totalprof1,totalprof2,prof1,prof2] = effect_of_pricechange(price1,price2,itemdescript,itemcategory,model,modelspec,w,cost,wmat,cons);
% i = strmatch('PEANUT BUTTER',itemdescript);size(i),
% price2 = pricevect;price2(1,i) = 10.00;
% [totalprof1,totalprof2,prof1,prof2] = effect_of_pricechange(pricevect,price2,itemdescript,model,modelspec,w,cost,wmat,cons);

itemdescript = char(itemdescript);
itemcategory = char(itemcategory);
critstr = 'totalqty';
 [critval,dcritval,ddcritval,wmat1,cons1,qty1,rev1,prof1,dqty,drev,dprof, ...
   totalqty1,totalrev1,totalprof1,dtotalqty,dtotalrev,dtotalprof] = ...
  demand_model_eval(price1',model,modelspec,w,critstr,cost',wmat,cons);

 [critval,dcritval,ddcritval,wmat1,cons1,qty2,rev2,prof2,dqty,drev,dprof, ...
   totalqty2,totalrev2,totalprof2,dtotalqty,dtotalrev,dtotalprof] = ...
  demand_model_eval(price2',model,modelspec,w,critstr,cost',wmat,cons);

% find number of prices which changed:

pricechanges=find(price2-price1~=0);
fprintf('%d prices were changed\n',max(size(pricechanges)));

fprintf('Item\tOldPrice\tNewPrice\n');
for i=1:max(size(pricechanges)),
   fprintf('%s\t%10.2f\t%10.2f\n',itemdescript(pricechanges(i),:),price1(pricechanges(i)),price2(pricechanges(i)));
end;
fprintf('\n\n');
   % find all qties or profs that changed

dtotalprof = totalprof2-totalprof1;
dtotalrev  = totalrev2-totalrev1;
dtotalqty  = totalqty2-totalqty1;
fprintf('Summary effect on Store\n');
fprintf('Variable\tBefore\tAfter\tChange\n');
fprintf('totalprof\t%f\t%f\t%f\n',totalprof1,totalprof2,dtotalprof);
fprintf('totalrev\t%f\t%f\t%f\n',totalrev1,totalrev2,dtotalrev);
fprintf('totalqty\t%f\t%f\t%f\n',totalqty1,totalqty2,dtotalqty);
fprintf('\n');

dqty  = qty2-qty1;
dprof = prof2-prof1;
drev  = rev2-rev1;
changed=find(dqty~=0 | dprof~=0 | drev~=0);
fprintf('Item changes\n');
fprintf('%d items in store total, were effected by the change in the %d items\n',max(size(changed)),max(size(pricechanges)));
fprintf(['Category\tItem\tQtyBefore\tQtyAfter\tRevBefore\tRevAfter\tProfBefore\tProfAfter\t' ...
         'QtyDiff\tRevDiff\tProfDiff\n']);
for i=1:max(size(changed)),
   fprintf('%s\t%s\t%d\t%d\t%f\t%f\t%f\t%f\t%d\t%f\t%f\n',itemcategory(changed(i),:),itemdescript(changed(i),:), ...
       qty1(changed(i)),qty2(changed(i)),rev1(changed(i)),rev2(changed(i)), ...
      prof1(changed(i)),prof2(changed(i)),dqty(changed(i)),drev(changed(i)),dprof(changed(i)));
end;
