function examine_demand_models_accuracy;

cases=1:50;tr=[1:230];te=[231:382];

% Accuracy of using own price to predict demand
% ==========================================================================

% Use price series representation
totpred_own=zeros(max(cases),size(te,2));totact=(item30(cases,te));warning off;for i=cases,w=polyfitf(price30(i,tr)',item30(i,tr)',1);yest=polyff(w,1,price30(i,te)');totpred_own(i,:) = yest';fprintf('%d/%d ',i,50);end;warning on;fprintf('\n');

% Use pricepoint method
ii=find(changelist<max(cases));
cases = changelist(ii,1);
totpred=zeros(1,size(te,2));totact=sum(item30(cases,te));
for i=1:size(cases,1),
   i,
   w=polyfitf(full(prices(cases(i,1),1:full(different_prices(i,1))))', ...
      full(qties(cases(i,1),1:full(different_prices(full(i),1))))',1);
   yest=polyff(w,1,price30(cases(i,1),te)');
   totpred = totpred + yest';
   fprintf('%d/%d ',i,size(cases,1));
end;
warning on;fprintf('\n');

% Test variable selection: cross-elastic, meanprice, lagterms, indicators
% ========================================================================

% plot totpred versus totact
figure(1);clf;plot(te,sum(totpred),'b--');hold on;plot(te,sum(totact),'r-');legend('predicted','actual');xlabel('day');ylabel('qty in next 30 days');
title('Own price to predict demand (Aggregate forecast vrs actual 10 items)');

% Accuracy of the two in terms of percent absolute error for next 30 days
abs((sum(item30(1:10,te)')'-sum(totpred_own')')./sum(item30(1:10,te)')')

% Correlation of the two
correlation(item30(1:10,te)',totpred_own'),


% Go to yestout = 
% in create_demand_models. Uncomment it, now the procedure will return totpred 

% Adjust 


[temp1,temp2,temp3,meanabs,perabs,correl,totpred1,totact1] = create_demand_models(price30,item30,[1:230],[231:382],10,0,0,0,1,1,0);


% Prediction using 30 day series versus
% single day prediction and roll up to 30 days
% ---------------------------------------------

% predicting from price30, item30 series
% 10 stepwize terms, 14 autocorrs, 5 day lag, resolution of 1
[temp1,temp2,temp3,meanabs,perabs,correl,totpred,totact,yest30,dep30] = create_demand_models(price30,item30,[1:250],[251:370],10,14,20,5,1,1,1);

% predicting from price, item series, resolution (sumseries) is 30
% same parameters
[temp1,temp2,temp3,meanabs,perabs,correl,totpred,totact,yest1,dep1] = create_demand_models(filled_price,item(:,2:size(item,2)),[1:250],[251:400],10,14,20,5,1,30,1);

accuracy_twoseries(item30(1:20,370-65+1:370),yest1,7,20);
accuracy_twoseries(item30(1:20,276:370),yest30,5,20);
