function price=fill_price_array2(price);
%
% p=fill_price_array2(price);
%
% a price array is a timeseries where a price or qty
% is recorded on a particular day. The days in-between
% purchases have no price recorded (are zero), even though the
% price was implicitly active. This routine fills those holes by
% cascading the price across the days where no price is recorded
%
% price series is on its side: time goes across
%                         item1
%                         item2
% 

% find the first price. 
% We need this to know what the initial currentprice is

disp('searching down and across for start price');
disp_step = round(size(price,1)./20);
for i=1:size(price,1),
   if rem(i,disp_step)==0,fprintf('%d ',i);end;
   %start(i,1)=1;
   %while price(i,start)==0 & start(i,1)<=size(price,2), 
   %   start(i,1)=start(i,1)+1; 
   %end;
   %if i==2, keyboard;end;
   ac=find(price(i,:)~=0);
   %ar=unique(ac);
   currentprice(i,1) = price(i,ac(1,1));
   %currentprice(i,1) = price(i,start(i,1));
   % set the current price
   
   % backfill
   % price(i,1:start(i,1)) = ones(1,start(i,1)).*currentprice(i,1);
end;

disp(' ');
disp('converting to full matrix');
price = full(price);
disp('filling prices by column');
% while keeping track of the current price, fill in the zeros
for t=1:size(price,2),
   zeroprice = find(price(:,t)==0);
   price(zeroprice,t) = currentprice(zeroprice,1);
   
   newprice = find(price(:,t)~=0);
   % for items which have a new price, leave price as is, 
   % and update the currentprice vector
   currentprice(newprice,1) = price(newprice,t);
   fprintf('%d ',t);
end;
fprintf('\n');
    