% LOAD DATA
% =========

load usalo.mat; % note save these into another filename (or local on mapping directory)
load brodbeck_longlat.txt;
load dicks_and_walmart_stores_longlat_only.txt
l=dicks_and_walmart_stores_longla;
clear dicks_and_walmart_stores_longla;

storelist = [l(7:12,1:2);l(14,1:2)]; % omit store 9
% each number on storelist matches up to the position across in b

% Distance to each store
% ======================

d=[];
for i=1:size(l,1),
  d(1:size(l,1),i) = latlong2dist(ones(size(l,1),1)*l(i,:),l);
end;
% brodbeck stores are 7..14
% 1 0.23 miles
% 2 all > 18.5
% 3 0.4322
% 4 competitors > 20.9, owns store >19.8
% 6 all > 14.38
% 8 0.3785
% 10 all > 13.19

for ii=7:14,


% PLOT SURFACE OF SURROUNDING AREA
% =================================

store=['W';'W';'W';'W';'W';'W';'1';'2';'3';'4';'6';'8';'9';'0'];
%b = [zeros(size(l,1),1) l -inf.*ones(size(l,1),7) ];
dist = latlong2dist(b(:,2:3),ones(size(b,1),1)*mean(b(:,2:3)));
ii=find(dist<55);size(ii), % 55
%ii = find(latlong2dist(b(:,2:3),ones(size(b,1),1)*storelist(2,:))<30);
%ii=[1:14]';
minx = min(b(ii,2:3));maxx = max(b(ii,2:3));range=maxx-minx;maxrange = max(range);
extremum = minx+[maxrange maxrange];
%pt=1000;b=[b;zeros(pt,1) rand(pt,2).*maxrange+ones(pt,1)*minx zeros(pt,7)];ii=[1:size(b,1)]';
[minx,stepsize,zi]=showresults([b(ii,2),b(ii,3);extremum],[sum(b(ii,4:10)')';0],1);
%[minx,stepsize,zi]=showresults([b(ii,2),b(ii,3);l;extremum],[sum(b(ii,4:10)')';-inf.*ones(size(l,1),1);nan],1);view(0,90);zoom on;%zoom(2);%view(30,30);rotate3d;
%f = (l-ones(size(l,1),1)*minx)./(ones(size(l,1),1)*stepsize)+1;
%figure(1);hold on;for i=1:size(l,1),plot3(f(i,1),f(i,2), 10000,'r.','markersize',10);text(f(i,1),f(i,2),10000,store(i,1),'color','w','fontsize',14);end;

%

zi=zi';
%zi=flipud(zi);

figure(3);clf;
axesm('MapProjection','eqaconic','MapParallels',[],...
      'MapLatLimit',[20 75],'MapLonLimit',[-175 -60],...
      'MLabelLocation',1,'MLineLocation',1,...
      'PLabelLocation',15,'PLineLocation',15,...
      'GColor',0.5*[1 1 1],'GLineSTyle','-',...
      'MLabelParallel','south');
% eqaconic axesm miller;
framem;gridm; mlabel;plabel;
plot3m(statelat,statelon,-1000.*ones(size(statelat,1),1));
plot3m(gtlakelat,gtlakelon,-1000.*ones(size(gtlakelat,1),1));
plot3m(uslat,uslon,-1000.*ones(size(uslat,1),1));
maplegend = [ceil(1./stepsize(1)) extremum(1) minx(2)];
%meshm(zi,maplegend);colormap(pink);

%[lat,lon] = meshgrat(zi,maplegend);surfm(lat,lon,zi);%demcmap(zi);
meshm(zi,maplegend,size(zi),zi);demcmap(zi);
light('Position',[1 0 1]);
material([.5 .5 1]);lighting phong;
daspectm('meters',125);
for i=1:size(l,1),plot3m(l(i,1),l(i,2),100000,'r.','markersize',10);textm(l(i,1),l(i,2),10000,store(i,1),'color','b','fontsize',14);end;

%set(gca,'DataAspectRatio',[1 1 .5]);
%view(0,75);
%surfcm(lat,lon,zi);colormap(bone);
%demcmap(zi);

% Draw non-map landscape
% ----------------------

zi2=zi';

number_of_tickmarks = 7;
height              = 2000;
color               = 'k';

fig4 = figure(4);clf;hold on;surfl(zi2);colormap(pink);light('Position',[1 0 1]);material([.5 .5 1]);lighting phong;shading interp;view(30,30);
%fig4 = figure(4);clf;hold on;[c,h] = contour(zi2,5);colormap(round(pink));%clabel(c,h);
f = (l-ones(size(l,1),1)*minx)./(ones(size(l,1),1)*stepsize)+1;
figure(4);hold on;
for i=1:size(l,1),
  plot3(f(i,1),f(i,2),height,strcat(color,'.'),'markersize',10);
  text(f(i,1),f(i,2),height,store(i,1),'color',color,'fontsize',14);
  line([f(i,1) f(i,1)],[f(i,2) f(i,2)],[height 0],'color',color);
end;

points = size(zi2,1);
x1tick = round([minx(:,1):maxrange./number_of_tickmarks:extremum(:,1)]'.*10)./10;
x2tick = round([minx(:,2):maxrange./number_of_tickmarks:extremum(:,2)]'.*10)./10;
set(gca,'xtick',1:points./number_of_tickmarks:points);
set(gca,'xticklabel',num2str(x1tick));
set(gca,'ytick',1:points./number_of_tickmarks:points);
set(gca,'yticklabel',num2str(x2tick));

% Capture movie
% -------------

no_frames = 100;
M = moviein(no_frames);
figure(4);zoom out;a=1;b=60;view(a,b);drawnow;
for i=1:no_frames,
  a=a+5;figure(4);view(a,b);zoom(1+0.1*sin(i./6));
  drawnow;fprintf(' ');
  M(:,i) = getframe(fig4);
end;
figure(4);clf;movie(M,10);

% save to mpg format
% ------------------

filename = 'i:\consulting\common\projects\mapping\documents\brodbeck_map';
mpgwrite(M,pink,strcat(filename,'.mpg'));
eval(['save ',filename,'.mat',' M']);
%figure(4);[x,map] = frame2im(M(:,60));imshow(x,map);

plot3(statelat,statelon,0.*ones(size(statelat,1),1));
plot3(gtlakelat,gtlakelon,0.*ones(size(gtlakelat,1),1));
plot3(uslat,uslon,0.*ones(size(uslat,1),1));



% FUNCTION MAPPING DISTANCE TO REV
% ===============================================================

% Nearest store to each cust (only)
% ---------------------------------
% will be incorrect because we have custs whose closest store is store9

[yest,id,dist2closest] = k_nearest_neighbour(b(:,2:3),storelist,rand(size(b,1),1),1,4);
% id is the id of the closest centroid (store), therefore, this is
% literally the number down store which this cust is closest to
% dist2store = distance(b(:,[2:3]),storelist(id,1:2));
% actually, we might already have the distance as centdist
rev_closest=zeros(size(b,1),1);
for i=1:size(b,1),
  rev_closest(i,1) = b(i,id(i)+3);
end;

% Create function which is rev_from_that_store = f(dist_to_closest_store)
% just the closest store
% correlation(dist2closet,rev_closest)
% -0.2945 % -0.3451 
% correlation(dist2closest,log(rev_closest+2)
%         % -0.4869
% correlation(log(dist2closest),log(rev_closest))
% -0.5773 % -0.5720 
% correlation(propdist2closest,rev_closest)
%         % -0.4461
% correlation(propdist2closest,log(rev_closest+2))
%         % -0.6720 
% correlation(log(propdist2closest+1),log(rev_closest+2))
%         % -0.6703
 
% Use all stores to each cust as training examples
% ------------------------------------------------

propdist2store = [];
dist2store     = [];
% rev            = []; 
% calculated below
for i=1:size(storelist,1),  
   % dist = distance(b(:,[2:3]),ones(size(b,1),1)*storelist(i,1:2));
   dist           = latlong2dist(b(:,[2:3]),ones(size(b,1),1)*storelist(i,1:2));
   dist2store     = [dist2store;     dist];
   propdist2store = [propdist2store  dist];  
   % rev = [rev;b(:,i+3)]; 
   % calculated below
   fprintf('d ');
end;
propdist2store = propdist2store ./ (sum(propdist2store')' * ones(1,size(storelist,1)));
% this is now an array with the propdists

propdist2closest = zeros(size(b,1),1);
for i=1:size(b,1),
  propdist2closest(i,1) = propdist2store(i,id(i));
end;
% selectively pick out the closest in each

% collapse the array into a large dataset
propdist2store = propdist2store(:);
rev = b(:,4:3+size(storelist,1));
rev = rev(:);



% We now have, 
%   dist2store,   propdist2store,   rev
%   dist2closest, propdist2closest, rev_closest
 
 correlation(dist2store,rev)
   -0.2887
 correlation(dist2store,log(rev+2))
   -0.3920
 correlation(log(dist2store+1),log(rev+2))
   -0.7330
 correlation(propdist2store,rev)
   -0.4596
 correlation(propdist2store,log(rev+2))
   -0.6206
 correlation(log(propdist2store+1),log(rev+2))
   -0.6384
% corr -0.28,                     %  -0.3866 great circle
% log(dist,rev) -0.35             % 
% corr(log(dist),log(rev)) -0.47  % -0.7454 great circle (!)
% correlation(propdist2store,rev1)
% -0.4596
% correlation(log(propdist2store+1),log(rev1+1))
% -0.6395
% correlation(propdist2store,log(rev1+1))
% -0.6220

% deg=2;w=polyfitf(dist2store,rev,deg);yest=polyff(w,deg,dist2store);correlation(yest,rev),
% 0.3495
% deg=2;w=polyfitf(propdist2store,rev,deg);yest=polyff(w,deg,propdist2store);correlation(yest,rev),
% 0.6359
% deg=2;w=polyfitf(propdist2store,log(rev+2),deg);yest=polyff(w,deg,propdist2store);correlation(yest,log(rev+2)),
% 0.7911
% deg=2;w=polyfitf(dist2store,log(rev+2),deg);yest=polyff(w,deg,dist2store);correlation(yest,log(rev+2)),
% 0.4757
% deg=2;w=polyfitf(dist2closest,log(rev_closest+2),deg);yest=polyff(w,deg,dist2closest);correlation(yest,log(rev_closest+2)),
% 0.5941
% deg=2;w=polyfitf(propdist2closest,log(rev_closest+2),deg);yest=polyff(w,deg,propdist2closest);correlation(yest,log(rev_closest+2)),
% 0.6816

distmeasure = [...
'dist2store              '; ...
'dist2store              '; ...
'log(dist2store+C2)      '; ...
'propdist2store          '; ... 
'propdist2store          '; ...
'log(propdist2store+C2)  '; ...
'dist2closest            '; ...
'dist2closest            '; ...
'log(dist2closest+C2)    '; ...
'propdist2closest        '; ...
'propdist2closest        '; ...
'log(propdist2closest+C2)'];
revmeasure = [...
'rev                '; ...
'log(rev+C1)        '; ...
'log(rev+C1)        '; ...
'rev                '; ...
'log(rev+C1)        '; ...
'log(rev+C1)        '; ...
'rev_closest        '; ...
'log(rev_closest+C1)'; ...
'log(rev_closest+C2)'; ...
'rev_closest        '; ...
'log(rev_closest+C1)'; ...
'log(rev_closest+C2)'];

C1=2;C2=2;
for i=1:size(revmeasure,1),
  eval(['distmeasure1=',distmeasure(i,:),';']);
  eval(['revmeasure1=',revmeasure(i,:),';']);

  % first order relationship
  rankcorr(i,1) = rank_correlation(distmeasure1,revmeasure1,3);
  corr(i,1)     = correlation(distmeasure1,revmeasure1);

  % second order relationship
  deg=2;w=polyfitf(distmeasure1,revmeasure1,deg);yest=polyff(w,deg,distmeasure1);
  rankcorr2(i,1) = rank_correlation(yest,revmeasure1,3);
  corr2(i,1)     = correlation(yest,revmeasure1);
  
  % spline function
  %[c,w,yest] = spline_train([distmeasure1 distmeasure1],revmeasure1,5, ...
  %                                   -1, -1, ... 
  %                                   1, 4, -1);
  %rankcorr3(i,1) = rank_correlation(yest,revmeasure1);
  %corr3(i,1)     = correlation(yest,revmeasure1);

  fprintf('%d/%d ',i,size(revmeasure,1));
end;


% propdist2store seems to be better for inducing function
% 

% Display function
% ----------------

deg=2;offset=2;points=200;
w=polyfitf(log(dist2store+offset),log(rev+offset),deg);
range = [0:0.01:5];
figure(1);clf;
plot(range,exp(polyff(w,deg,log(range'+offset)))-2,'-');
r=find(dist2store>min(range) & dist2store<max(range)); % find them in the range
[a,rr]=sort(rand(size(r,1),1));
r=r(rr);
hold on;plot(dist2store(r(1:points),1),rev(r(1:points),1),'r.');
xlabel('miles from store');
ylabel('revenue per 33 weeek period');

% Predict true value by scaling up by share (dist2store==0 share=1)
% ------------------------------------------------------------------

yest = exp(polyff(w,deg,log(dist2store+offset)))-offset;
share = yest ./ (exp(polyff(w,deg,log(0+offset)))-offset);
trueval = revy1./share;

% rank correlation
[a,i] = sort(trueval);[a,rank_trueval] = sort(i);[a,i]=sort(revy1);[a,rank_revy1] = sort(i);
correlation(trueval,revy1),
correlation(rank_trueval,rank_revy1),
correlation(log(trueval+2),log(revy1+2)),

% 0.03, 0.87, 0.774
% 
% compare to: 0.93, 0.77, 0.81 corr, logcorr, rankcorr for revy1 to revy2


% how good are the people we predict as highest
[a,i] = sort(-1.*trueval);
mean(revy2(i(1:300))),
% 1,700 
% problem is the scale. The top truevals are in the millions.
% (obviously, a customer far out who is loyal to dicks, will have
% goodrev ./ number close to 0, which will give a huge predicted
% value. Instead, we will rescale by predicting decile rank, 



% Get average rev as you move out
% -------------------------------

stid=6;
[yest,id,dist2store] = k_nearest_neighbour(b(:,2:3),storelist,rand(size(b,1),1),1,4);
rev=zeros(size(b,1),1);for i=1:size(b,1),rev(i,1) = b(i,id(i)+3);end;
ii=find(id~=2 & id~=4 & id~=5);
dist2store=dist2store(ii,:);
rev=rev(ii,:);
% Requires dist2store, rev
%

inc=0.002;radial_points = [inc:inc:0.15]';
z      = zeros(size(radial_points,1),1);
stderr = z;
stddev = z;
emplow = z;
empupp = z;
sumrev = z;
count  = z;
for i=1:size(radial_points,1),
   % find all within this dist from store1
      ii = find(propdist2store<radial_points(i,1) & propdist2store>=radial_points(i,1)-inc);
      if ~isempty(ii),
        sumrev(i,1) = sum(rev(ii));
        count(i,1) = size(ii,1);
        r=rev(ii);
        stderr(i,1)=std(r)./sqrt(size(r,1));
        stddev(i,1)=std(r);
        [emplow(i,1),empupp(i,1)]=errorbars(r,0.80);
      end;
end;
figure(1);clf;hold on;
plot(radial_points,sumrev./count);
plot(radial_points,(sumrev./count)-stderr.*1.96,'r-');
plot(radial_points,(sumrev./count)+stderr.*1.96,'r-');
%plot(radial_points,(sumrev./count)-stddev,'r-');
%plot(radial_points,(sumrev./count)+stddev,'r-');
plot(radial_points,emplow(i,1),'r-');
plot(radial_points,empupp(i,1),'r-');
title('revenue versus distance to store');
xlabel('distance to store');
ylabel('avg revenue');
%legend('rev','stddev','stddev');
legend('rev','lower95','upper95');

% only go up to 1 (so r is at 1 mile around store)
[a,x]=hist(r,50);figure(1);clf;bar(x,a);xlabel('revenue');ylabel('number of customers');
title('distribution of revenue at radius of 1 mile around store');














% ========================================================================
% NOTES
%
%
%
%
%
%
%



% Graph dist2store all stores
inc=0.2;radial_points = [inc:inc:20]';
z      = zeros(size(radial_points,1),1);
stderr = z;
stddev = z;
emplow = z;
empupp = z;
sumrev = z;
count  = z;
for i=1:size(radial_points,1),
   % find all within this dist from store1
   r=[];
   for st=1:7,
      d=latlong2dist(b(:,[2 3]),ones(size(b,1),1)*storelist(st,:));
      ii = find(d<radial_points(i,1) & d>=radial_points(i,1)-inc);
      % ii = find(distance(b(:,[2 3]),ones(size(b,1),1)*storelist(st,:))<radial_points(i,1));
      % & distance>radial_points(i,1)-inc
      if ~isempty(ii),
        sumrev(i,1) = sumrev(i,1)+sum(b(ii,st+3));
        count(i,1) = count(i,1)+size(ii,1);
        r=[r;b(ii,st+3)];
      end;
   end;
   if size(r,1)>0,
     stderr(i,1)=std(r)./sqrt(size(r,1));
     stddev(i,1)=std(r);
     [emplow(i,1),empupp(i,1)]=errorbars(r,0.80);
   end;
   fprintf('%d/%d ',i,size(radial_points,1));
end;

figure(1);clf;hold on;
plot(radial_points,sumrev./count);
plot(radial_points,(sumrev./count)-stderr.*1.96,'r-');
plot(radial_points,(sumrev./count)+stderr.*1.96,'r-');
%plot(radial_points,(sumrev./count)-stddev,'r-');
%plot(radial_points,(sumrev./count)+stddev,'r-');
plot(radial_points,emplow(i,1),'r-');
plot(radial_points,empupp(i,1),'r-');

title('revenue versus distance to store');
xlabel('distance to store');
ylabel('avg revenue');
%legend('rev','stddev','stddev');
legend('rev','lower95','upper95');

%
% END NOTES
% ====================================================