function dist = latlong2dist(x1,x2,method,units);

% dist = latlong2dist(pos1,pos2,method,units);
% 
% method == 1 == Great Circle method
% units  == 'mi' / 'km'
% pos1   == (latitude,longitude) in degrees
% pos2   == (latitude,longitude) in degrees
%
% default is Great Circle, mi

% Parameters
% ----------

if nargin<2,
  fprintf('latlong2kilometers must take in pos1, pos2\n');
  fprintf('pos1 is a two-dim lat,long coord, pos2 is the same\n');
  return
end;
if nargin<3,
  method=1;
  units='mi';
end;
if nargin<4,
  units='mi';
end;
if units~='mi' & units~='km',
  units = 'mi';
end;
if method~=1 & method~=2,
  method=1;
end;

if 0,
fprintf('\nlatlong2dist\n');
if method==1,
  fprintf(' method: Great circle distance\n');
end;
fprintf(' units:  %s\n',units);
fprintf('---------------------------\n\n');
end;

% Radius of the Earth
% -------------------

if units=='km', r = 6378; end;
if units=='mi', r = 3963; end;


% Convert to radians
% ------------------

x1 = x1./(180/pi);
x2 = x2./(180/pi);


% Great Circle method
% --------------------

c = sin(x1(:,1)).*sin(x2(:,1)) + ...
    cos(x1(:,1)).*cos(x2(:,1)).*(cos(x2(:,2)-x1(:,2)));
a=acos(c);
dist=a.*r;

return
