function load_brodbeck_itemhierarchy;

load bcatitem.txt
load bdescriptitem.txt
load bdeptitem.txt

bcatcat = string_load('bcatcat.txt');
bdescriptdescript = string_load('bdescriptdescript.txt');
bdeptdept = string_load('bdeptdept.txt');

itemdescript = lookup_description(item(:,1),bdescriptitem,bdescriptdescript);
itemcategory = lookup_description(item(:,1),bcatitem,bcatcat);
itemdept = lookup_description(item(:,1),bdeptitem,bdeptdept);

% Check that the original database brodbeckitemhierarchy
% and the new itemdescript, itemcategory, itemdept all equal each other:

r=3090:3095;[num2str(item(r,1)),char(itemdescript(r,:)),char(itemcategory(r,:)),char(itemdept(r,:))],

% Now lookup those itemcodes in the hierarchy
select * from brodbeckitemhierarchy where itemcode='one of the above';
% get the category which itemcode is assigned under. 
% Now look up the record with that category as the itemcode - this
% tells you the details about the higher level (category level)
select * from brodbeckitemhierarchy where itemcode='cat in prev query';
select * from brodbeckitemhierarchy where itemcode='cat in prev query';
% Do the itemdescript, categorydescript, departmentdescript match 

% Note, don't query brodbeckitemdepartment or category, because
% these are derived tables and could have errors in them. If the
% records don't match up above, then you can track it down as a 
% matlab error or sql error by looking at brodbeckitemdepartment
% to see if that matches the atomic hierarchy details

[group,itemgroup,groupcount] = group_by(itemcategory,item(:,2;size(item,2)),'sum');
[group1,pricegroup,groupcount] = group_by(itemcategory,filled_price,'mean');

% Display series and price over same range (normalized to zscores)
% By Category
pause on;for tr=1:size(itemgroup,1),figure(1);clf;plot(1:size(itemgroup,2),data2zscore(full(itemgroup(tr,:))')','b-');hold on;plot(1:size(itemgroup,2),data2zscore(full(pricegroup(tr,:))')','r-');title([num2str(tr) char(group(tr,:))]);figure(2);clf;plot(itemgroup(tr,:));title([num2str(tr) char(group(tr,:))]);pause;end;

