
% Logistic function is: 
% 
% p = 1./(1+exp(-b1-b2.*w))
% 

% My fit to the logistic function, params are b(1)=4, b(2)=-10
figure(1);r=[0:0.01:1];plot(r,(1+exp(-4)./exp(-10.*r)).^-1,'.');

% Matlab's fit to the logistic function
yest=glmval([4 -10]',r','logit');figure(1);plot(r',yest,'.');

% Differencing one y from the next - gives me an approximation of what the derivative of the logistic looks like
% Note that I'm differencing at one 0.01 increment, so the finite differences derivative here will be 
% multiplied by 0.01.
figure(3);plot(r(1:length(r)-1),diff(yest),'.');

% My derivation of the derivativfe
figure(2);plot(r,-1.*(1+exp(-4)./exp(-10.*r)).^(-2).*(exp(-4).*-1.*(exp(-10.*r)).^(-2).*-10.*exp(-10.*r)));

% To get an absolutely perfect fit with the finite differences curve, 
% multiply by 0.01. There is also a 0.01 offset to the right caused by the differencing




% Plot a logistic and a profit curve
qty=1;figure(1);clf;price=[1:0.1:10];cost=0.8;b(1)=-5;b(2)=1;prob = 1./(1+exp(b(1)+b(2).*price));plot(price,prob,'-');prof=qty.*(price-cost).*prob;hold on;plot(price,prof,':');

% derivative of the profit curve with respect to price
figure(2);clf;popt=[0:0.1:100];equality = (1./exp(b(1)+b(2).*popt) + 1) - b(2).*(popt-cost);equality=equality.^2;figure(2);clf;plot(popt,equality,'-');grid on;

equality = (popt - 1./(b(2).*exp(b(1)+b(2).*popt))) - (cost + 1./b(2));equality=equality.^2;


% derivative is therefore 
(popt - 1./(b(2).*exp(b(1)+b(2).*popt))) + (cost + 1./b(2))