function popt = optimum_price(price,qty,prices,qties,diff_prices,transacts, changelist,cost,savefreq); %
%
% popt = optimum_price(price2,qty,prices,qties,diff_prices, transacts, changelist,cost,savefreq);
%
% Given current price p, qty q, cost cost, this calculates the optimum price for each
% item. This needs lastprice, lastqty, and bestprice, bestqty as a starting point,
% and then proceeds to hillclimb on the price vector. Hopefully a number of iterations
% can be run, even though there are 13000 items, and around 5 pricepoints per item
% (this equals 5^13000 = 
% 
% To run need:
% bestprice, bestqty, lastprice, lastqty, avgprice, avgqty
% price2
%

if 0, % change this to 0 if loading

% Find lastprice
% --------------

lastprice = zeros(size(price,1),1);
lastqty   = zeros(size(price,1),1);
for i=1:size(changelist,1), 
   lastprice(changelist(i),1) = prices(changelist(i),diff_prices(changelist(i),1));
   lastqty(changelist(i),1)   = qties(changelist(i),diff_prices(changelist(i),1));
end;
cost = zeros(size(price,1),1);
% we now have lastprice, lastqty and cost

% Find avg price (mode price)
% ---------------------------

avgprice = zeros(size(price,1),1);
avgqty   = zeros(size(price,1),1);
[a,pos] = max(transacts(changelist,1)'); % transacts is hopefully for each pricepoint
for i=1:size(changelist,1),
  avgprice(changelist(i),1) = prices(i,pos);
  avgqty(changelist(i),1) = qties(i,pos);
end;

%avgprice = prices(:,i);
%for i=1:size(changelist,1), 
  % i2 = find(price(i,:)>0);
  % avgprice(changelist(i),1) = mean(price(i,i2)');
  % avgqty(changelist(i),1)   = mean(qty(i,i2)');
%end;

% Load ms
% -------

% we need, Qtyi = mpricei + c + mpricej + c + ...
% 

% Find best price
% ----------------

rev = (prices-0.9.*prices) .* qties;
%rev = prices .* qties;
[a,bestpricepos] = max(rev');
 
bestprice  = zeros(size(price,1),1);
bestqty    = zeros(size(price,1),1);
%beststderr = zeros(size(price,1),1);
for i=1:size(prices,1),
   bestprice(i,1)  = prices(i,bestpricepos(i));
   bestqty(i,1)    = qties(i,bestpricepos(i));
%   beststderr(i,1) = stderr(i,bestpricepos(i));
end

% Save these numbers
% -------------------

save lastprice.mat lastprice lastqty cost bestprice bestqty avgprice avgqty; % bestpricestderr;

r=[1:10]';
lastprice = lastprice(    r,:);
lastqty   = lastqty(      r,:);
cost      = cost(         r,:);
bestprice = bestprice(    r,:);
bestqty   = bestqty(      r,:);
price2    = price(        r,:);
qty       = qty(          r,:);
prices    = prices(       r,:);
qties     = qties(        r,:);
diff_prices = diff_prices(r,:);
avgprice  = avgprice(     r,:);
avgqty    = avgqty(       r,:);

% also need to save m
% for now we can calc m.

save price_state_small.mat lastprice lastqty cost bestprice bestqty price2 qty prices qties diff_prices changelist;
return

else
   load lastprice.mat;
end;



% OPTIMIZATION
% ------------

% Try every possible combination of prices. There are
% 63701 different price points. 13009 items, with 
% start with the last known value of the price,qty
% or we could start with the bestprice, bestqty as a starting point
% try both

p    = bestprice(changelist,1);
q    = bestqty(changelist,1);
cost = cost(changelist,1);
prof = eval_price(p,q,cost);
pricesn = prices(changelist,:);
qtiesn  = qties(changelist,:);

profcur = eval_price(lastprice(changelist,1),lastqty(changelist,1),cost);
profinit = prof;
figure(1);clf;hold on;

count = 1;

while (1),
   
   lastprof = prof;
   
  % find a random id between 1 and diff_prices
  %idnew   = round(rand(number_of_items,1) .* (diff_prices-1)).*sign(diff_prices);
  
  idnew   = 1+round( rand(size(changelist,1),1) .* (diff_prices(changelist,1)-1) );
  % disp('for loop');
  for i=1:size(changelist,1),
     pnew(i,1)    = pricesn(i,idnew(i,1));
     qnew(i,1)    = qtiesn(i,idnew(i,1));
  end;
  %pnew = pricesn(idnew');
  %qnew = qtiesn(idnew');
  %disp('out');
  profnew = eval_price(pnew,qnew,cost);
  if profnew>prof,
     % keep new point
     disp('new point');
     p    = pnew;
     q    = qnew;
     prof = profnew;   
  else
     % revert
  end;

  % plot the profit improvement
  plot([count-1 count],[lastprof prof],'-');hold on;
  plot(count,profcur,'.','markersize',1);
  plot(count,profinit,'.','markersize',1);
  drawnow;
  
  if rem(count,savefreq)==0,
     keyboard;
  end;
  count=count+1;
  
  disp([num2str(count)]);
end;
