function r=string_less_than(st1,st2,operation);
% r=string_less_than(st1,st2,operation);
%
% operation=='lt' for less than
% operation=='le' for less than equal to
% 
% This function is used by lookup_description, and needs to be kept
% with that function
% 

% Method:
% [1 2 3 2 1] st2
% [1 0 4 5 1] st1
% 1 1 0 0 1
%
% [1 2 3 2 1] st2
% [1 3 4 5 1] st1
%  1 0 0 0 1
%
% if tie, go on
% if notie, then decide then and there
% ====================================================

% Parameters
% ----------

if nargin<2, 
   fprintf('string_less_than: two arguments are needed\n');
   help string_less_than
end;
if nargin==2, 
   operation='lt';
end;
if size(st1,2)~=size(st2,2),
   fprintf('st1 and st2 have different sizes\n');
   return
end;

d=st1==st2;
% find out where st1 and st2 are equal

i = min(find(d==0));
% find the first non-equal

if strmatch(operation,'le'),
   if isempty(i) | ... % st1 is exactly equal to st2
      st1(1,i)<=st2(1,i),
      r=1;
   else
      r=0;
   end;
else
   % operation is 'lt'
  if isempty(i), % st1 is equal to st2, in this case st1 is not less than st2
     r=0;
     return
  end;
  if st1(1,i)<st2(1,i),
    r=1;
  else
    r=0;
  end;
end;

return
