function st=string_load(filename,sparsemode);

if nargin<2, sparsemode=0; end;

fid=fopen(filename,'r');
disp(['loading ' filename]);
a=fscanf(fid,'%c');
fclose(fid);

disp('splitting out into character array');

% remove all white spaces appearing immediately before carrage returns
% remove all tabs
i=find(double(a)~=10);
a=a(i);

if sparsemode,
  whitespace=find(a==32);
  a(whitespace)=zeros(size(whitespace));
  clear whitespace;
end;

% find carrage returns
i = find(double(a)==13);
totaldown = size(i,2)+1;
i = [0 i];              % the first position is now included
i = [i size(a,2)];      % the last position is now included
%a = sparse(a);

if sparsemode==0,
  st=32.*ones(totaldown,23); 
  % need a better solution here, look at i
  % and determine the max difference
else
  st = sparse([]);
end;

for down=1:totaldown,
   st1 = deblank(deblank( char(a(1,i(1,down)+1:i(1,down+1)-1))')');
   st(down,1:size(st1,2)) = st1;
   if rem(down,1000)==0,
      fprintf('%d/%d ',down,totaldown);
   end;
end;
fprintf('\n');

if sparsemode, fprintf('Please note that the char matrix is sparse and non-printable. To make printable, replace all 0s with 32s\n');end;