function wegmans_analysis;

% correlations and substitutions
% ------------------------------

num=120;
% problem with correlation is that matlab can't handle the size in memory
% therefore do the following
r=rand(size(qty,1),1);[a,i] = sort(r);
corr = corrmat2(qty(i(1:10000),:),qty(i(1:10000),:)); % same as corrcoef(qty,qty);
corrlist = find_sig_corrmat_els(corr-tril(corr),120,support,10);
generate_graph_format(corrlist,char(cat),1,'tomsawyercomplex');

% cooccurrence and lift affinities
% ---------------------------------

[cooc,support,lift,no_occurrences] = cooccurrence(qty,qty);
liftlist = find_sig_corrmat_els(lift-tril(lift),120,support,10);
generate_graph_format(liftlist,char(cat),1,'tomsawyercomplex');

% Affinity Contribution
% ---------------------

[a,b,qty_contrib,baseline_prob] = contribution_cooc(cooc,qty,ones(1,size(qty,2)),zeros(1,size(qty,2)),10);

% highest contribution items (and removal impact, and advertising impact)

% lowest contribution items (best removal candidates)

% Items which bring in large number of items, in relation to their baseline prob
rat = baseline_prob./(qty_contrib+eps);
[zrat,zmean,zstd] = data2zscore(full(rat)');
ii=find(rat~=0);% remove zeros
[a,i] = sort(zrat(ii,1)); % the items with lowest basline probs compared to contributions
% appear at the bottom of the list
r=1:10;

% Items which bring in poor contribution, in relation to their baseline prob
i=flipud(i);
[full(zrat(ii(i(r)))) full(baseline_prob(ii(i(r))))' full(qty_contrib(ii(i(r))))' zscore2data(full(zrat(ii(i(r)))),zmean,zstd) full(baseline_prob(ii(i(r))))'./full(qty_contrib(ii(i(r))))'],
char(cat(ii(i(r)),:)),


[zrat,zmean,zstd] = data2zscore(rat);

r=1600:1630;[a,i] = sort(zrat);i=flipud(i);zrat(i(r)),char(cat(i(r),:)),



% Basket timeseries
% -----------------
[a,b] = find(lift>300 & support>20);size(a), % find a pair to use

% if there aren't too many, list them and select one
for i=1:size(a,1),fprintf('%s\t%s\n',char(cat(a(i),:)),char(cat(b(i),:)));end;
i=4;

t=1000;qa=change_resolution(full(qty(:,a(i)))',t,0);qb=change_resolution(full(qty(:,b(i)))',t,0);
% figure(1);clf;plot(1:size(qa,2),qa,'r-');hold on;plot(1:size(qb,2),qb);legend(char(cat(a(i),:)),char(cat(b(i),:)),0);
figure(1);clf;plot(1:size(qa,2),data2zscore(qa')','r-');hold on;plot(1:size(qb,2),data2zscore(qb')');legend(char(cat(a(i),:)),char(cat(b(i),:)),0);
% zscore version
title(strcat('transaction timeseries Lift=',num2str(full(lift(a(i),b(i)))),',p(a->b)=',num2str(full(cooc(a(i),b(i)))),',Corr=',num2str(correlation(qa',qb'))));
xlabel(strcat('ordered transaction (1 unit equals sum of ',num2str(t),' transactions)'));
% ylabel('quantity sold');
ylabel('qty sold zscore'); 
% title(strcat('transaction timeseries (1 unit equals sum of 500 transactions)',char(cat(a(4),:)),' and ',char(cat(b(4),:))));


% Cliques
% -------

dd=support>150;[a,b]=find(dd>0);

% Save dimacs format
fid=fopen('cooc.d','w');
fprintf(fid,'p edge %d %d\n',size(cooc,2),size(a,1));
fprintf(fid,'e %d\t%d\n',a',b');
fclose(fid);

% Save pard format
fid=fopen('cooc.p','w');
fprintf(fid,'string string\n%d %d\nc graph test\n',size(cooc,2),size(a,1));
fprintf(fid,'%d\t%d\n',a',b');
fclose(fid);

% Run dimacs
asc2bin cooc.d cooc.b
dfmax cooc.b
dmclique cooc.b

% Run pard
pard

% Customer return visit distribution (period)
% -------------------------------------------

% determine number of days for each customer (days1..no.custs)
% takes 15 minutes for 4500 custs
days=zeros(size(custvals,1),1);
for i=1:size(custvals,1),
   entry=find(custid==custvals(i,1));
   days(i,1)=size(unique(transactionid(entry,1:3),'rows'),1);
   if rem(i,50)==0,fprintf('%d/%d ',i,size(custvals,1));end;
end;

% show the result
for ii=1:100,
   bin(ii,1)=size(find(days==ii),1);
end;figure(1);
bar(1:40,bin(1:40));title('Customer return visit period');ylabel('number of customers');xlabel('visits per 60 days');


% Are Daily correlation and Basket correlation are similar?
% ---------------------------------------------------------

% Join the basketcategory with the timeseries level categorylevel
load brodbeck_basketcategory
load brodbeck_categorylevel
% note that itemvals (from basketcategory) is the category for 375 basket categories
% group (categorylevel) is the category for 340 timeseries categories

appended = lookup_description(char(full(itemvals)),char(full(group)),itemgroup);
% appended is a 375 down matrix with the timeseries values, for each basketcategory
% in itemvals

% appended (375 down, 411 days across) corresponds to qty' (375 down, baskets 60,000 across)

ii=find(appended(:,1)==-9);
% find all itemvals which were able to take a timeseries value

% zero out these timeseries
appended(ii,:) = zeros(size(ii,1),size(appended,2));

% zero out the baskets corresponding to these items
qty(:,ii) = zeros(size(qty,1),size(ii,1));


corr_timeseries=corrmat2(appended',appended');
size(corr_timeseries),

corr_basket = corrmat2(qty,qty);
size(corr_basket),

% note that we assume there are no real 0s in these correlations. We can check by
i=find(corr_basket==0);size(i),i=find(corr_timeseries==0);size(i),

% both are symmetric and we want to ignore the diagonal (ones)
corr_basket = corr_basket-tril(corr_basket);
corr_timeseries = corr_timeseries-tril(corr_timeseries);

% compare the two, and ignore all nans, 0s, and infs
n=find(~isnan(corr_basket) & ~isinf(corr_basket) & corr_basket~=0 & ...
   ~isnan(corr_timeseries) & ~isinf(corr_timeseries) & corr_timeseries~=0);
size(n),

size(corr_basket,2).^2./2,
% out of 70,313 possible cells (375*375/2)
% there were 57970 cells with a legal value
% ====================================================================================


% Distribution of the two correlations (basket and timeseries)
% ------------------------------------------------------------

buckets=100;[a,x]=hist(corr_basket(n),buckets);figure(1);clf;plot(x,a,'b-');hold on;[a,x]=hist(corr_timeseries(n),buckets);figure(1);plot(x,a,'r-');grid on;legend('basket','daily',0);title('Distribution of correlations');xlabel('correlation');ylabel('frequency');

% Meandiff, meanabsdiff, corr
% ---------------------------

mean_diff = mean(corr_basket(n)-corr_timeseries(n));
corr      = correlation(corr_basket(n),corr_timeseries(n));
mean_abs_diff = mean(abs(corr_basket(n)-corr_timeseries(n)));

% Spearman's correlation
% ----------------------

[a,i1]=sort(corr_basket(n));[a,r1]=sort(i1);[a,i2]=sort(corr_timeseries(n));[a,r2]=sort(i2);
correlation(r1,r2),

%ans =
% 0.3571
% correlation(corr_basket(n),corr_timeseries(n))
% 0.4122
%N=57970

% Correlation over different correlation regions

mx=max([corr_basket(n);corr_timeseries(n)]);mn=min([corr_basket(n);corr_timeseries(n)]);
mn=mean(corr_basket(n))-10.*std(corr_basket(n));mx=mean(corr_basket(n))+10.*std(corr_basket(n));
no_bins=8;corr_range=[];
halfwidth=(mx-mn)./no_bins./2; 
range1=mn:halfwidth.*2:mx;
for i=1:no_bins,ii=find(corr_basket(n)>=range1(i)-halfwidth & corr_basket(n)<range1(i)+halfwidth);
   if ~isempty(ii),
      corr_range(i,1)=correlation(corr_basket(n(ii)),corr_timeseries(n(ii)));
   else 
      corr_range(i,1)=nan;
   end;
end;
figure(1);clf;h=bar(range1(1:no_bins),corr_range(1:no_bins),'b-');
set(h,'facecolor','none');shading faceted;
xlabel('basket correlation');ylabel('correlation with timeseries');
title('Correlation between the two affinities in different regions of the distribution');grid on;

hold on;
buckets=100;[a,x]=hist(corr_basket(n),buckets);figure(1);plot(x,a./sum(a),'r-');
[a,x]=hist(corr_timeseries(n),buckets);figure(1);plot(x,a./sum(a),'r--');
legend('basket','daily',0);
