function wout = dirac_nearest(w);
% 
% wout = dirac_nearest(w);
%
% Flags the highest weight in a vector.
% Returns a vector with w(a)=0 for all a, except the weight which was highest, b, which 
% will have a weight equal to 1.
% 
% EXAMPLE
%
% w = rand(100,1);
% wout = dirac_nearest(w); 
% stairs(1:length(w),wout);
% 
% yest = blend_prototypes(w,y,'dirac_nearest'); 
% % Will perform a "nearest neighbour" operation, returning yest as the single case 
% % which had the highest weight
% % The w vector is searched for the max. The max is set to 1, and all others are set to 0
% % y is then the weighted average of these 0s, and a 1 on the case which had the highest weight
% 
% SEE ALSO
% 
% blend_prototypes

 
[a,i] = max(w);
wout = zeros(size(w));
wout(i) = 1;
