function perm = permutate(num);
% 
% perm = permutate(num);
%
% Generates all permutations of integers between 1 and num
% 
% Algorithm by http://www.delphiforfun.org/Programs/Permutes_1.htm
% Implemented in Matlab by Brendan Kitts on Dec 28, 2003 in order to 
% perform an all-word-permutations edit distance analysis between collocations
%


perm = nan.*ones(factorial(num),num);
perm(1,:) = [1:num];
row = 1;
while 1,
  row=row+1;
  perm(row,:) = perm(row-1,:); % initialize to the row previous
  finished_row = 0;
  for pos=num:-1:1,
    % Count backwards until we find a starting point
    increment_pos = perm(row,pos);
    while increment_pos<=num,
      increment_pos = increment_pos + 1; % try one higher
      if increment_pos <= num & isempty(find(perm(row,1:pos-1)==increment_pos)), 
        % We can use it!
        perm(row,pos) = increment_pos;
        % Now begin to move left to right, starting with the lowest un-used integer
        for newpos = pos+1:num,
          unused = setdiff([1:num],[perm(row,1:newpos-1)]);
          perm(row,newpos) = min(unused);
        end;
        finished_row = 1;
        break;
      end; % if
    end; % while
    if finished_row, break; end;
  end; % foreach pos, searching from the right, looking for a starting number that we can increment
  if row>=size(perm,1), break;end;
end;

