function [str2,removed_nonasc] = tokenize(str,delim,remove_nonascii);
% 
% [str2,removed_nonasc] = tokenize(str,delim,remove_nonascii);
% 
% str is a delimited string. Returns a character array {}
% If there were collocations in str, they are returned as separate elements of str2, ie. 
% remove_nonascii == 1 if you want it to remove characters such as '[' and '"', leaving only text.
% Default is to leave the string alone.
% 
% EXAMPLE
% 
% s = tokenize('hello there ploddy',' ');
% s is {'hello','there','ploddy'}
% 

if nargin<3,
  remove_nonascii=1;
end;

  removed_nonasc=0;

  str2 = {};
  therest = str;
  while ~isempty(therest),
    [s,therest] = strtok(therest,delim);
    if remove_nonascii,
      sorig=s;
      s = strrep(s,'[','');
      s = strrep(s,']','');
      s = strrep(s,'"','');
      s = strrep(s,'-',''); % This is temporary!
      if strcmp(s,sorig)==0, removed_nonasc=1; end;
    end;
    str2{length(str2)+1} = s;
  end;
return;
