function [productionmat,dist,wordlengthmat,wordlistlength] = words_in_common_mat(phrases);

wordlistlength = zeros(length(phrases),1);
tic,
fprintf('breaking into wordlists\n');
for i=1:length(phrases),
  wordlist{i} = getwords(phrases{i});
  wordlistlength(i) = length(wordlist{i});
end;
toc,

tic,
fprintf('allocting matrix\n');
dist = zeros(length(phrases),length(phrases));
toc,

fprintf('computing every pair of words\n');
tic,
for i1=1:length(phrases),
  for i2=1:length(phrases),
    if i1<i2,
      common = ismember(wordlist{i1},wordlist{i2});
      num = sum(common);  
      dist(i1,i2) = num;
    end;
  end;
end;
toc,

fprintf('lower triangular and diagonal\n');
tic,
%keyboard;
  wordlengthmat = wordlistlength * ones(1,length(phrases));
  dist = dist + dist';
  dist = dist + eye(size(wordlengthmat)).*wordlengthmat;
  productionmat = dist ./ wordlengthmat;
  % productionmat interpretation: percentage of words in i1 that are common with i2
  % ie. the lower the percentage, the more distant is the child from the parent
  % at 0 the keyword is no longer a child
  % at 1, the keyword down is a parent of the keyword across 
  % Interpretation: i1 down distance from i2 across
  % scores of 1.0 indicate that productionmat(i1,i2), i1 is a parent of i2
  % scores < 1.0 indicate that productionmat(i1,i2), i1 is a child / production / elaboration of i2
  % scores of 0.0 indicate that the i1,i2 share no lineage  
  
  % We then to loop over each word, and look for parents of it. Compare its performance 
  % to its parents. If it is not appreciably better, or if its CPA is comparable, 
  % then it should be collapsed into its parent
  
  % (1) find and kill off keywords that cannot come good
  % (2) collapse unnecessary children into parents
  % 
toc,

