function [dstr,dnum] = Date_SQL2Matlab(sqldate);
% 
% [dstr,dnum] = Date_SQL2Matlab(sqldate);
%
% Translates a SQLServer generated date in numeric representation (eg. 38123) 
% into (a) the string version of that date, eg. 2004-10-10 2:00:02, and 
% (b) the Matlab datenum version of that date, eg. 1232
% The matlab date number can be put into datestr to reformat the string version 
% of the date however we want, eg. 
% 
% anotherstr = datestr(dnum,'yyyy-mm-dd');
% 
%

% Check whether datenum is translating the right date 
% datestr(datenum('10-10-2004'))


Datenum_at_Jan012004 = 730486;
SQLnum_at_Jan012004  = 36524;

offset = Datenum_at_Jan012004-SQLnum_at_Jan012004; % This should be the Matlab date number for 2000-01-01


dnum = sqldate+offset;
dstr = datestr(dnum,31); %'yyyy-mm-dd HH:MM:SS');

return;

