function corr = autocorr1way(series);
% example
% corr = autocorrelation(item);
% figure(1);bar(-1.*floor(size(corr,2)/2)+1:ceil(size(corr,2)/2),corr(5,:));
%

maxdate = size(series,2);
corr = zeros(size(series));
% center series around the mean
series = series - mean(series')';
testseries = zeros(size(series));

for s=maxdate-1:-1:0,
  testseries(:,s+1:maxdate) = series(:,1:maxdate-s);
  % no wrap
 
  % calculate correlation
  corr(:,s+1) =  ...
   ( sum((series(:,s+1:maxdate).*testseries(:,s+1:maxdate))') ./ ...
   sqrt( sum( (series(:,s+1:maxdate).*series(:,s+1:maxdate))' ) .* ...
         sum( (testseries(:,s+1:maxdate).*testseries(:,s+1:maxdate))' ) ) )';
   % keyboard   
 
end;

% wrap the entire corr matrix so that shift of 0 is at center, shift -1 
% is left, and +1 is right


if 0,
if maxdate>1, 
center = ceil(maxdate/2);
corr(:,1:center)          = fliplr(corr(:,1:center));
corr(:,center+1:maxdate)  = fliplr(corr(:,center+1:maxdate));
end;

  start = ceil(maxdate/2); % this is how much we want to wrap it. ceil ensures its >0
  corr(:,start+1:maxdate) = corr(:,1:maxdate-start);
  corr(:,1:start)         = corr(:,maxdate-start+1:maxdate);
end;
