function corr = autocorrelation(series);

% f = autocorrelation(series)

% f contains the autocorrelation at duration 1,2,...,size(series,2)

% this shows whether there is any repeating structure in the series at

% any of these periods 

%

% example

% corr = autocorrelation(item);

% figure(1);bar(-1.*floor(size(corr,2)/2)+1:ceil(size(corr,2)/2),corr(5,:));

%



maxdate = size(series,2);

corr = zeros(size(series));

% center series around the mean

series = series - mean(series')';



for start=0:maxdate,

  % wrap the series

  % first part becomes the last part 

  testseries(:,start+1:maxdate) = series(:,1:maxdate-start);

  if start>0,

  testseries(:,1:start)       = series(:,maxdate-start+1:maxdate);

  end;

  

  % calculate correlation

  if start>0,

    corr(:,start) = ( sum((series.*testseries)') ./ ...

                      sqrt( sum( (series.*series)' ) .* ...

                            sum( (testseries.*testseries)' ) ) )';

  end;

end;



% wrap the entire corr matrix so that shift of 0 is at center, shift -1 

% is left, and +1 is right





if maxdate>1, 

center = ceil(maxdate/2);

corr(:,1:center)          = fliplr(corr(:,1:center));

corr(:,center+1:maxdate)  = fliplr(corr(:,center+1:maxdate));

end;



if 0,

  start = ceil(maxdate/2); % this is how much we want to wrap it. ceil ensures its >0

  corr(:,start+1:maxdate) = corr(:,1:maxdate-start);

  corr(:,1:start)         = corr(:,maxdate-start+1:maxdate);

end;

