function [inputs,targets] = create_multiple_timeseries(series, train, days, delay, skipdays, targetdays, targetseries_id);
% [inputs,targets] = create_multiple_timeseries(series, train, days, delay, skipdays, targetdays, targetseries_id);
%
% train = size of training period (1..train will be used), days == days_in_model, delay == minlag, targetdays == number of days to predict 
% 
% [tr1,tg1]=create_multiple_timeseries( [1:40;31:70],35,10,4,2,5,1)
% [tr2,tg2]=create_multiple_timeseries2([1:40;31:70],35,10,4,2,5,1)
%
% 

end_of_patterns = 1+train-(days+delay+targetdays);
slidedown       = [1:skipdays:end_of_patterns];
start_across    = end_of_patterns; % toeplitz is square
targetrange     = start_across+days+delay:start_across+days+delay+targetdays-1;
% end of usable patterns in toeplitz
% rightmost extent of the toeplitz

inputs  = zeros(size(slidedown,2),days.*size(series,1));
targets = zeros(size(slidedown,2),targetdays.*size(targetseries_id,2));

sliding_ids = toeplitz([1:train]); % series(i,1:train));
% perform the toeplitz ONCE, to find out where the ids go. (create an id mask)
% Now for each series, we will apply this id mask to create the required series.
% This works because all series are the same size, and have the same windowing
% being applied to them.

input_ids  = sliding_ids(slidedown,start_across:start_across+days-1);
target_ids = sliding_ids(slidedown,targetrange);


ti = 0;
for i=1:size(series,1),
% these series line up horizontally. Going down we have the sliding
% components
% these series are supposed to be different timeseries for the same customer
% outside we would have a loop which constructs them one customer at a time, and adds
% to a large array

  s = series(i,:);
  
  inputs( [1:size(slidedown,2)],(i-1).*days+1:i.*days) = s(input_ids);
  
  % inputsmember(  1,(i-1).*days+1:i.*days) = i.*ones(1,days);
  
  % Add target series
  if ~isempty(targetseries_id),
    if ismember(i,targetseries_id),
       ti=ti+1;
       targets([1:size(slidedown,2)],(ti-1).*targetdays+1:ti.*targetdays) = s(target_ids);
          % targetsmember( 1,(ti-1).*targetdays+1:ti.*targetdays) = i.*ones(1,targetdays);
    end; % ismember(i,targetseris_id)
  end; % isempty(targetseries_id)
  
end; % i