function  [arp] = custom_ar(Y,days,delay);
%
% [arp] = custom_ar(Y,days,delay);
%
% performs a custom ar fit. This uses specific days
%
% example
% custom_ar([1 2 3 4 5 6 7 8],[1 3],0)
% fits a model using lags 1 and 3.
% note when it comes time to apply the model, the inputs are
% [lag1value lag3value]
%

  alldays_sliding = toeplitz(Y);
  maxday = max(days');
  
  endtraining     = size(Y,2) - maxday - delay;
  starttraining   = 1;
  
  inputs = alldays_sliding(starttraining:endtraining, ... 
                           size(Y,2)-days-delay);

  targets = alldays_sliding(starttraining:endtraining, ...
                            size(Y,2));

% keyboard
  arp = inputs \ targets;


if 0,
  days=abs(days); % all are lagged
  p = max(days);  % maximum lag
  disp(['delay of ' num2str(DELAY)]);
  ACF = acovf(Y,p+DELAY);

  ACF=ACF(:);

inputs = ACF(days);
targets = ACF(max(days)+1+DELAY);
  arp = toeplitz(inputs) \ targets;
end;

if 0,
  p=size(ACF,1)-1-DELAY; % NOTE -10 put in

	arp = toeplitz(ACF(1:p))\ACF(2+DELAY:p+1+DELAY);
        % should be 2:p+1
end;
return;
