function [fit,a] = diffar(series,                   ...
                          training_window,          ...
                          range,                    ...
                          days_in_model,            ...
                          delay_before_prediction,  ...
                          lag,          ...
                          standardize);
                       
                       
[start,d] = difference(series,lag);
% d1..n are positions series2..n
[f,a] = dispar(d,training_window,range,days_in_model,delay_before_prediction);
% f is the fit to d, size of f is same as size of d
%fit = [series(:,lag) (f+series(:,1:size(series,2)-lag) ) ];
% originally what I was doing. This doesn't make sense, though. It adds 
% lag of 1 (only!) to any delay_before_prediction

%fit = integrate(start,f,lag);

% fit(:,range) = series(:,range-delay_before_prediction-1)+f(:,range-1);
% this works

%fit(:,range) = zeros(1,size(range,2));
% fit(:,range-i-1) = [start(:,i) integrate(start(:,i)+f(:,range-i-1)+ fit(:,range-i-1)];

fit(:,range) = zeros(1,size(range,2));
diffrange = [range(1,1)+1:range(1,size(range,2))];
intrange = [range(1,1):range(1,size(range,2))-lag];
if lag>1,
  % work out what the first difference term is
  fit(:,diffrange) = integrate([start(:,2:size(start,2))],f(:,intrange),lag-1);
 % fit(:,range(1,1)) is 0  
 % fit(:,diffrange) = integrate(start(:,2:size(start,2)),f(:,intrange),lag-1);
 % integrates it back out to lag 1
else
   fit(:,diffrange) = f(:,diffrange);
end;
fit(:,range) = series(:,range-delay_before_prediction)+fit(:,range);
  
% this is if we were trying to predict every day into the future. Note however, 
% that we only predicted the difference (direction) in the timeseries, given 
% the series of previous directions. Now we can set the actual level to be the 
% true level in the past 7 days, and then apply that to integrate out the actual
% forecast.

%fit = [series(:,delay_before_prediction:size(series,2))+f];
% f is the forecasted change (up down) from pos delay times ago

%fit(:,range) = integrate([series(:,range(1,1)-1) start(:,2:size(start,2))],...
%                         f(:,[min(range)-1 range]),lag);

disp('now viewing integrated accuracy');

for i=1:size(series,1),
   
figure(2);clf;
plot(range,series(i,range),'r-');hold on;
plot(range,fit(i,range),'b-');

   corr = (fit(i,range) * series(i,range)') / (norm(fit(i,range))*norm(series(i,range)));
  
   s = series(i,range); % - mean(series(i,range)');
   f = fit(i,range); % - mean(fit(i,range)');

   z = find(s==0);
   s(z) = s(z)-1; % forces denominator to be -1
   f(z) = zeros(size(z)); % forces numerator to be 0, therefore we get
   % (-1-0)/-1 = 1. = 100%
   
   perr = 100 .* mean( abs((f-s)./s)' );
   disp(['corr '  num2str(corr) ' perr ' num2str(perr) ]);
pause
end;