function f = dispfourier(series);
%
% f = dispfourier(series);
%
% displays structure in the series in graphs. Shows fourier
% and autocorrelation of the given series
%

series=full(series);
figure(gcf);clf;

corrleft = -1.*ceil(size(series,2)/2);
corrright = ceil(size(series,2)/2) - 1;

for i=1:size(series,1),

  % find first nonzero
  for f = 1:size(series,2),
    if series(i,f)>0,
      break;
    end;
  end;

  if f>=size(series,2), 
    disp('no non-zero parts');
    %continue; 
  end;

  s = series(i,f+1:size(series,2));
  
  figure(gcf);
  clf;
  subplot(3,1,1); % time domain series
  plot(1:size(s,2),s,'r-');
  title([ 'time series ' num2str(i) ]);
  % xlabel('day');
  drawnow;
 
  subplot(3,1,2); % fourier domain series
  dd = fft(s);
  bar( 2:floor(size(dd,2)/2), abs(dd(1,2:floor(size(dd,2)/2)) ));
  % title('spectra');
  % xlabel('period in days');
  % we could leave it here, but here's an attempt to express the x axis
  % as days (instead of frequency, day = size2 / freq = how many times 
  % that frequency oscillates in the series

if 0,
  % let there be 10 tick marks maximum
  total_tickmarks = 10;
  spacebetweenticks = size(series,2) / total_tickmarks;
  set(gca,'XTickMode','manual');
  set(gca,'XTick',[1:spacebetweenticks:size(series,2)]);
  
  labels = mat2str( ( size(series,2) .* ones(1,total_tickmarks)) ./ ...
                      [1:spacebetweenticks:size(series,2)] );

  labels = strrep(labels,' ',',');
  set(get(gca),'XTickLabels',labels);
  drawnow;

keyboard
end;

  subplot(3,1,3); % autocorrelation
  corr = autocorr1way(s);
  bar(1:floor(size(s,2)/2),corr(1,1:floor(size(s,2)/2)));
  % title('autocorrelation');
  % xlabel('displacement in days');
  drawnow;

  pause;

end;
