function [corr,perr,tot] = display_accuracy(fit,series,show);
% [corr,perr] = display_accuracy(f,s);
% f and s are horizontal series
%

   % percentage error (or gross error) 
   % ---------------------------------
   if series==zeros(size(series)) | ... 
      fit   ==zeros(size(fit)),
      %disp('one of the series is all zero');
      corr=0;perr=0;tot=0;
      return   
   end;
   
   s = series;
   f = fit;
  
   z = find(s==0);
   s(z) = s(z)-1; % forces denominator to be -1 
   f(z) = zeros(size(z)); % forces numerator to be 0, therefore we get
   % (-1-0)/-1 = 1. = 100%
   
   z = find(f<0); % these are forecasts less than 0
   f(z) = zeros(size(z));
   
   % correlation
   % -----------
                                
   series = series- ( mean(series')' * ones(1,size(series,2)));
   fit = fit- ( mean(fit')' * ones(1,size(series,2)));
   corr = (fit * series') / (norm(fit)*norm(series));
   
   perr = 100 .* mean( abs((f-s)./s)' );
   
   tot = 100 .* sum(abs(f-s)') ./ sum(abs(s)');
   
   if nargin==3,
      if show==1,
        disp(['corr '  num2str(corr) ' perr ' num2str(perr) ]);
     end;
   end;
