function [corrm,perrm,totm,       ...
          corrm2,perrm2,totm2,    ...
          corrm3,perrm3,totm3] =  ...
          movingavg_days(series,initrange,total_days,delay);
%
% function [corrm,perrm,totm,      ...
%           corrm2,perrm2,totm2,
%           corrm3,perrm3,totm3] = ...
%           movingavg_days(series,initrange,window,weeks,delay);
%
% tests different varieties of moving average
% window is the window size for a continuous moving average, eg. 
% a 7 day or 10 day continuous moving average
% weeks is the number of weeks used in a biweekly moving average, eg
% select the forecast day last week and the week before
%

STDFILTER = 5;

if 0,
% to detrend:
x = [ [1:190]' ones(190,1)];
y = wwi(46,301:400)';
a = x\y;
figure(1);clf;
plot(301:490,wwi(46,301:490),'r-');hold on;
plot(301:490,x*a,'y-')
% this gives the intercept point for each entry in the timeseries.
% simply
% series - x*a detrends the series. After fitting moving average, retrend
% by
% series + x*a
%
end;

% detrend the series,
% drop outliers,
% fit movingavg curve,
% retrend each movingavg curve

% find first zero
%training_range = initrange(1,1)-1;
%series' * a = 

disp('calculating dependent');
dep = create_dependent(series,delay);
% creates 7 day sums. This is the correct actual level 

WEEKS = 12;
for ii=2:total_days,
   ii,
   
m1 = movingavg(filter_outliers(series,STDFILTER),ii*3,delay);
% 7 day moving average, no filtering           was window

if ii<WEEKS,
  m2 = movingavgweek2(filter_outliers(series,STDFILTER),ii,delay);
  % use forecast day last week and week before

  m3 = movingavgweek3(filter_outliers(series,STDFILTER),ii,delay);
  % use yesterday and week before                     was weeks
end;

%m2 = movingavgweek(series,weeks,delay);
%m2 = filter_outliers(m2,STDFILTER);
%tests filtering on the moving average (forecasts), not the actuals

m11 = create_dependent(m1,delay); % sums up that average
% this also shifts the moving average backwards in time.
m11 = [zeros(size(m1,1),delay) m11(:,1:size(m11,2)-delay) ];

if ii<WEEKS,
  m22 = create_dependent(m2,delay); % sums up that average
  % this also shifts the moving average backwards in time.
  m22 = [zeros(size(m2,1),delay) m22(:,1:size(m2,2)-delay) ];

  m33 = create_dependent(m3,delay); % sums up that average
  % this also shifts the moving average backwards in time.
  m33 = [zeros(size(m3,1),delay) m33(:,1:size(m3,2)-delay) ];
end;

  for iii=1:size(series,1),
    [corrm(iii,ii),perrm(iii,ii),totm(iii,ii)] = display_accuracy(m11(iii,:),dep(iii,:),0);
    if ii<WEEKS,
    [corrm2(iii,ii),perrm2(iii,ii),totm2(iii,ii)] = display_accuracy(m22(iii,:),dep(iii,:),0);
    [corrm3(iii,ii),perrm3(iii,ii),totm3(iii,ii)] = display_accuracy(m33(iii,:),dep(iii,:),0);
    end;   
 end;

end;

return
disp('displaying');

for i=1:size(series,1),
  figure(1);clf;
  plot(initrange,dep(i,initrange),'r-');hold on;
  plot(initrange,m11(i,initrange),'g-');
  plot(initrange,m22(i,initrange));
  drawnow;
  
  [corrm(i,:),perrm(i,:),totm(i,:)] = display_accuracy(m11(i,initrange),dep(i,initrange),0);
  [corrm2(i,:),perrm2(i,:),totm2(i,:)] = display_accuracy(m22(i,initrange),dep(i,initrange),0);
  %pause
end;

