function m = movingavg_inclusive(series,windowsize,delay);
% function m = movingavg_inclusive(series,windowsize,delay);
%
% given a series, [1 2 3 4 5 6 7], 
% converts into a moving average
% and does not use any delay. Therefore,
%
% movingavg_nodelay([1 2 3 4 5 6 7 8 9 10],7)
% [1 1.5 2 3 3.5 4 5 6 7]
%
% The idea is that the first windowsize elements also go into the
% preliminary moving average, but we assume that that moving average
% is unreliable (had fewer elements go into it).


m = zeros(size(series));
for i=delay+windowsize:size(series,2),
  m(:,i) = mean( series(:,i-delay-windowsize+1:i-delay)' )';
end;
for i=delay+1:min([windowsize-1 size(series,2)]),
   if i==1,
      m(:,1) = series(:,1);
   else
      m(:,i) = mean(series(:,1:i)')';
   end;
end;




