function m = movingavgweek(series,weeks,delay);
% function m = movingavgweek(series,weeks,delay);
%
% today is 14. Uses 8 and 1 to predict 15, (or 15+1week = 22)
% ie. uses forecast day 1 week ago, and tomorrow 2 weeks ago, 
% to predict forecast day week hence
%
% i-delay-1 is current day (i-delay-2 we have accessable)
% i-delay-1:i is not accessable
% i is prediction day. (tomorrow 1 week hence)
% count back in 7s from i, ie. i-7 i-14, etc. those which fall
% in our accessable range we use

% i is the prediction day
for i=delay+(weeks.*7)+1:size(series,2),
   % calc last accessable day which is a forecast day (on the same
   % day of week as the forecast day)
   % need to step back in 7s. Round delay up to the nearest 
   % multiple of 7. eg. delay 11 becomes 14 etc.
   
   delay_weeks = floor(delay./7)+1; % rounds up. min of 1 week
   range = i-delay_weeks.*7 - (weeks-1).*7 :7:i-delay_weeks.*7; 
   m(:,i) = mean( series(:,range)' )';
%keyboard   
end;
m(:,1:delay+weeks.*7) = zeros(size(series,1),delay+weeks.*7);
