function multispectralar(series, ...
                         training_window, ... 
                         testrange, ... 
                         days, ...
                         delay, ... 
                         bands);
% multispectralar(series, ...
%                        training_window, ... 
%                        testrange, ... 
%                        days, ...
%                        delay, ... 
%                        bands);

if testrange(1,size(testrange,2))+delay+days+1 > size(series,2),
   testrange = testrange(1,1):size(series,2)-(delay+days+1);
end;

training_window = testrange(1,size(testrange,2))-testrange(1,1)+1;
trainingrange = testrange(1,1)-training_window : testrange(1,1)-1;
trainingseries = series(:,trainingrange);

if trainingrange(1,1)<1, 
  disp('training range < 1, returning');
  return;
end;

for i=1:size(series,1),
  
  if series(i,trainingrange) == zeros(1,size(trainingrange,2)),
    disp('no entries in training range');
  else

  for band=1:bands,
    size_of_bandregion = ceil(size(trainingseries,2)/2) / bands,
    keeprange = (band-1) * size_of_bandregion : band * size_of_bandregion-1;
    nyquist1 = ceil(size(trainingseries,2)/2),
   
    freqseries11 = fft(trainingseries(i,:));
    freqseries1 = zeros(size(freqseries1));
    if nyquist1 + keeprange(1,size(keeprange,2)) > size(series,2), 
      keeprange = keeprange(1,1) : size(series,2);
      disp('range corrected');
    end;

    freqseries1(1,nyquist1-keeprange) = freqseries11(1,nyquist1-keeprange);
    freqseries1(1,nyquist1+keeprange) = freqseries11(1,nyquist1+keeprange);

   series1 = real(ifft(freqseries1));
   
   % fit this band of frequencies
   disp(['band ' num2str(band)]);
   [fitt,a(band,:),corr(band,:),perr(band,:)] = fitar(series1,days,delay);

    % weights for each band should be calculated from a holdout set
    % instead we'll use the training error as the weight. Yes, this is
    % a poor practice, but it'll save some time. See if stacking gets
    % us anywhere.
  
  end;
  
corr,

  sumcorr = sum(corr);
  sumperr = sum(perr);  
  
   % now we have to move through the series and apply the ah and
   % al. alternative. trainingwindow real. then we have fitl on
   % the real dat.
   
   % for the testseries, we have to split testdata to period 
   % into low and highpass
   
   
   % initialize first value
   fit(i,testrange+delay+days+1) = zeros(1,size(testrange+delay+days+1,2));
   fit(i,testrange(1,1):testrange(1,1)+delay+days) = ...
   series(i,testrange(1,1):testrange(1,1)+delay+days);

   for p=testrange+delay+days+1,
      %  keyboard
      
      freqseriess = fft(series(i,p-training_window-delay:p-delay-1)); 
      % we can split the entire series up to p
      nyquist = ceil(size(freqseriess,2)/2);
      
      for band=1:bands,
        size_of_bandregion = ceil(size(trainingseries,2)/2) / bands;
        keeprange = (band-1) * size_of_bandregion : band * size_of_bandregion-1;
   
        freqseries = zeros(size(freqseries));
        if nyquist1 + keeprange(1,size(keeprange,2)) > size(series,2), 
          keeprange =  keeprange(1,1) : size(series,2);
          disp('range corrected (test set)');
        end;

    freqseries(1,nyquist-keeprange) = freqseriess(1,nyquist-keeprange);
    freqseries(1,nyquist+keeprange) = freqseriess(1,nyquist+keeprange);
 
      seriesl = real(ifft(freqseries));

      lvect = flipud(seriesl(1, size(seriesl,2)-days+1: ...
                                size(seriesl,2))');
                          
%      fit(i,p) = fit(i,p) + (band.*corr(band,:)./sumcorr) .* ...
 %                           (a(band,:) * lvect);
      fit(i,p) = fit(i,p) + (a(band,:) * lvect);
      
     end; % next band

   end; 

   disp('combined fit');
   figure(2);clf;
   disprange = testrange(1,1)+delay+days: ... 
               testrange(1,size(testrange,2))+delay+days;

   plot(disprange,series(i,disprange),'r-');hold on;
   plot(disprange,fit(i,disprange));

   display_accuracy(fit(i,disprange),series(i,disprange));
   pause

end; % no entries in trainingrange
end;
