function [corrm,perrm,totm,       ...
          corrm2,perrm2,totm2] =  ...
          testmovingavg(series,initrange,window,weeks,delay);
%
% function [corrm,perrm,totm,      ...
%           corrm2,perrm2,totm2] = ...
%           testmovingavg(series,initrange,window,weeks,delay);
%
% tests different varieties of moving average
% window is the window size for a continuous moving average, eg. 
% a 7 day or 10 day continuous moving average
% weeks is the number of weeks used in a biweekly moving average, eg
% select the forecast day last week and the week before
%

STDFILTER = 5;

disp('calculating dependent');
dep = create_dependent(series,delay);
% creates 7 day sums. This is the correct actual level 

disp(['calculating ' num2str(window) ' day moving avg']);
m1 = movingavg(filter_outliers(series,STDFILTER),window,delay);
% 7 day moving average, no filtering

disp(['calculating ' num2str(weeks) '-weekly moving avg']); 
%m2 = movingavgweek(filter_outliers(series,STDFILTER),weeks,delay);
% use forecast day last week and week before

m2 = movingavgweek3(filter_outliers(series,STDFILTER),weeks,delay);
% use yesterday and week before 
%end;

%m2 = movingavgweek(series,weeks,delay);
%m2 = filter_outliers(m2,STDFILTER);
%tests filtering on the moving average (forecasts), not the actuals

m11 = create_dependent(m1,delay); % sums up that average
% this also shifts the moving average backwards in time.
m11 = [zeros(size(m1,1),delay) m11(:,1:size(m1,2)-delay) ];

m22 = create_dependent(m2,delay); % sums up that average
% this also shifts the moving average backwards in time.
m22 = [zeros(size(m2,1),delay) m22(:,1:size(m2,2)-delay) ];

disp('displaying');

for i=1:size(series,1),
  figure(1);clf;
  plot(initrange,dep(i,initrange),'r-');hold on;
  plot(initrange,m11(i,initrange),'g-');
  plot(initrange,m22(i,initrange));
  drawnow;
  
  [corrm(i,:),perrm(i,:),totm(i,:)] = display_accuracy(m11(i,initrange),dep(i,initrange),0);
  [corrm2(i,:),perrm2(i,:),totm2(i,:)] = display_accuracy(m22(i,initrange),dep(i,initrange),0);

  pause
end;

