function separation = time_separation(time1,time2,timemin,timemax);
% 
% d = time_separation(time1,time2,timemin,timemax);
% 
% Times are strange things - they restart after a particular number called timemax
% The difference between two times such as 23:00 and 1:00am is 2 hours - the alternative 
% would have been 21 hours. This function looks for the closest separation between the two times
% This can be especially useful when creating a similarity kernel over a set of data - 
% thus, datapoints closer together in time are regarded as more similar. The closeness in time 
% is given by this separation number (in hours or whatever)
%
% time1 and time2 are both column vectors

times = sort([time1 time2]')'; 

% times is now lowertime, uppertime

separation(:,1) = times(:,2)-times(:,1);

separation(:,2) = (timemax-times(:,2)) + (times(:,1)-timemin);

separation = min(separation')'; % take the smaller of each number


return;

