
function y = time_similarity_kernel(timeofdayproto,timeofday,timemin,timemax,varargin);
% 
% d=time_similarity(timeofdayproto,timeofday,timemin,timemax,varargin);
%
% EXAMPLE 
% 
% beta = [5;-10];timeofday=[0:24]';figure(1);clf;plot(timeofday,time_similarity_kernel(20,timeofday,0,24,beta));grid on;axis([0 24 0 1]);
% % Change the -10 to -20 etc, and it narrows the kernel
%  
% Creates a similarity kernel over different dates, such that it returns 
% 1.0 if the two times are identical, and 0.0 if the two times are maximally distant 
% from each other (for instance midnight and midday)
% 
% We may want to divide the returned y by the sum of possible ys, in other words, turn this into 
% a probability distribution such that the integral of the function is 1.
% 

maxseparation = (timemax-timemin)./2; 

d = time_separation(timeofdayproto * ones(size(timeofday)),timeofday,timemin,timemax);
d = d ./ maxseparation;

x = varargin{1};

if x(1)==0 & x(2)==0, 
  % dirac kernel
  y = (d==0); % y is 1 when the time separation is 0, and 0 otherwise
  return;
end;

y = 1./(1+exp(-x(1) - x(2).* d));

% d is always 0..1. Can we find a scalar such that 

% yprob = 

return;


% Potential kernels
% ------------------
% 
% plot([0:0.01:1]',cos([0:0.01:1].*pi));
% Logistic function x(2) governs how quickly the kernel falls
% x(1)=5;x(2)=-10;figure(1);clf;plot([0:0.01:1]',1./(1+exp(-x(1) - x(2).* [0:0.01:1])));axis([0 1 0 1]);
